from Tkinter             import *
from ATOM3Type           import *
from Operator            import *
from LeafType             import *
from TypeName            import *
from ASG_TypesMetaModel import *
from PostActionsXPreActionsXText_or_BitmapXButtonXEntity import *

class ButtonConfig (PostActionsXPreActionsXText_or_BitmapXButtonXEntity):
  def createTypeGraph(self, atom3i, rootNode):

    self.obj37=TypeName(atom3i)

    self.obj37.Name.setValue('ButtonConfig')
    self.obj37.graphClass_= graph_TypeName
    from graph_TypeName import *
    new_obj = graph_TypeName(270.0,161.0,self.obj37)
    self.obj37.graphObject_ = new_obj
    rootNode.addNode(self.obj37)

    self.obj38=LeafType(atom3i)

    self.obj38.TypeConstraint.setValue(('typeConst', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE OBJECT'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n\n'))
    self.obj38.Type.setValue(('Entity', 'String', None, ('Key', 0), ('Direct Editing', 1)))
    self.obj38.Type.initialValue=ATOM3String('')
    self.obj38.graphClass_= graph_LeafType
    from graph_LeafType import *
    new_obj = graph_LeafType(42.0,336.0,self.obj38)
    self.obj38.graphObject_ = new_obj
    rootNode.addNode(self.obj38)

    self.obj39=LeafType(atom3i)

    self.obj39.TypeConstraint.setValue(('typeConst', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE OBJECT'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n\n'))
    self.obj39.Type.setValue(('Button', 'Enum', None, ('Key', 0), ('Direct Editing', 1)))
    self.obj39.Type.initialValue=ATOM3Enum(['Text', 'Bitmap', 'None'],0,1)
    self.obj39.Type.initialValue.configItems.setActionFlags([ 1, 1, 1, 0])
    lcobj1 =[]
    cobj1=ATOM3String('Text')
    lcobj1.append(cobj1)
    cobj1=ATOM3String('Bitmap')
    lcobj1.append(cobj1)
    cobj1=ATOM3String('None')
    lcobj1.append(cobj1)
    self.obj39.Type.initialValue.configItems.setValue(lcobj1)
    self.obj39.graphClass_= graph_LeafType
    from graph_LeafType import *
    new_obj = graph_LeafType(128.0,395.0,self.obj39)
    self.obj39.graphObject_ = new_obj
    rootNode.addNode(self.obj39)

    self.obj40=LeafType(atom3i)

    self.obj40.TypeConstraint.setValue(('typeConst', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE OBJECT'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n\n'))
    self.obj40.Type.setValue(('Text_or_Bitmap', 'String', None, ('Key', 0), ('Direct Editing', 1)))
    self.obj40.Type.initialValue=ATOM3String('')
    self.obj40.graphClass_= graph_LeafType
    from graph_LeafType import *
    new_obj = graph_LeafType(264.0,409.0,self.obj40)
    self.obj40.graphObject_ = new_obj
    rootNode.addNode(self.obj40)

    self.obj41=LeafType(atom3i)

    self.obj41.TypeConstraint.setValue(('typeConst', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE OBJECT'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n\n'))
    self.obj41.Type.setValue(('PreActions', 'Constraint', None, ('Key', 0), ('Direct Editing', 0)))
    self.obj41.Type.initialValue=ATOM3Constraint()
    self.obj41.Type.initialValue.setValue(('PreActions', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE OBJECT'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
    self.obj41.graphClass_= graph_LeafType
    from graph_LeafType import *
    new_obj = graph_LeafType(407.0,405.0,self.obj41)
    self.obj41.graphObject_ = new_obj
    rootNode.addNode(self.obj41)

    self.obj42=LeafType(atom3i)

    self.obj42.TypeConstraint.setValue(('typeConst', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE OBJECT'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n\n'))
    self.obj42.Type.setValue(('PostActions', 'Constraint', None, ('Key', 0), ('Direct Editing', 0)))
    self.obj42.Type.initialValue=ATOM3Constraint()
    self.obj42.Type.initialValue.setValue(('PostActions', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE OBJECT'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
    self.obj42.graphClass_= graph_LeafType
    from graph_LeafType import *
    new_obj = graph_LeafType(543.0,393.0,self.obj42)
    self.obj42.graphObject_ = new_obj
    rootNode.addNode(self.obj42)

    self.obj43=Operator(atom3i)

    self.obj43.type.setValue( (['X', 'U', '->'], 0) )
    self.obj43.type.config = 0
    self.obj43.graphClass_= graph_Operator
    from graph_Operator import *
    new_obj = graph_Operator(303.0,273.0,self.obj43)
    self.obj43.graphObject_ = new_obj
    rootNode.addNode(self.obj43)
    self.obj37.out_connections_.append(self.obj43)
    self.obj43.in_connections_.append(self.obj37)
    self.obj43.out_connections_.append(self.obj42)
    self.obj42.in_connections_.append(self.obj43)
    self.obj43.out_connections_.append(self.obj41)
    self.obj41.in_connections_.append(self.obj43)
    self.obj43.out_connections_.append(self.obj40)
    self.obj40.in_connections_.append(self.obj43)
    self.obj43.out_connections_.append(self.obj39)
    self.obj39.in_connections_.append(self.obj43)
    self.obj43.out_connections_.append(self.obj38)
    self.obj38.in_connections_.append(self.obj43)

