# __Function.py_____________________________________________________
from ASGNode import *

from ATOM3Type import *

from ATOM3String import *
from ATOM3Enum import *
from ATOM3Integer import *
from ATOM3List import *
from Point import *
from graph_Function import *
class Function(ASGNode, ATOM3Type):

   def __init__(self, parent = None):
      ASGNode.__init__(self)
      ATOM3Type.__init__(self)
      self.graphClass_ = graph_Function
      self.parent = parent
      self.Function_Number=ATOM3String('1')
      self.keyword_= self.Function_Number
      self.Input=ATOM3String('')
      self.Mode=ATOM3Enum(['Continuous', 'Discrete'], 0, 0)
      self.Number_Of_Points=ATOM3Integer(0)
      self.Points=ATOM3List([ 1, 1, 1, 0],Point)
      lcobj0=[]
      self.Points.setValue(lcobj0)
      self.generatedAttributes = {'Function_Number': ('ATOM3String', ),
                                  'Input': ('ATOM3String', ),
                                  'Mode': ('ATOM3Enum', ),
                                  'Number_Of_Points': ('ATOM3Integer', ),
                                  'Points': ('ATOM3List', 'Point')      }
      self.realOrder = ['Function_Number','Input','Mode','Number_Of_Points','Points']
   def clone(self):
      cloneObject = Function( self.parent )
      for atr in self.realOrder:
         cloneObject.setAttrValue(atr, self.getAttrValue(atr).clone() )
      cloneObject.keyword_ = cloneObject.Function_Number
      ASGNode.cloneActions(self, cloneObject)

      return cloneObject
   def copy(self, other):
      ATOM3Type.copy(self, other)
      for atr in self.realOrder:
         self.setAttrValue(atr, other.getAttrValue(atr) )
      self.keyword_ = self.Function_Number
      ASGNode.copy(self, other)

   def preCondition (self, actionID, * params):
      if self.graphObject_:
         return self.graphObject_.preCondition(actionID, params)
      else: return None
   def postCondition (self, actionID, * params):
      if self.graphObject_:
         return self.graphObject_.postCondition(actionID, params)
      else: return None


