# _ genFunctions.py ____________________________________________________________________________
# File generated automatically by ATOM3. Graph Grammar Rule
# ___________________________________________________________________________________________
from GGrule import *
from Function import *
from ASG_GPSSMetaModel import *
from SNAVariable import *
from Table import *
from connected_to import *
from Storage_Size import *
from GPSSBlock import *
class genFunctions (GGrule):

   def __init__(self, parent):
      GGrule.__init__(self, 1)
      self.LHS = ASG_GPSSMetaModel(parent)

      self.obj130=Function(parent)

      self.obj130.Input.setValue('')
      self.obj130.Points.setActionFlags([ 1, 1, 1, 0])
      lcobj1 =[]
      self.obj130.Points.setValue(lcobj1)
      self.obj130.Points.setNone()
      self.obj130.Mode.setNone()
      self.obj130.Mode.config = 0
      self.obj130.Number_Of_Points.setNone()
      self.obj130.Function_Number.setValue('')
      self.obj130.GGLabel.setValue(1)
      self.obj130.graphClass_= graph_Function
      if parent.genGraphics:
         from graph_Function import *
         new_obj = graph_Function(130.0,308.0,self.obj130)
      else: new_obj = None
      self.obj130.graphObject_ = new_obj
      self.LHS.addNode(self.obj130)
      self.RHS = ASG_GPSSMetaModel(parent)

      self.obj132=Function(parent)

      self.obj132.Input.setValue('')
      self.obj132.Points.setActionFlags([ 1, 1, 1, 0])
      lcobj1 =[]
      self.obj132.Points.setValue(lcobj1)
      self.obj132.Mode.setValue( (['Continuous', 'Discrete'], 0) )
      self.obj132.Mode.config = 0
      self.obj132.Number_Of_Points.setValue(0)
      self.obj132.Function_Number.setValue('10')
      self.obj132.GGLabel.setValue(1)
      self.obj132.graphClass_= graph_Function
      if parent.genGraphics:
         from graph_Function import *
         new_obj = graph_Function(132.0,275.0,self.obj132)
      else: new_obj = None
      self.obj132.graphObject_ = new_obj
      self.obj1320= AttrCalc()
      self.obj1320.Copy=ATOM3Boolean()
      self.obj1320.Copy.setValue(('Copy from LHS', 1))
      self.obj1320.Copy.config = 0
      self.obj1320.Specify=ATOM3Constraint()
      self.obj1320.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj132.GGset2Any['Input']= self.obj1320
      self.obj1321= AttrCalc()
      self.obj1321.Copy=ATOM3Boolean()
      self.obj1321.Copy.setValue(('Copy from LHS', 1))
      self.obj1321.Copy.config = 0
      self.obj1321.Specify=ATOM3Constraint()
      self.obj1321.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj132.GGset2Any['Function_Number']= self.obj1321
      self.obj1322= AttrCalc()
      self.obj1322.Copy=ATOM3Boolean()
      self.obj1322.Copy.setValue(('Copy from LHS', 1))
      self.obj1322.Copy.config = 0
      self.obj1322.Specify=ATOM3Constraint()
      self.obj1322.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj132.GGset2Any['Points']= self.obj1322
      self.obj1323= AttrCalc()
      self.obj1323.Copy=ATOM3Boolean()
      self.obj1323.Copy.setValue(('Copy from LHS', 1))
      self.obj1323.Copy.config = 0
      self.obj1323.Specify=ATOM3Constraint()
      self.obj1323.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj132.GGset2Any['Mode']= self.obj1323
      self.obj1324= AttrCalc()
      self.obj1324.Copy=ATOM3Boolean()
      self.obj1324.Copy.setValue(('Copy from LHS', 1))
      self.obj1324.Copy.config = 0
      self.obj1324.Specify=ATOM3Constraint()
      self.obj1324.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj132.GGset2Any['Number_Of_Points']= self.obj1324
      self.RHS.addNode(self.obj132)
   def condition(self, graphID, isograph, atom3i):
      node = self.getMatched(graphID, self.LHS.nodeWithLabel(1))
      return node.visited == 0
      
      
      

   def action(self, graphID, isograph, atom3i):
      import string
      node = self.getMatched(graphID, self.LHS.nodeWithLabel(1))
      node.visited = 1
      self.graphRewritingSystem.fileGen.write(" ")
      self.graphRewritingSystem.fileGen.write(string.ljust(node.Function_Number.toString(),5))
      self.graphRewritingSystem.fileGen.write(" ")
      self.graphRewritingSystem.fileGen.write(string.ljust("FUNCTION",11))
      self.graphRewritingSystem.fileGen.write(node.Input.toString())
      self.graphRewritingSystem.fileGen.write(","+node.Mode.toString()[0])
      self.graphRewritingSystem.fileGen.write(node.Number_Of_Points.toString())
      self.graphRewritingSystem.fileGen.write(string.whitespace[1])
      # now generate the points
      lpoints=node.Points.getValue()
      counter = 0
      for point in lpoints:
         if counter >0:
            if counter < 6:
               self.graphRewritingSystem.fileGen.write("/")      
            else:
               self.graphRewritingSystem.fileGen.write(string.whitespace[1])
               counter = 0      
         self.graphRewritingSystem.fileGen.write(point.x.toString()+","+ point.y.toString())
         counter = counter + 1
      self.graphRewritingSystem.fileGen.write(string.whitespace[1]+"*"+string.whitespace[1])
      
      
      
      
      
      
      

