# _ goDeep.py ____________________________________________________________________________
# File generated automatically by ATOM3. Graph Grammar Rule
# ___________________________________________________________________________________________
from GGrule import *
from Function import *
from ASG_GPSSMetaModel import *
from SNAVariable import *
from Table import *
from connected_to import *
from Storage_Size import *
from GPSSBlock import *
class goDeep (GGrule):

   def __init__(self, parent):
      GGrule.__init__(self, 3)
      self.LHS = ASG_GPSSMetaModel(parent)

      self.obj87=GPSSBlock(parent)

      self.obj87.A.setValue('')
      self.obj87.C.setValue('')
      self.obj87.B.setValue('')
      self.obj87.E.setValue('')
      self.obj87.D.setValue('')
      self.obj87.F.setValue('')
      self.obj87.X.setValue('')
      self.obj87.Type.setNone()
      self.obj87.Type.config = 0
      self.obj87.Comments.setValue('')
      self.obj87.Label.setValue('')
      self.obj87.GGLabel.setValue(1)
      self.obj87.graphClass_= graph_GPSSBlock
      if parent.genGraphics:
         from graph_GPSSBlock import *
         new_obj = graph_GPSSBlock(119.0,138.0,self.obj87)
      else: new_obj = None
      self.obj87.graphObject_ = new_obj
      self.LHS.addNode(self.obj87)

      self.obj88=GPSSBlock(parent)

      self.obj88.A.setValue('')
      self.obj88.C.setValue('')
      self.obj88.B.setValue('')
      self.obj88.E.setValue('')
      self.obj88.D.setValue('')
      self.obj88.F.setValue('')
      self.obj88.X.setValue('')
      self.obj88.Type.setNone()
      self.obj88.Type.config = 0
      self.obj88.Comments.setValue('')
      self.obj88.Label.setValue('')
      self.obj88.GGLabel.setValue(3)
      self.obj88.graphClass_= graph_GPSSBlock
      if parent.genGraphics:
         from graph_GPSSBlock import *
         new_obj = graph_GPSSBlock(122.0,371.0,self.obj88)
      else: new_obj = None
      self.obj88.graphObject_ = new_obj
      self.LHS.addNode(self.obj88)

      self.obj89=connected_to(parent)

      self.obj89.GGLabel.setValue(2)
      self.obj89.graphClass_= graph_connected_to
      if parent.genGraphics:
         from graph_connected_to import *
         new_obj = graph_connected_to(133.0,269.0,self.obj89)
      else: new_obj = None
      self.obj89.graphObject_ = new_obj
      self.LHS.addNode(self.obj89)
      self.obj87.out_connections_.append(self.obj89)
      self.obj89.in_connections_.append(self.obj87)
      self.obj89.out_connections_.append(self.obj88)
      self.obj88.in_connections_.append(self.obj89)
      self.RHS = ASG_GPSSMetaModel(parent)

      self.obj91=GPSSBlock(parent)

      self.obj91.A.setValue('')
      self.obj91.C.setValue('')
      self.obj91.B.setValue('')
      self.obj91.E.setValue('')
      self.obj91.D.setValue('')
      self.obj91.F.setValue('')
      self.obj91.X.setValue('')
      self.obj91.Type.setValue( (['Advance', 'Assign', 'Depart', 'Enter', 'Gate', 'Generate', 'Leave', 'Link', 'Logic', 'Mark', 'Priority', 'Queue', 'Release', 'SaveValue', 'Seize', 'Tabulate', 'Terminate', 'Test', 'Transfer', 'Unlink'], 0) )
      self.obj91.Type.config = 0
      self.obj91.Comments.setValue('')
      self.obj91.Label.setValue('L0')
      self.obj91.GGLabel.setValue(1)
      self.obj91.graphClass_= graph_GPSSBlock
      if parent.genGraphics:
         from graph_GPSSBlock import *
         new_obj = graph_GPSSBlock(95.0,103.0,self.obj91)
      else: new_obj = None
      self.obj91.graphObject_ = new_obj
      self.obj910= AttrCalc()
      self.obj910.Copy=ATOM3Boolean()
      self.obj910.Copy.setValue(('Copy from LHS', 1))
      self.obj910.Copy.config = 0
      self.obj910.Specify=ATOM3Constraint()
      self.obj910.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj91.GGset2Any['A']= self.obj910
      self.obj911= AttrCalc()
      self.obj911.Copy=ATOM3Boolean()
      self.obj911.Copy.setValue(('Copy from LHS', 1))
      self.obj911.Copy.config = 0
      self.obj911.Specify=ATOM3Constraint()
      self.obj911.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj91.GGset2Any['C']= self.obj911
      self.obj912= AttrCalc()
      self.obj912.Copy=ATOM3Boolean()
      self.obj912.Copy.setValue(('Copy from LHS', 1))
      self.obj912.Copy.config = 0
      self.obj912.Specify=ATOM3Constraint()
      self.obj912.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj91.GGset2Any['B']= self.obj912
      self.obj913= AttrCalc()
      self.obj913.Copy=ATOM3Boolean()
      self.obj913.Copy.setValue(('Copy from LHS', 1))
      self.obj913.Copy.config = 0
      self.obj913.Specify=ATOM3Constraint()
      self.obj913.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj91.GGset2Any['E']= self.obj913
      self.obj914= AttrCalc()
      self.obj914.Copy=ATOM3Boolean()
      self.obj914.Copy.setValue(('Copy from LHS', 1))
      self.obj914.Copy.config = 0
      self.obj914.Specify=ATOM3Constraint()
      self.obj914.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj91.GGset2Any['D']= self.obj914
      self.obj915= AttrCalc()
      self.obj915.Copy=ATOM3Boolean()
      self.obj915.Copy.setValue(('Copy from LHS', 1))
      self.obj915.Copy.config = 0
      self.obj915.Specify=ATOM3Constraint()
      self.obj915.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj91.GGset2Any['F']= self.obj915
      self.obj916= AttrCalc()
      self.obj916.Copy=ATOM3Boolean()
      self.obj916.Copy.setValue(('Copy from LHS', 1))
      self.obj916.Copy.config = 0
      self.obj916.Specify=ATOM3Constraint()
      self.obj916.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj91.GGset2Any['X']= self.obj916
      self.obj917= AttrCalc()
      self.obj917.Copy=ATOM3Boolean()
      self.obj917.Copy.setValue(('Copy from LHS', 1))
      self.obj917.Copy.config = 0
      self.obj917.Specify=ATOM3Constraint()
      self.obj917.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj91.GGset2Any['Type']= self.obj917
      self.obj918= AttrCalc()
      self.obj918.Copy=ATOM3Boolean()
      self.obj918.Copy.setValue(('Copy from LHS', 1))
      self.obj918.Copy.config = 0
      self.obj918.Specify=ATOM3Constraint()
      self.obj918.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj91.GGset2Any['Comments']= self.obj918
      self.obj919= AttrCalc()
      self.obj919.Copy=ATOM3Boolean()
      self.obj919.Copy.setValue(('Copy from LHS', 1))
      self.obj919.Copy.config = 0
      self.obj919.Specify=ATOM3Constraint()
      self.obj919.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj91.GGset2Any['Label']= self.obj919
      self.RHS.addNode(self.obj91)

      self.obj92=GPSSBlock(parent)

      self.obj92.A.setValue('')
      self.obj92.C.setValue('')
      self.obj92.B.setValue('')
      self.obj92.E.setValue('')
      self.obj92.D.setValue('')
      self.obj92.F.setValue('')
      self.obj92.X.setValue('')
      self.obj92.Type.setValue( (['Advance', 'Assign', 'Depart', 'Enter', 'Gate', 'Generate', 'Leave', 'Link', 'Logic', 'Mark', 'Priority', 'Queue', 'Release', 'SaveValue', 'Seize', 'Tabulate', 'Terminate', 'Test', 'Transfer', 'Unlink'], 0) )
      self.obj92.Type.config = 0
      self.obj92.Comments.setValue('')
      self.obj92.Label.setValue('L1')
      self.obj92.GGLabel.setValue(3)
      self.obj92.graphClass_= graph_GPSSBlock
      if parent.genGraphics:
         from graph_GPSSBlock import *
         new_obj = graph_GPSSBlock(93.0,294.0,self.obj92)
      else: new_obj = None
      self.obj92.graphObject_ = new_obj
      self.obj920= AttrCalc()
      self.obj920.Copy=ATOM3Boolean()
      self.obj920.Copy.setValue(('Copy from LHS', 1))
      self.obj920.Copy.config = 0
      self.obj920.Specify=ATOM3Constraint()
      self.obj920.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj92.GGset2Any['A']= self.obj920
      self.obj921= AttrCalc()
      self.obj921.Copy=ATOM3Boolean()
      self.obj921.Copy.setValue(('Copy from LHS', 1))
      self.obj921.Copy.config = 0
      self.obj921.Specify=ATOM3Constraint()
      self.obj921.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj92.GGset2Any['C']= self.obj921
      self.obj922= AttrCalc()
      self.obj922.Copy=ATOM3Boolean()
      self.obj922.Copy.setValue(('Copy from LHS', 1))
      self.obj922.Copy.config = 0
      self.obj922.Specify=ATOM3Constraint()
      self.obj922.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj92.GGset2Any['B']= self.obj922
      self.obj923= AttrCalc()
      self.obj923.Copy=ATOM3Boolean()
      self.obj923.Copy.setValue(('Copy from LHS', 1))
      self.obj923.Copy.config = 0
      self.obj923.Specify=ATOM3Constraint()
      self.obj923.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj92.GGset2Any['E']= self.obj923
      self.obj924= AttrCalc()
      self.obj924.Copy=ATOM3Boolean()
      self.obj924.Copy.setValue(('Copy from LHS', 1))
      self.obj924.Copy.config = 0
      self.obj924.Specify=ATOM3Constraint()
      self.obj924.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj92.GGset2Any['D']= self.obj924
      self.obj925= AttrCalc()
      self.obj925.Copy=ATOM3Boolean()
      self.obj925.Copy.setValue(('Copy from LHS', 1))
      self.obj925.Copy.config = 0
      self.obj925.Specify=ATOM3Constraint()
      self.obj925.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj92.GGset2Any['F']= self.obj925
      self.obj926= AttrCalc()
      self.obj926.Copy=ATOM3Boolean()
      self.obj926.Copy.setValue(('Copy from LHS', 1))
      self.obj926.Copy.config = 0
      self.obj926.Specify=ATOM3Constraint()
      self.obj926.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj92.GGset2Any['X']= self.obj926
      self.obj927= AttrCalc()
      self.obj927.Copy=ATOM3Boolean()
      self.obj927.Copy.setValue(('Copy from LHS', 1))
      self.obj927.Copy.config = 0
      self.obj927.Specify=ATOM3Constraint()
      self.obj927.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj92.GGset2Any['Type']= self.obj927
      self.obj928= AttrCalc()
      self.obj928.Copy=ATOM3Boolean()
      self.obj928.Copy.setValue(('Copy from LHS', 1))
      self.obj928.Copy.config = 0
      self.obj928.Specify=ATOM3Constraint()
      self.obj928.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj92.GGset2Any['Comments']= self.obj928
      self.obj929= AttrCalc()
      self.obj929.Copy=ATOM3Boolean()
      self.obj929.Copy.setValue(('Copy from LHS', 1))
      self.obj929.Copy.config = 0
      self.obj929.Specify=ATOM3Constraint()
      self.obj929.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj92.GGset2Any['Label']= self.obj929
      self.RHS.addNode(self.obj92)

      self.obj93=connected_to(parent)

      self.obj93.GGLabel.setValue(2)
      self.obj93.graphClass_= graph_connected_to
      if parent.genGraphics:
         from graph_connected_to import *
         new_obj = graph_connected_to(94.0,199.0,self.obj93)
      else: new_obj = None
      self.obj93.graphObject_ = new_obj
      self.RHS.addNode(self.obj93)
      self.obj91.out_connections_.append(self.obj93)
      self.obj93.in_connections_.append(self.obj91)
      self.obj93.out_connections_.append(self.obj92)
      self.obj92.in_connections_.append(self.obj93)
   def condition(self, graphID, isograph, atom3i):
      node = self.getMatched(graphID, self.LHS.nodeWithLabel(1))
      child = self.getMatched(graphID, self.LHS.nodeWithLabel(3))
      return node.current == 1 and node.visited == 0 and child.current == 0 and child.visited == 0
      
      
      
      
      

   def action(self, graphID, isograph, atom3i):
      import string
      node = self.getMatched(graphID, self.LHS.nodeWithLabel(1))
      child = self.getMatched(graphID, self.LHS.nodeWithLabel(3))
      node.visited, node.current  = 1, 0
      child.current = 1
      self.graphRewritingSystem.fileGen.write(" ")
      self.graphRewritingSystem.fileGen.write(string.ljust(node.Label.toString(),5))
      self.graphRewritingSystem.fileGen.write(" ")
      # get type
      type = node.Type.getValue()
      tName= string.upper(type[0][type[1]])
      if tName == "GATE" or tName=="TEST" or tName=="LOGIC": # we should add param X
        tName = tName + " " + node.X.toString()
      self.graphRewritingSystem.fileGen.write(string.ljust(tName,11))
      pars = [node.A.toString(),node.B.toString(),node.C.toString(), node.D.toString(),node.E.toString(), node.F.toString()]
      rest = []+pars
      wpar = ""
      for p in pars:
        if p != "": wpar = wpar+p
        rest.remove(p)
        for r in rest:
          if r!="":
            wpar = wpar+","
            break
      self.graphRewritingSystem.fileGen.write(string.ljust(wpar,29))
      self.graphRewritingSystem.fileGen.write(node.Comments.toString())
      self.graphRewritingSystem.fileGen.write(string.whitespace[1])
      
      
      
      

