from Tkinter import *
from ATOM3Type import *
from ATOM3String import *
from ATOM3Integer import *
from ATOM3List import *
from ButtonConfig import *
class Formalism_NameXButtons_Per_RowXButtons (ATOM3Type):
   def __init__(self):
      ATOM3Type.__init__(self)
      self.Formalism_Name= None
      self.Buttons_Per_Row= None
      self.Buttons= None

   def createComponents(self):
      if not self.Formalism_Name:
         self.Formalism_Name=ATOM3String('')
      if not self.Buttons_Per_Row:
         self.Buttons_Per_Row=ATOM3Integer(0)
      if not self.Buttons:
         self.Buttons=ATOM3List([ 1, 1, 1, 0],ButtonConfig)
         lcobj0=[]
         self.Buttons.setValue(lcobj0)

   def show(self, parent, parentWindowInfo=None):
      self.createComponents()
      ATOM3Type.show(self, parent, parentWindowInfo)
      self.containerFrame = Frame(parent)
      Label(self.containerFrame, text='Formalism_Name').grid(row=0,column=0,sticky=W)
      self.Formalism_Name.show(self.containerFrame, parentWindowInfo).grid(row=0,column=1,sticky=W)
      Label(self.containerFrame, text='Buttons_Per_Row').grid(row=1,column=0,sticky=W)
      self.Buttons_Per_Row.show(self.containerFrame, parentWindowInfo).grid(row=1,column=1,sticky=W)
      Label(self.containerFrame, text='Buttons').grid(row=2,column=0,sticky=W)
      self.Buttons.show(self.containerFrame, parentWindowInfo).grid(row=2,column=1,sticky=W)
      return self.containerFrame

   def toString(self):
      self.createComponents()
      return  self.Formalism_Name.toString()+' '+ self.Buttons_Per_Row.toString()+' '+ self.Buttons.toString()
   def getValue(self):
      self.createComponents()
      return (self.Formalism_Name.getValue(),self.Buttons_Per_Row.getValue(),self.Buttons.getValue(),)

   def setValue(self, value):
      self.createComponents()
      if value == None:
         self.Formalism_Name.setNone()
         self.Buttons_Per_Row.setNone()
         self.Buttons.setNone()
      else:
         self.Formalism_Name.setValue(value[0])
         self.Buttons_Per_Row.setValue(value[1])
         self.Buttons.setValue(value[2])

   def writeConstructor2File(self, file, indent, objName="at", depth = 0, generatingCode = 0):
      self.createComponents()
      file.write(indent+objName+'= Formalism_NameXButtons_Per_RowXButtons()\n')
      self.Formalism_Name.writeConstructor2File(file, indent, objName+'.Formalism_Name', depth, generatingCode)
      self.Buttons_Per_Row.writeConstructor2File(file, indent, objName+'.Buttons_Per_Row', depth, generatingCode)
      self.Buttons.writeConstructor2File(file, indent, objName+'.Buttons', depth, generatingCode)

   def writeValue2File(self, file, indent, objName="at", depth = 0, generatingCode = 0):
      self.createComponents()
      self.Formalism_Name.writeValue2File(file, indent, objName+'.Formalism_Name', depth, generatingCode)
      self.Buttons_Per_Row.writeValue2File(file, indent, objName+'.Buttons_Per_Row', depth, generatingCode)
      self.Buttons.writeValue2File(file, indent, objName+'.Buttons', depth, generatingCode)

   def clone(self):
     "Makes an exact copy of itself"
     cloneObject = Formalism_NameXButtons_Per_RowXButtons()
     if self.Formalism_Name: cloneObject.Formalism_Name = self.Formalism_Name.clone()
     if self.Buttons_Per_Row: cloneObject.Buttons_Per_Row = self.Buttons_Per_Row.clone()
     if self.Buttons: cloneObject.Buttons = self.Buttons.clone()
     return cloneObject
   def destroy(self):
     "Destroys (i.e. updates) each field"
     cloneObject = Formalism_NameXButtons_Per_RowXButtons()
     if self.Formalism_Name: self.Formalism_Name.destroy()
     if self.Buttons_Per_Row: self.Buttons_Per_Row.destroy()
     if self.Buttons: self.Buttons.destroy()
     return cloneObject
