# _ findRoot.py ____________________________________________________________________________
# File generated automatically by ATOM3. Graph Grammar Rule
# ___________________________________________________________________________________________
from GGrule import *
from Function import *
from ASG_GPSSMetaModel import *
from SNAVariable import *
from Table import *
from connected_to import *
from Storage_Size import *
from GPSSBlock import *
class findRoot (GGrule):

   def __init__(self, parent):
      GGrule.__init__(self, 6)
      self.LHS = ASG_GPSSMetaModel(parent)

      self.obj80=GPSSBlock(parent)

      self.obj80.A.setValue('')
      self.obj80.C.setValue('')
      self.obj80.B.setValue('')
      self.obj80.E.setValue('')
      self.obj80.D.setValue('')
      self.obj80.F.setValue('')
      self.obj80.X.setValue('')
      self.obj80.Type.setValue( (['Advance', 'Assign', 'Depart', 'Enter', 'Gate', 'Generate', 'Leave', 'Link', 'Logic', 'Mark', 'Priority', 'Queue', 'Release', 'SaveValue', 'Seize', 'Tabulate', 'Terminate', 'Test', 'Transfer', 'Unlink'], 5) )
      self.obj80.Type.config = 0
      self.obj80.Comments.setValue('')
      self.obj80.Label.setValue('')
      self.obj80.GGLabel.setValue(1)
      self.obj80.graphClass_= graph_GPSSBlock
      if parent.genGraphics:
         from graph_GPSSBlock import *
         new_obj = graph_GPSSBlock(102.0,221.0,self.obj80)
      else: new_obj = None
      self.obj80.graphObject_ = new_obj
      self.LHS.addNode(self.obj80)
      self.RHS = ASG_GPSSMetaModel(parent)

      self.obj82=GPSSBlock(parent)

      self.obj82.A.setValue('')
      self.obj82.C.setValue('')
      self.obj82.B.setValue('')
      self.obj82.E.setValue('')
      self.obj82.D.setValue('')
      self.obj82.F.setValue('')
      self.obj82.X.setValue('')
      self.obj82.Type.setValue( (['Advance', 'Assign', 'Depart', 'Enter', 'Gate', 'Generate', 'Leave', 'Link', 'Logic', 'Mark', 'Priority', 'Queue', 'Release', 'SaveValue', 'Seize', 'Tabulate', 'Terminate', 'Test', 'Transfer', 'Unlink'], 0) )
      self.obj82.Type.config = 0
      self.obj82.Comments.setValue('')
      self.obj82.Label.setValue('L0')
      self.obj82.GGLabel.setValue(1)
      self.obj82.graphClass_= graph_GPSSBlock
      if parent.genGraphics:
         from graph_GPSSBlock import *
         new_obj = graph_GPSSBlock(104.0,222.0,self.obj82)
      else: new_obj = None
      self.obj82.graphObject_ = new_obj
      self.obj820= AttrCalc()
      self.obj820.Copy=ATOM3Boolean()
      self.obj820.Copy.setValue(('Copy from LHS', 1))
      self.obj820.Copy.config = 0
      self.obj820.Specify=ATOM3Constraint()
      self.obj820.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj82.GGset2Any['A']= self.obj820
      self.obj821= AttrCalc()
      self.obj821.Copy=ATOM3Boolean()
      self.obj821.Copy.setValue(('Copy from LHS', 1))
      self.obj821.Copy.config = 0
      self.obj821.Specify=ATOM3Constraint()
      self.obj821.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj82.GGset2Any['C']= self.obj821
      self.obj822= AttrCalc()
      self.obj822.Copy=ATOM3Boolean()
      self.obj822.Copy.setValue(('Copy from LHS', 1))
      self.obj822.Copy.config = 0
      self.obj822.Specify=ATOM3Constraint()
      self.obj822.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj82.GGset2Any['B']= self.obj822
      self.obj823= AttrCalc()
      self.obj823.Copy=ATOM3Boolean()
      self.obj823.Copy.setValue(('Copy from LHS', 1))
      self.obj823.Copy.config = 0
      self.obj823.Specify=ATOM3Constraint()
      self.obj823.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj82.GGset2Any['E']= self.obj823
      self.obj824= AttrCalc()
      self.obj824.Copy=ATOM3Boolean()
      self.obj824.Copy.setValue(('Copy from LHS', 1))
      self.obj824.Copy.config = 0
      self.obj824.Specify=ATOM3Constraint()
      self.obj824.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj82.GGset2Any['D']= self.obj824
      self.obj825= AttrCalc()
      self.obj825.Copy=ATOM3Boolean()
      self.obj825.Copy.setValue(('Copy from LHS', 1))
      self.obj825.Copy.config = 0
      self.obj825.Specify=ATOM3Constraint()
      self.obj825.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj82.GGset2Any['F']= self.obj825
      self.obj826= AttrCalc()
      self.obj826.Copy=ATOM3Boolean()
      self.obj826.Copy.setValue(('Copy from LHS', 1))
      self.obj826.Copy.config = 0
      self.obj826.Specify=ATOM3Constraint()
      self.obj826.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj82.GGset2Any['X']= self.obj826
      self.obj827= AttrCalc()
      self.obj827.Copy=ATOM3Boolean()
      self.obj827.Copy.setValue(('Copy from LHS', 1))
      self.obj827.Copy.config = 0
      self.obj827.Specify=ATOM3Constraint()
      self.obj827.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj82.GGset2Any['Type']= self.obj827
      self.obj828= AttrCalc()
      self.obj828.Copy=ATOM3Boolean()
      self.obj828.Copy.setValue(('Copy from LHS', 1))
      self.obj828.Copy.config = 0
      self.obj828.Specify=ATOM3Constraint()
      self.obj828.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj82.GGset2Any['Comments']= self.obj828
      self.obj829= AttrCalc()
      self.obj829.Copy=ATOM3Boolean()
      self.obj829.Copy.setValue(('Copy from LHS', 1))
      self.obj829.Copy.config = 0
      self.obj829.Specify=ATOM3Constraint()
      self.obj829.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj82.GGset2Any['Label']= self.obj829
      self.RHS.addNode(self.obj82)
   def condition(self, graphID, isograph, atom3i):
      node = self.getMatched(graphID, self.LHS.nodeWithLabel(1))
      return node.visited == 0 and node.current == 0 and len(node.in_connections_) == 0
      
      
      

   def action(self, graphID, isograph, atom3i):
      node = self.getMatched(graphID, self.LHS.nodeWithLabel(1))
      node.current = 1
      
      

