# _ finishBranch.py ____________________________________________________________________________
# File generated automatically by ATOM3. Graph Grammar Rule
# ___________________________________________________________________________________________
from GGrule import *
from Function import *
from ASG_GPSSMetaModel import *
from SNAVariable import *
from Table import *
from connected_to import *
from Storage_Size import *
from GPSSBlock import *
class finishBranch (GGrule):

   def __init__(self, parent):
      GGrule.__init__(self, 4)
      self.LHS = ASG_GPSSMetaModel(parent)

      self.obj98=GPSSBlock(parent)

      self.obj98.A.setValue('')
      self.obj98.C.setValue('')
      self.obj98.B.setValue('')
      self.obj98.E.setValue('')
      self.obj98.D.setValue('')
      self.obj98.F.setValue('')
      self.obj98.X.setValue('')
      self.obj98.Type.setNone()
      self.obj98.Type.config = 0
      self.obj98.Comments.setValue('')
      self.obj98.Label.setValue('')
      self.obj98.GGLabel.setValue(1)
      self.obj98.graphClass_= graph_GPSSBlock
      if parent.genGraphics:
         from graph_GPSSBlock import *
         new_obj = graph_GPSSBlock(117.0,209.0,self.obj98)
      else: new_obj = None
      self.obj98.graphObject_ = new_obj
      self.LHS.addNode(self.obj98)
      self.RHS = ASG_GPSSMetaModel(parent)

      self.obj100=GPSSBlock(parent)

      self.obj100.A.setValue('')
      self.obj100.C.setValue('')
      self.obj100.B.setValue('')
      self.obj100.E.setValue('')
      self.obj100.D.setValue('')
      self.obj100.F.setValue('')
      self.obj100.X.setValue('')
      self.obj100.Type.setValue( (['Advance', 'Assign', 'Depart', 'Enter', 'Gate', 'Generate', 'Leave', 'Link', 'Logic', 'Mark', 'Priority', 'Queue', 'Release', 'SaveValue', 'Seize', 'Tabulate', 'Terminate', 'Test', 'Transfer', 'Unlink'], 0) )
      self.obj100.Type.config = 0
      self.obj100.Comments.setValue('')
      self.obj100.Label.setValue('L0')
      self.obj100.GGLabel.setValue(1)
      self.obj100.graphClass_= graph_GPSSBlock
      if parent.genGraphics:
         from graph_GPSSBlock import *
         new_obj = graph_GPSSBlock(173.0,227.0,self.obj100)
      else: new_obj = None
      self.obj100.graphObject_ = new_obj
      self.obj1000= AttrCalc()
      self.obj1000.Copy=ATOM3Boolean()
      self.obj1000.Copy.setValue(('Copy from LHS', 1))
      self.obj1000.Copy.config = 0
      self.obj1000.Specify=ATOM3Constraint()
      self.obj1000.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj100.GGset2Any['A']= self.obj1000
      self.obj1001= AttrCalc()
      self.obj1001.Copy=ATOM3Boolean()
      self.obj1001.Copy.setValue(('Copy from LHS', 1))
      self.obj1001.Copy.config = 0
      self.obj1001.Specify=ATOM3Constraint()
      self.obj1001.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj100.GGset2Any['C']= self.obj1001
      self.obj1002= AttrCalc()
      self.obj1002.Copy=ATOM3Boolean()
      self.obj1002.Copy.setValue(('Copy from LHS', 1))
      self.obj1002.Copy.config = 0
      self.obj1002.Specify=ATOM3Constraint()
      self.obj1002.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj100.GGset2Any['B']= self.obj1002
      self.obj1003= AttrCalc()
      self.obj1003.Copy=ATOM3Boolean()
      self.obj1003.Copy.setValue(('Copy from LHS', 1))
      self.obj1003.Copy.config = 0
      self.obj1003.Specify=ATOM3Constraint()
      self.obj1003.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj100.GGset2Any['E']= self.obj1003
      self.obj1004= AttrCalc()
      self.obj1004.Copy=ATOM3Boolean()
      self.obj1004.Copy.setValue(('Copy from LHS', 1))
      self.obj1004.Copy.config = 0
      self.obj1004.Specify=ATOM3Constraint()
      self.obj1004.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj100.GGset2Any['D']= self.obj1004
      self.obj1005= AttrCalc()
      self.obj1005.Copy=ATOM3Boolean()
      self.obj1005.Copy.setValue(('Copy from LHS', 1))
      self.obj1005.Copy.config = 0
      self.obj1005.Specify=ATOM3Constraint()
      self.obj1005.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj100.GGset2Any['F']= self.obj1005
      self.obj1006= AttrCalc()
      self.obj1006.Copy=ATOM3Boolean()
      self.obj1006.Copy.setValue(('Copy from LHS', 1))
      self.obj1006.Copy.config = 0
      self.obj1006.Specify=ATOM3Constraint()
      self.obj1006.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj100.GGset2Any['X']= self.obj1006
      self.obj1007= AttrCalc()
      self.obj1007.Copy=ATOM3Boolean()
      self.obj1007.Copy.setValue(('Copy from LHS', 1))
      self.obj1007.Copy.config = 0
      self.obj1007.Specify=ATOM3Constraint()
      self.obj1007.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj100.GGset2Any['Type']= self.obj1007
      self.obj1008= AttrCalc()
      self.obj1008.Copy=ATOM3Boolean()
      self.obj1008.Copy.setValue(('Copy from LHS', 1))
      self.obj1008.Copy.config = 0
      self.obj1008.Specify=ATOM3Constraint()
      self.obj1008.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj100.GGset2Any['Comments']= self.obj1008
      self.obj1009= AttrCalc()
      self.obj1009.Copy=ATOM3Boolean()
      self.obj1009.Copy.setValue(('Copy from LHS', 1))
      self.obj1009.Copy.config = 0
      self.obj1009.Specify=ATOM3Constraint()
      self.obj1009.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj100.GGset2Any['Label']= self.obj1009
      self.RHS.addNode(self.obj100)
   def condition(self, graphID, isograph, atom3i):
      node=self.getMatched(graphID,self.LHS.nodeWithLabel(1))
      return node.visited == 0 and node.current == 1
      
      
      
      

   def action(self, graphID, isograph, atom3i):
      import string
      node = self.getMatched(graphID, self.LHS.nodeWithLabel(1))
      node.visited, node.current  = 1, 0
      self.graphRewritingSystem.fileGen.write(" ")
      self.graphRewritingSystem.fileGen.write(string.ljust(node.Label.toString(),5))
      self.graphRewritingSystem.fileGen.write(" ")
      # get type
      type = node.Type.getValue()
      tName= string.upper(type[0][type[1]])
      if tName == "GATE" or tName=="TEST" or tName == "LOGIC":
        tName = tName + " " + node.X.toString()
      self.graphRewritingSystem.fileGen.write(string.ljust(tName,11))
      
      pars = [node.A.toString(),node.B.toString(),node.C.toString(), node.D.toString(),node.E.toString(), node.F.toString()]
      rest = []+pars
      wpar = ""
      for p in pars:
        if p != "": wpar = wpar+p
        rest.remove(p)
        for r in rest:
          if r!="":
            wpar = wpar+","
            break
      self.graphRewritingSystem.fileGen.write(string.ljust(wpar,29))
      self.graphRewritingSystem.fileGen.write(node.Comments.toString())
      self.graphRewritingSystem.fileGen.write(string.whitespace[1])
      
      
      

