# _ genGates.py ____________________________________________________________________________
# File generated automatically by ATOM3. Graph Grammar Rule
# ___________________________________________________________________________________________
from GGrule import *
from Function import *
from ASG_GPSSMetaModel import *
from SNAVariable import *
from Table import *
from connected_to import *
from Storage_Size import *
from GPSSBlock import *
class genGates (GGrule):

   def __init__(self, parent):
      GGrule.__init__(self, 2)
      self.LHS = ASG_GPSSMetaModel(parent)

      self.obj144=GPSSBlock(parent)

      self.obj144.A.setValue('')
      self.obj144.C.setValue('')
      self.obj144.B.setValue('')
      self.obj144.E.setValue('')
      self.obj144.D.setValue('')
      self.obj144.F.setValue('')
      self.obj144.X.setValue('')
      self.obj144.Type.setValue( (['Advance', 'Assign', 'Depart', 'Enter', 'Gate', 'Generate', 'Leave', 'Link', 'Logic', 'Mark', 'Priority', 'Queue', 'Release', 'SaveValue', 'Seize', 'Tabulate', 'Terminate', 'Test', 'Transfer', 'Unlink'], 4) )
      self.obj144.Type.config = 0
      self.obj144.Comments.setValue('')
      self.obj144.Label.setValue('')
      self.obj144.GGLabel.setValue(0)
      self.obj144.graphClass_= graph_GPSSBlock
      if parent.genGraphics:
         from graph_GPSSBlock import *
         new_obj = graph_GPSSBlock(303.0,75.0,self.obj144)
      else: new_obj = None
      self.obj144.graphObject_ = new_obj
      self.LHS.addNode(self.obj144)

      self.obj145=GPSSBlock(parent)

      self.obj145.A.setValue('')
      self.obj145.C.setValue('')
      self.obj145.B.setValue('')
      self.obj145.E.setValue('')
      self.obj145.D.setValue('')
      self.obj145.F.setValue('')
      self.obj145.X.setValue('')
      self.obj145.Type.setNone()
      self.obj145.Type.config = 0
      self.obj145.Comments.setValue('')
      self.obj145.Label.setValue('')
      self.obj145.GGLabel.setValue(1)
      self.obj145.graphClass_= graph_GPSSBlock
      if parent.genGraphics:
         from graph_GPSSBlock import *
         new_obj = graph_GPSSBlock(190.0,234.0,self.obj145)
      else: new_obj = None
      self.obj145.graphObject_ = new_obj
      self.LHS.addNode(self.obj145)

      self.obj146=GPSSBlock(parent)

      self.obj146.A.setValue('')
      self.obj146.C.setValue('')
      self.obj146.B.setValue('')
      self.obj146.E.setValue('')
      self.obj146.D.setValue('')
      self.obj146.F.setValue('')
      self.obj146.X.setValue('')
      self.obj146.Type.setNone()
      self.obj146.Type.config = 0
      self.obj146.Comments.setValue('')
      self.obj146.Label.setValue('')
      self.obj146.GGLabel.setValue(2)
      self.obj146.graphClass_= graph_GPSSBlock
      if parent.genGraphics:
         from graph_GPSSBlock import *
         new_obj = graph_GPSSBlock(425.0,237.0,self.obj146)
      else: new_obj = None
      self.obj146.graphObject_ = new_obj
      self.LHS.addNode(self.obj146)

      self.obj147=connected_to(parent)

      self.obj147.GGLabel.setValue(3)
      self.obj147.graphClass_= graph_connected_to
      if parent.genGraphics:
         from graph_connected_to import *
         new_obj = graph_connected_to(263.0,176.0,self.obj147)
      else: new_obj = None
      self.obj147.graphObject_ = new_obj
      self.LHS.addNode(self.obj147)

      self.obj148=connected_to(parent)

      self.obj148.GGLabel.setValue(4)
      self.obj148.graphClass_= graph_connected_to
      if parent.genGraphics:
         from graph_connected_to import *
         new_obj = graph_connected_to(449.0,177.0,self.obj148)
      else: new_obj = None
      self.obj148.graphObject_ = new_obj
      self.LHS.addNode(self.obj148)
      self.obj144.out_connections_.append(self.obj147)
      self.obj147.in_connections_.append(self.obj144)
      self.obj144.out_connections_.append(self.obj148)
      self.obj148.in_connections_.append(self.obj144)
      self.obj147.out_connections_.append(self.obj145)
      self.obj145.in_connections_.append(self.obj147)
      self.obj148.out_connections_.append(self.obj146)
      self.obj146.in_connections_.append(self.obj148)
      self.RHS = ASG_GPSSMetaModel(parent)

      self.obj150=GPSSBlock(parent)

      self.obj150.A.setValue('')
      self.obj150.C.setValue('')
      self.obj150.B.setValue('')
      self.obj150.E.setValue('')
      self.obj150.D.setValue('')
      self.obj150.F.setValue('')
      self.obj150.X.setValue('')
      self.obj150.Type.setValue( (['Advance', 'Assign', 'Depart', 'Enter', 'Gate', 'Generate', 'Leave', 'Link', 'Logic', 'Mark', 'Priority', 'Queue', 'Release', 'SaveValue', 'Seize', 'Tabulate', 'Terminate', 'Test', 'Transfer', 'Unlink'], 0) )
      self.obj150.Type.config = 0
      self.obj150.Comments.setValue('')
      self.obj150.Label.setValue('L0')
      self.obj150.GGLabel.setValue(0)
      self.obj150.graphClass_= graph_GPSSBlock
      if parent.genGraphics:
         from graph_GPSSBlock import *
         new_obj = graph_GPSSBlock(289.0,93.0,self.obj150)
      else: new_obj = None
      self.obj150.graphObject_ = new_obj
      self.obj1500= AttrCalc()
      self.obj1500.Copy=ATOM3Boolean()
      self.obj1500.Copy.setValue(('Copy from LHS', 1))
      self.obj1500.Copy.config = 0
      self.obj1500.Specify=ATOM3Constraint()
      self.obj1500.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj150.GGset2Any['A']= self.obj1500
      self.obj1501= AttrCalc()
      self.obj1501.Copy=ATOM3Boolean()
      self.obj1501.Copy.setValue(('Copy from LHS', 1))
      self.obj1501.Copy.config = 0
      self.obj1501.Specify=ATOM3Constraint()
      self.obj1501.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj150.GGset2Any['C']= self.obj1501
      self.obj1502= AttrCalc()
      self.obj1502.Copy=ATOM3Boolean()
      self.obj1502.Copy.setValue(('Copy from LHS', 1))
      self.obj1502.Copy.config = 0
      self.obj1502.Specify=ATOM3Constraint()
      self.obj1502.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj150.GGset2Any['B']= self.obj1502
      self.obj1503= AttrCalc()
      self.obj1503.Copy=ATOM3Boolean()
      self.obj1503.Copy.setValue(('Copy from LHS', 1))
      self.obj1503.Copy.config = 0
      self.obj1503.Specify=ATOM3Constraint()
      self.obj1503.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj150.GGset2Any['E']= self.obj1503
      self.obj1504= AttrCalc()
      self.obj1504.Copy=ATOM3Boolean()
      self.obj1504.Copy.setValue(('Copy from LHS', 1))
      self.obj1504.Copy.config = 0
      self.obj1504.Specify=ATOM3Constraint()
      self.obj1504.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj150.GGset2Any['D']= self.obj1504
      self.obj1505= AttrCalc()
      self.obj1505.Copy=ATOM3Boolean()
      self.obj1505.Copy.setValue(('Copy from LHS', 1))
      self.obj1505.Copy.config = 0
      self.obj1505.Specify=ATOM3Constraint()
      self.obj1505.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj150.GGset2Any['F']= self.obj1505
      self.obj1506= AttrCalc()
      self.obj1506.Copy=ATOM3Boolean()
      self.obj1506.Copy.setValue(('Copy from LHS', 1))
      self.obj1506.Copy.config = 0
      self.obj1506.Specify=ATOM3Constraint()
      self.obj1506.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj150.GGset2Any['X']= self.obj1506
      self.obj1507= AttrCalc()
      self.obj1507.Copy=ATOM3Boolean()
      self.obj1507.Copy.setValue(('Copy from LHS', 1))
      self.obj1507.Copy.config = 0
      self.obj1507.Specify=ATOM3Constraint()
      self.obj1507.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj150.GGset2Any['Type']= self.obj1507
      self.obj1508= AttrCalc()
      self.obj1508.Copy=ATOM3Boolean()
      self.obj1508.Copy.setValue(('Copy from LHS', 1))
      self.obj1508.Copy.config = 0
      self.obj1508.Specify=ATOM3Constraint()
      self.obj1508.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj150.GGset2Any['Comments']= self.obj1508
      self.obj1509= AttrCalc()
      self.obj1509.Copy=ATOM3Boolean()
      self.obj1509.Copy.setValue(('Copy from LHS', 1))
      self.obj1509.Copy.config = 0
      self.obj1509.Specify=ATOM3Constraint()
      self.obj1509.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj150.GGset2Any['Label']= self.obj1509
      self.RHS.addNode(self.obj150)

      self.obj151=GPSSBlock(parent)

      self.obj151.A.setValue('')
      self.obj151.C.setValue('')
      self.obj151.B.setValue('')
      self.obj151.E.setValue('')
      self.obj151.D.setValue('')
      self.obj151.F.setValue('')
      self.obj151.X.setValue('')
      self.obj151.Type.setValue( (['Advance', 'Assign', 'Depart', 'Enter', 'Gate', 'Generate', 'Leave', 'Link', 'Logic', 'Mark', 'Priority', 'Queue', 'Release', 'SaveValue', 'Seize', 'Tabulate', 'Terminate', 'Test', 'Transfer', 'Unlink'], 0) )
      self.obj151.Type.config = 0
      self.obj151.Comments.setValue('')
      self.obj151.Label.setValue('L1')
      self.obj151.GGLabel.setValue(1)
      self.obj151.graphClass_= graph_GPSSBlock
      if parent.genGraphics:
         from graph_GPSSBlock import *
         new_obj = graph_GPSSBlock(158.0,268.0,self.obj151)
      else: new_obj = None
      self.obj151.graphObject_ = new_obj
      self.obj1510= AttrCalc()
      self.obj1510.Copy=ATOM3Boolean()
      self.obj1510.Copy.setValue(('Copy from LHS', 1))
      self.obj1510.Copy.config = 0
      self.obj1510.Specify=ATOM3Constraint()
      self.obj1510.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj151.GGset2Any['A']= self.obj1510
      self.obj1511= AttrCalc()
      self.obj1511.Copy=ATOM3Boolean()
      self.obj1511.Copy.setValue(('Copy from LHS', 1))
      self.obj1511.Copy.config = 0
      self.obj1511.Specify=ATOM3Constraint()
      self.obj1511.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj151.GGset2Any['C']= self.obj1511
      self.obj1512= AttrCalc()
      self.obj1512.Copy=ATOM3Boolean()
      self.obj1512.Copy.setValue(('Copy from LHS', 1))
      self.obj1512.Copy.config = 0
      self.obj1512.Specify=ATOM3Constraint()
      self.obj1512.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj151.GGset2Any['B']= self.obj1512
      self.obj1513= AttrCalc()
      self.obj1513.Copy=ATOM3Boolean()
      self.obj1513.Copy.setValue(('Copy from LHS', 1))
      self.obj1513.Copy.config = 0
      self.obj1513.Specify=ATOM3Constraint()
      self.obj1513.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj151.GGset2Any['E']= self.obj1513
      self.obj1514= AttrCalc()
      self.obj1514.Copy=ATOM3Boolean()
      self.obj1514.Copy.setValue(('Copy from LHS', 1))
      self.obj1514.Copy.config = 0
      self.obj1514.Specify=ATOM3Constraint()
      self.obj1514.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj151.GGset2Any['D']= self.obj1514
      self.obj1515= AttrCalc()
      self.obj1515.Copy=ATOM3Boolean()
      self.obj1515.Copy.setValue(('Copy from LHS', 1))
      self.obj1515.Copy.config = 0
      self.obj1515.Specify=ATOM3Constraint()
      self.obj1515.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj151.GGset2Any['F']= self.obj1515
      self.obj1516= AttrCalc()
      self.obj1516.Copy=ATOM3Boolean()
      self.obj1516.Copy.setValue(('Copy from LHS', 1))
      self.obj1516.Copy.config = 0
      self.obj1516.Specify=ATOM3Constraint()
      self.obj1516.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj151.GGset2Any['X']= self.obj1516
      self.obj1517= AttrCalc()
      self.obj1517.Copy=ATOM3Boolean()
      self.obj1517.Copy.setValue(('Copy from LHS', 1))
      self.obj1517.Copy.config = 0
      self.obj1517.Specify=ATOM3Constraint()
      self.obj1517.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj151.GGset2Any['Type']= self.obj1517
      self.obj1518= AttrCalc()
      self.obj1518.Copy=ATOM3Boolean()
      self.obj1518.Copy.setValue(('Copy from LHS', 1))
      self.obj1518.Copy.config = 0
      self.obj1518.Specify=ATOM3Constraint()
      self.obj1518.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj151.GGset2Any['Comments']= self.obj1518
      self.obj1519= AttrCalc()
      self.obj1519.Copy=ATOM3Boolean()
      self.obj1519.Copy.setValue(('Copy from LHS', 1))
      self.obj1519.Copy.config = 0
      self.obj1519.Specify=ATOM3Constraint()
      self.obj1519.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj151.GGset2Any['Label']= self.obj1519
      self.RHS.addNode(self.obj151)

      self.obj152=GPSSBlock(parent)

      self.obj152.A.setValue('')
      self.obj152.C.setValue('')
      self.obj152.B.setValue('')
      self.obj152.E.setValue('')
      self.obj152.D.setValue('')
      self.obj152.F.setValue('')
      self.obj152.X.setValue('')
      self.obj152.Type.setValue( (['Advance', 'Assign', 'Depart', 'Enter', 'Gate', 'Generate', 'Leave', 'Link', 'Logic', 'Mark', 'Priority', 'Queue', 'Release', 'SaveValue', 'Seize', 'Tabulate', 'Terminate', 'Test', 'Transfer', 'Unlink'], 0) )
      self.obj152.Type.config = 0
      self.obj152.Comments.setValue('')
      self.obj152.Label.setValue('L2')
      self.obj152.GGLabel.setValue(2)
      self.obj152.graphClass_= graph_GPSSBlock
      if parent.genGraphics:
         from graph_GPSSBlock import *
         new_obj = graph_GPSSBlock(420.0,267.0,self.obj152)
      else: new_obj = None
      self.obj152.graphObject_ = new_obj
      self.obj1520= AttrCalc()
      self.obj1520.Copy=ATOM3Boolean()
      self.obj1520.Copy.setValue(('Copy from LHS', 1))
      self.obj1520.Copy.config = 0
      self.obj1520.Specify=ATOM3Constraint()
      self.obj1520.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj152.GGset2Any['A']= self.obj1520
      self.obj1521= AttrCalc()
      self.obj1521.Copy=ATOM3Boolean()
      self.obj1521.Copy.setValue(('Copy from LHS', 1))
      self.obj1521.Copy.config = 0
      self.obj1521.Specify=ATOM3Constraint()
      self.obj1521.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj152.GGset2Any['C']= self.obj1521
      self.obj1522= AttrCalc()
      self.obj1522.Copy=ATOM3Boolean()
      self.obj1522.Copy.setValue(('Copy from LHS', 1))
      self.obj1522.Copy.config = 0
      self.obj1522.Specify=ATOM3Constraint()
      self.obj1522.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj152.GGset2Any['B']= self.obj1522
      self.obj1523= AttrCalc()
      self.obj1523.Copy=ATOM3Boolean()
      self.obj1523.Copy.setValue(('Copy from LHS', 1))
      self.obj1523.Copy.config = 0
      self.obj1523.Specify=ATOM3Constraint()
      self.obj1523.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj152.GGset2Any['E']= self.obj1523
      self.obj1524= AttrCalc()
      self.obj1524.Copy=ATOM3Boolean()
      self.obj1524.Copy.setValue(('Copy from LHS', 1))
      self.obj1524.Copy.config = 0
      self.obj1524.Specify=ATOM3Constraint()
      self.obj1524.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj152.GGset2Any['D']= self.obj1524
      self.obj1525= AttrCalc()
      self.obj1525.Copy=ATOM3Boolean()
      self.obj1525.Copy.setValue(('Copy from LHS', 1))
      self.obj1525.Copy.config = 0
      self.obj1525.Specify=ATOM3Constraint()
      self.obj1525.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj152.GGset2Any['F']= self.obj1525
      self.obj1526= AttrCalc()
      self.obj1526.Copy=ATOM3Boolean()
      self.obj1526.Copy.setValue(('Copy from LHS', 1))
      self.obj1526.Copy.config = 0
      self.obj1526.Specify=ATOM3Constraint()
      self.obj1526.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj152.GGset2Any['X']= self.obj1526
      self.obj1527= AttrCalc()
      self.obj1527.Copy=ATOM3Boolean()
      self.obj1527.Copy.setValue(('Copy from LHS', 1))
      self.obj1527.Copy.config = 0
      self.obj1527.Specify=ATOM3Constraint()
      self.obj1527.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj152.GGset2Any['Type']= self.obj1527
      self.obj1528= AttrCalc()
      self.obj1528.Copy=ATOM3Boolean()
      self.obj1528.Copy.setValue(('Copy from LHS', 1))
      self.obj1528.Copy.config = 0
      self.obj1528.Specify=ATOM3Constraint()
      self.obj1528.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj152.GGset2Any['Comments']= self.obj1528
      self.obj1529= AttrCalc()
      self.obj1529.Copy=ATOM3Boolean()
      self.obj1529.Copy.setValue(('Copy from LHS', 1))
      self.obj1529.Copy.config = 0
      self.obj1529.Specify=ATOM3Constraint()
      self.obj1529.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj152.GGset2Any['Label']= self.obj1529
      self.RHS.addNode(self.obj152)

      self.obj153=connected_to(parent)

      self.obj153.GGLabel.setValue(3)
      self.obj153.graphClass_= graph_connected_to
      if parent.genGraphics:
         from graph_connected_to import *
         new_obj = graph_connected_to(237.0,201.0,self.obj153)
      else: new_obj = None
      self.obj153.graphObject_ = new_obj
      self.RHS.addNode(self.obj153)

      self.obj154=connected_to(parent)

      self.obj154.GGLabel.setValue(4)
      self.obj154.graphClass_= graph_connected_to
      if parent.genGraphics:
         from graph_connected_to import *
         new_obj = graph_connected_to(439.0,193.0,self.obj154)
      else: new_obj = None
      self.obj154.graphObject_ = new_obj
      self.RHS.addNode(self.obj154)
      self.obj150.out_connections_.append(self.obj153)
      self.obj153.in_connections_.append(self.obj150)
      self.obj150.out_connections_.append(self.obj154)
      self.obj154.in_connections_.append(self.obj150)
      self.obj153.out_connections_.append(self.obj151)
      self.obj151.in_connections_.append(self.obj153)
      self.obj154.out_connections_.append(self.obj152)
      self.obj152.in_connections_.append(self.obj154)
   def condition(self, graphID, isograph, atom3i):
      gnode = self.getMatched(graphID, self.LHS.nodeWithLabel(1))
      ch1   = self.getMatched(graphID, self.LHS.nodeWithLabel(2))
      ch2   = self.getMatched(graphID, self.LHS.nodeWithLabel(3))
      gnodeCond = gnode.current == 1 and gnode.visited == 0
      ch1Cond   = ch1.current == 0 and ch1.visited == 0 and ch1.Label.toString() == gnode.B.toString()
      ch2Cond   = ch2.current == 0 and ch2.visited == 0
      return gnodeCond and ch1Cond and ch2Cond
      
      

   def action(self, graphID, isograph, atom3i):
      import string
      node = self.getMatched(graphID, self.LHS.nodeWithLabel(1))
      ch1  = self.getMatched(graphID, self.LHS.nodeWithLabel(2))
      ch2  = self.getMatched(graphID, self.LHS.nodeWithLabel(3))
      node.visited, node.current  = 1, 0
      ch2.current = 1
      self.graphRewritingSystem.fileGen.write(" ")
      self.graphRewritingSystem.fileGen.write(string.ljust(node.Label.toString(),5))
      self.graphRewritingSystem.fileGen.write(" ")
      # get type
      tName= "GATE " + node.X.toString()
      self.graphRewritingSystem.fileGen.write(string.ljust(tName,11))
      pars = [node.A.toString(),node.B.toString(),node.C.toString(), node.D.toString(),node.E.toString(), node.F.toString()]
      rest = []+pars
      wpar = ""
      for p in pars:
        if p != "": wpar = wpar+p
        rest.remove(p)
        for r in rest:
          if r!="":
            wpar = wpar+","
            break
      self.graphRewritingSystem.fileGen.write(string.ljust(wpar,29))
      self.graphRewritingSystem.fileGen.write(node.Comments.toString())
      self.graphRewritingSystem.fileGen.write(string.whitespace[1])
      
      
      

