# _ genVariables.py ____________________________________________________________________________
# File generated automatically by ATOM3. Graph Grammar Rule
# ___________________________________________________________________________________________
from GGrule import *
from Function import *
from ASG_GPSSMetaModel import *
from SNAVariable import *
from Table import *
from connected_to import *
from Storage_Size import *
from GPSSBlock import *
class genVariables (GGrule):

   def __init__(self, parent):
      GGrule.__init__(self, 9)
      self.LHS = ASG_GPSSMetaModel(parent)

      self.obj137=SNAVariable(parent)

      self.obj137.Expression.setValue('')
      self.obj137.Type.setNone()
      self.obj137.Type.config = 0
      self.obj137.Name.setValue('')
      self.obj137.GGLabel.setValue(1)
      self.obj137.graphClass_= graph_SNAVariable
      if parent.genGraphics:
         from graph_SNAVariable import *
         new_obj = graph_SNAVariable(149.0,282.0,self.obj137)
      else: new_obj = None
      self.obj137.graphObject_ = new_obj
      self.LHS.addNode(self.obj137)
      self.RHS = ASG_GPSSMetaModel(parent)

      self.obj139=SNAVariable(parent)

      self.obj139.Expression.setValue('')
      self.obj139.Type.setValue( (['Integer', 'Float', 'Boolean'], 0) )
      self.obj139.Type.config = 0
      self.obj139.Name.setValue('0')
      self.obj139.GGLabel.setValue(1)
      self.obj139.graphClass_= graph_SNAVariable
      if parent.genGraphics:
         from graph_SNAVariable import *
         new_obj = graph_SNAVariable(120.0,283.0,self.obj139)
      else: new_obj = None
      self.obj139.graphObject_ = new_obj
      self.obj1390= AttrCalc()
      self.obj1390.Copy=ATOM3Boolean()
      self.obj1390.Copy.setValue(('Copy from LHS', 1))
      self.obj1390.Copy.config = 0
      self.obj1390.Specify=ATOM3Constraint()
      self.obj1390.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj139.GGset2Any['Expression']= self.obj1390
      self.obj1391= AttrCalc()
      self.obj1391.Copy=ATOM3Boolean()
      self.obj1391.Copy.setValue(('Copy from LHS', 1))
      self.obj1391.Copy.config = 0
      self.obj1391.Specify=ATOM3Constraint()
      self.obj1391.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj139.GGset2Any['Type']= self.obj1391
      self.obj1392= AttrCalc()
      self.obj1392.Copy=ATOM3Boolean()
      self.obj1392.Copy.setValue(('Copy from LHS', 1))
      self.obj1392.Copy.config = 0
      self.obj1392.Specify=ATOM3Constraint()
      self.obj1392.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj139.GGset2Any['Name']= self.obj1392
      self.RHS.addNode(self.obj139)
   def condition(self, graphID, isograph, atom3i):
      node=self.getMatched(graphID, self.LHS.nodeWithLabel(1))
      return node.visited == 0
      
      
      

   def action(self, graphID, isograph, atom3i):
      node=self.getMatched(graphID,self.LHS.nodeWithLabel(1))
      node.visited = 1
      self.graphRewritingSystem.fileGen.write(" ")
      self.graphRewritingSystem.fileGen.write(string.ljust(node.Name.toString(),5))
      self.graphRewritingSystem.fileGen.write(" ")
      # see if it is integer or float
      type=node.Type.toString()
      if type == 'Integer':
         self.graphRewritingSystem.fileGen.write(string.ljust("VARIABLE",11))
      else:
         self.graphRewritingSystem.fileGen.write(string.ljust("FVARIABLE",11))
      self.graphRewritingSystem.fileGen.write(node.Expression.toString())
      self.graphRewritingSystem.fileGen.write(string.whitespace[1])
      
      

