from Tkinter import *
from ATOM3Type import *
from ATOM3Enum import *
from ATOM3String import *
from ATOM3String import *
from ATOM3String import *
class ltypenameXAXBXC (ATOM3Type):
   def __init__(self):
      ATOM3Type.__init__(self)
      self.ltypename= None
      self.A= None
      self.B= None
      self.C= None

   def createComponents(self):
      if not self.ltypename:
         self.ltypename=ATOM3Enum(['START', 'CLEAR', 'RESET'], None, 0)
         self.ltypename.setNone()
      if not self.A:
         self.A=ATOM3String('')
      if not self.B:
         self.B=ATOM3String('')
      if not self.C:
         self.C=ATOM3String('')

   def show(self, parent, parentWindowInfo=None):
      self.createComponents()
      ATOM3Type.show(self, parent, parentWindowInfo)
      self.containerFrame = Frame(parent)
      Label(self.containerFrame, text='ltypename').grid(row=0,column=0,sticky=W)
      self.ltypename.show(self.containerFrame, parentWindowInfo).grid(row=0,column=1,sticky=W)
      Label(self.containerFrame, text='A').grid(row=1,column=0,sticky=W)
      self.A.show(self.containerFrame, parentWindowInfo).grid(row=1,column=1,sticky=W)
      Label(self.containerFrame, text='B').grid(row=2,column=0,sticky=W)
      self.B.show(self.containerFrame, parentWindowInfo).grid(row=2,column=1,sticky=W)
      Label(self.containerFrame, text='C').grid(row=3,column=0,sticky=W)
      self.C.show(self.containerFrame, parentWindowInfo).grid(row=3,column=1,sticky=W)
      return self.containerFrame

   def toString(self):
      self.createComponents()
      return  self.ltypename.toString()+' '+ self.A.toString()+' '+ self.B.toString()+' '+ self.C.toString()
   def getValue(self):
      self.createComponents()
      return (self.ltypename.getValue(),self.A.getValue(),self.B.getValue(),self.C.getValue(),)

   def setValue(self, value):
      self.createComponents()
      if value == None:
         self.ltypename.setNone()
         self.A.setNone()
         self.B.setNone()
         self.C.setNone()
      else:
         self.ltypename.setValue(value[0])
         self.A.setValue(value[1])
         self.B.setValue(value[2])
         self.C.setValue(value[3])

   def writeConstructor2File(self, file, indent, objName="at", depth = 0, generatingCode = 0):
      self.createComponents()
      file.write(indent+objName+'= ltypenameXAXBXC()\n')
      self.ltypename.writeConstructor2File(file, indent, objName+'.ltypename', depth, generatingCode)
      self.A.writeConstructor2File(file, indent, objName+'.A', depth, generatingCode)
      self.B.writeConstructor2File(file, indent, objName+'.B', depth, generatingCode)
      self.C.writeConstructor2File(file, indent, objName+'.C', depth, generatingCode)

   def writeValue2File(self, file, indent, objName="at", depth = 0, generatingCode = 0):
      self.createComponents()
      self.ltypename.writeValue2File(file, indent, objName+'.ltypename', depth, generatingCode)
      self.A.writeValue2File(file, indent, objName+'.A', depth, generatingCode)
      self.B.writeValue2File(file, indent, objName+'.B', depth, generatingCode)
      self.C.writeValue2File(file, indent, objName+'.C', depth, generatingCode)

   def clone(self):
     "Makes an exact copy of itself"
     cloneObject = ltypenameXAXBXC()
     if self.ltypename: cloneObject.ltypename = self.ltypename.clone()
     if self.A: cloneObject.A = self.A.clone()
     if self.B: cloneObject.B = self.B.clone()
     if self.C: cloneObject.C = self.C.clone()
     return cloneObject
   def destroy(self):
     "Destroys (i.e. updates) each field"
     cloneObject = ltypenameXAXBXC()
     if self.ltypename: self.ltypename.destroy()
     if self.A: self.A.destroy()
     if self.B: self.B.destroy()
     if self.C: self.C.destroy()
     return cloneObject
