from graph_ASG_ERmetaMetaModel import *
from stickylink import *
from widthXfillXdecoration import *
from ASG_GPSSMetaModel import *
from ASG_GPSSMetaModel import *
from GPSSBlock import *
from Function import *
from Storage_Size import *
from Table import *
from SNAVariable import *
from connected_to import *
from ATOM3BottomType import *
from ATOM3String import *
from ATOM3Constraint import *
from ATOM3Attribute import *
from ATOM3Enum import *
from ATOM3Appearance import *
from ATOM3Float import *
from ATOM3Connection import *
from ATOM3Boolean import *
from ATOM3Link import *
from ATOM3Integer import *
from ATOM3List import *
from ATOM3Port import *

def manufacturing_1_GPSS_mdl(self, rootNode):
    rootNode.Name.setValue('Manufacturing shop model 1')
    rootNode.Control_Statements.setActionFlags([ 1, 1, 1, 0])
    lcobj1 =[]
    cobj1= ltypenameXAXBXC()
    cobj1.ltypename=ATOM3Enum(['START', 'CLEAR', 'RESET'],0,0)
    cobj1.A=ATOM3String('1000')
    cobj1.B=ATOM3String('')
    cobj1.C=ATOM3String('')
    lcobj1.append(cobj1)
    rootNode.Control_Statements.setValue(lcobj1)
    rootNode.Author.setValue('G. Gordon Figure 11-3/9-2')

    self.globalPrecondition( rootNode )

    self.obj35=GPSSBlock(self)

    self.obj35.A.setValue('5')
    self.obj35.C.setValue('')
    self.obj35.B.setValue('')
    self.obj35.E.setValue('')
    self.obj35.D.setValue('')
    self.obj35.F.setValue('')
    self.obj35.X.setValue('')
    self.obj35.Type.setValue( (['Advance', 'Assign', 'Depart', 'Enter', 'Gate', 'Generate', 'Leave', 'Link', 'Logic', 'Mark', 'Priority', 'Queue', 'Release', 'SaveValue', 'Seize', 'Tabulate', 'Terminate', 'Test', 'Transfer', 'Unlink'], 5) )
    self.obj35.Type.config = 0
    self.obj35.Comments.setValue('; Create parts')
    self.obj35.Label.setValue('L0')
    self.obj35.graphClass_= graph_GPSSBlock
    if self.genGraphics:
       from graph_Generate import *
       new_obj = graph_Generate(135.0,30.0,self.obj35)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("GPSSBlock", new_obj.tag)
    else: new_obj = None
    self.obj35.graphObject_ = new_obj
    rootNode.addNode(self.obj35)
    self.globalAndLocalPostcondition(self.obj35, rootNode)

    self.globalPrecondition( rootNode )

    self.obj38=GPSSBlock(self)

    self.obj38.A.setValue('4')
    self.obj38.C.setValue('')
    self.obj38.B.setValue('3')
    self.obj38.E.setValue('')
    self.obj38.D.setValue('')
    self.obj38.F.setValue('')
    self.obj38.X.setValue('')
    self.obj38.Type.setValue( (['Advance', 'Assign', 'Depart', 'Enter', 'Gate', 'Generate', 'Leave', 'Link', 'Logic', 'Mark', 'Priority', 'Queue', 'Release', 'SaveValue', 'Seize', 'Tabulate', 'Terminate', 'Test', 'Transfer', 'Unlink'], 0) )
    self.obj38.Type.config = 0
    self.obj38.Comments.setValue('; Inspect')
    self.obj38.Label.setValue('L1')
    self.obj38.graphClass_= graph_GPSSBlock
    if self.genGraphics:
       from graph_Advance import *
       new_obj = graph_Advance(134.0,123.0,self.obj38)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("GPSSBlock", new_obj.tag)
    else: new_obj = None
    self.obj38.graphObject_ = new_obj
    rootNode.addNode(self.obj38)
    self.globalAndLocalPostcondition(self.obj38, rootNode)

    self.globalPrecondition( rootNode )

    self.obj41=GPSSBlock(self)

    self.obj41.A.setValue('.1')
    self.obj41.C.setValue('REJ')
    self.obj41.B.setValue('ACC')
    self.obj41.E.setValue('')
    self.obj41.D.setValue('')
    self.obj41.F.setValue('')
    self.obj41.X.setValue('')
    self.obj41.Type.setValue( (['Advance', 'Assign', 'Depart', 'Enter', 'Gate', 'Generate', 'Leave', 'Link', 'Logic', 'Mark', 'Priority', 'Queue', 'Release', 'SaveValue', 'Seize', 'Tabulate', 'Terminate', 'Test', 'Transfer', 'Unlink'], 18) )
    self.obj41.Type.config = 0
    self.obj41.Comments.setValue('; Randomly determine defective parts')
    self.obj41.Label.setValue('L2')
    self.obj41.graphClass_= graph_GPSSBlock
    if self.genGraphics:
       from graph_Transfer import *
       new_obj = graph_Transfer(127.0,219.0,self.obj41)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("GPSSBlock", new_obj.tag)
    else: new_obj = None
    self.obj41.graphObject_ = new_obj
    rootNode.addNode(self.obj41)
    self.globalAndLocalPostcondition(self.obj41, rootNode)

    self.globalPrecondition( rootNode )

    self.obj44=GPSSBlock(self)

    self.obj44.A.setValue('1')
    self.obj44.C.setValue('')
    self.obj44.B.setValue('')
    self.obj44.E.setValue('')
    self.obj44.D.setValue('')
    self.obj44.F.setValue('')
    self.obj44.X.setValue('')
    self.obj44.Type.setValue( (['Advance', 'Assign', 'Depart', 'Enter', 'Gate', 'Generate', 'Leave', 'Link', 'Logic', 'Mark', 'Priority', 'Queue', 'Release', 'SaveValue', 'Seize', 'Tabulate', 'Terminate', 'Test', 'Transfer', 'Unlink'], 16) )
    self.obj44.Type.config = 0
    self.obj44.Comments.setValue('; Accepted parts')
    self.obj44.Label.setValue('ACC')
    self.obj44.graphClass_= graph_GPSSBlock
    if self.genGraphics:
       from graph_Terminate import *
       new_obj = graph_Terminate(143.0,323.0,self.obj44)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("GPSSBlock", new_obj.tag)
    else: new_obj = None
    self.obj44.graphObject_ = new_obj
    rootNode.addNode(self.obj44)
    self.globalAndLocalPostcondition(self.obj44, rootNode)

    self.globalPrecondition( rootNode )

    self.obj45=GPSSBlock(self)

    self.obj45.A.setValue('1')
    self.obj45.C.setValue('')
    self.obj45.B.setValue('')
    self.obj45.E.setValue('')
    self.obj45.D.setValue('')
    self.obj45.F.setValue('')
    self.obj45.X.setValue('')
    self.obj45.Type.setValue( (['Advance', 'Assign', 'Depart', 'Enter', 'Gate', 'Generate', 'Leave', 'Link', 'Logic', 'Mark', 'Priority', 'Queue', 'Release', 'SaveValue', 'Seize', 'Tabulate', 'Terminate', 'Test', 'Transfer', 'Unlink'], 16) )
    self.obj45.Type.config = 0
    self.obj45.Comments.setValue('; Rejected parts')
    self.obj45.Label.setValue('REJ')
    self.obj45.graphClass_= graph_GPSSBlock
    if self.genGraphics:
       from graph_Terminate import *
       new_obj = graph_Terminate(271.0,220.0,self.obj45)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("GPSSBlock", new_obj.tag)
    else: new_obj = None
    self.obj45.graphObject_ = new_obj
    rootNode.addNode(self.obj45)
    self.globalAndLocalPostcondition(self.obj45, rootNode)

    self.globalPrecondition( rootNode )

    self.obj50=connected_to(self)

    self.obj50.graphClass_= graph_connected_to
    if self.genGraphics:
       from graph_connected_to import *
       new_obj = graph_connected_to(175.5,105.5,self.obj50)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("connected_to", new_obj.tag)
    else: new_obj = None
    self.obj50.graphObject_ = new_obj
    rootNode.addNode(self.obj50)
    self.globalAndLocalPostcondition(self.obj50, rootNode)

    self.globalPrecondition( rootNode )

    self.obj51=connected_to(self)

    self.obj51.graphClass_= graph_connected_to
    if self.genGraphics:
       from graph_connected_to import *
       new_obj = graph_connected_to(174.0,203.0,self.obj51)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("connected_to", new_obj.tag)
    else: new_obj = None
    self.obj51.graphObject_ = new_obj
    rootNode.addNode(self.obj51)
    self.globalAndLocalPostcondition(self.obj51, rootNode)

    self.globalPrecondition( rootNode )

    self.obj52=connected_to(self)

    self.obj52.graphClass_= graph_connected_to
    if self.genGraphics:
       from graph_connected_to import *
       new_obj = graph_connected_to(173.0,304.5,self.obj52)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("connected_to", new_obj.tag)
    else: new_obj = None
    self.obj52.graphObject_ = new_obj
    rootNode.addNode(self.obj52)
    self.globalAndLocalPostcondition(self.obj52, rootNode)

    self.globalPrecondition( rootNode )

    self.obj53=connected_to(self)

    self.obj53.graphClass_= graph_connected_to
    if self.genGraphics:
       from graph_connected_to import *
       new_obj = graph_connected_to(250.0,252.0,self.obj53)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("connected_to", new_obj.tag)
    else: new_obj = None
    self.obj53.graphObject_ = new_obj
    rootNode.addNode(self.obj53)
    self.globalAndLocalPostcondition(self.obj53, rootNode)
    self.drawConnections((self.obj35,self.obj50,[175.0, 84.0, 175.5, 105.5], 0, 2), (self.obj38,self.obj51,[174.0, 176.0, 174.0, 203.0], 0, 2), (self.obj41,self.obj52,[174.0, 285.0, 173.0, 304.5], 0, 2), (self.obj41,self.obj53,[219.0, 253.0, 250.0, 252.0], 0, 2), (self.obj50,self.obj38,[175.5, 105.5, 175.0, 126.0], 0, 2), (self.obj51,self.obj41,[174.0, 203.0, 173.0, 222.0], 0, 2), (self.obj52,self.obj44,[173.0, 304.5, 174.0, 326.0], 0, 2), (self.obj53,self.obj45,[250.0, 252.0, 274.0, 252.0], 0, 2) )

newfunction = manufacturing_1_GPSS_mdl

loadedMMName = 'GPSSMetaModel'
