from graph_ASG_ERmetaMetaModel import *
from stickylink import *
from widthXfillXdecoration import *
from ASG_GPSSMetaModel import *
from ASG_GPSSMetaModel import *
from GPSSBlock import *
from Function import *
from Storage_Size import *
from Table import *
from SNAVariable import *
from connected_to import *
from ATOM3BottomType import *
from ATOM3String import *
from ATOM3Constraint import *
from ATOM3Attribute import *
from ATOM3Enum import *
from ATOM3Appearance import *
from ATOM3Float import *
from ATOM3Connection import *
from ATOM3Boolean import *
from ATOM3Link import *
from ATOM3Integer import *
from ATOM3List import *
from ATOM3Port import *

def manufacturing_4_GPSS_mdl(self, rootNode):
    rootNode.Name.setValue('Manufacturing shop model 4')
    rootNode.Control_Statements.setActionFlags([ 1, 1, 1, 0])
    lcobj1 =[]
    cobj1= ltypenameXAXBXC()
    cobj1.ltypename=ATOM3Enum(['START', 'CLEAR', 'RESET'],0,0)
    cobj1.A=ATOM3String('1000')
    cobj1.B=ATOM3String('')
    cobj1.C=ATOM3String('')
    lcobj1.append(cobj1)
    rootNode.Control_Statements.setValue(lcobj1)
    rootNode.Author.setValue('G. Gordon Figure 11-9/9-8')

    self.globalPrecondition( rootNode )

    self.obj26=GPSSBlock(self)

    self.obj26.A.setValue('5')
    self.obj26.C.setValue('')
    self.obj26.B.setValue('')
    self.obj26.E.setValue('')
    self.obj26.D.setValue('')
    self.obj26.F.setValue('')
    self.obj26.X.setValue('')
    self.obj26.Type.setValue( (['Advance', 'Assign', 'Depart', 'Enter', 'Gate', 'Generate', 'Leave', 'Link', 'Logic', 'Mark', 'Priority', 'Queue', 'Release', 'SaveValue', 'Seize', 'Tabulate', 'Terminate', 'Test', 'Transfer', 'Unlink'], 5) )
    self.obj26.Type.config = 0
    self.obj26.Comments.setValue('; Create parts')
    self.obj26.Label.setValue('L0')
    self.obj26.graphClass_= graph_GPSSBlock
    if self.genGraphics:
       from graph_Generate import *
       new_obj = graph_Generate(133.0,5.0,self.obj26)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("GPSSBlock", new_obj.tag)
    else: new_obj = None
    self.obj26.graphObject_ = new_obj
    rootNode.addNode(self.obj26)
    self.globalAndLocalPostcondition(self.obj26, rootNode)

    self.globalPrecondition( rootNode )

    self.obj27=GPSSBlock(self)

    self.obj27.A.setValue('12')
    self.obj27.C.setValue('')
    self.obj27.B.setValue('9')
    self.obj27.E.setValue('')
    self.obj27.D.setValue('')
    self.obj27.F.setValue('')
    self.obj27.X.setValue('')
    self.obj27.Type.setValue( (['Advance', 'Assign', 'Depart', 'Enter', 'Gate', 'Generate', 'Leave', 'Link', 'Logic', 'Mark', 'Priority', 'Queue', 'Release', 'SaveValue', 'Seize', 'Tabulate', 'Terminate', 'Test', 'Transfer', 'Unlink'], 0) )
    self.obj27.Type.config = 0
    self.obj27.Comments.setValue('; Inspect')
    self.obj27.Label.setValue('L1')
    self.obj27.graphClass_= graph_GPSSBlock
    if self.genGraphics:
       from graph_Advance import *
       new_obj = graph_Advance(329.0,86.0,self.obj27)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("GPSSBlock", new_obj.tag)
    else: new_obj = None
    self.obj27.graphObject_ = new_obj
    rootNode.addNode(self.obj27)
    self.globalAndLocalPostcondition(self.obj27, rootNode)

    self.globalPrecondition( rootNode )

    self.obj28=GPSSBlock(self)

    self.obj28.A.setValue('.1')
    self.obj28.C.setValue('REJ')
    self.obj28.B.setValue('ACC')
    self.obj28.E.setValue('')
    self.obj28.D.setValue('')
    self.obj28.F.setValue('')
    self.obj28.X.setValue('')
    self.obj28.Type.setValue( (['Advance', 'Assign', 'Depart', 'Enter', 'Gate', 'Generate', 'Leave', 'Link', 'Logic', 'Mark', 'Priority', 'Queue', 'Release', 'SaveValue', 'Seize', 'Tabulate', 'Terminate', 'Test', 'Transfer', 'Unlink'], 18) )
    self.obj28.Type.config = 0
    self.obj28.Comments.setValue('; Randomly determine defective parts')
    self.obj28.Label.setValue('L2')
    self.obj28.graphClass_= graph_GPSSBlock
    if self.genGraphics:
       from graph_Transfer import *
       new_obj = graph_Transfer(323.0,321.0,self.obj28)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("GPSSBlock", new_obj.tag)
    else: new_obj = None
    self.obj28.graphObject_ = new_obj
    rootNode.addNode(self.obj28)
    self.globalAndLocalPostcondition(self.obj28, rootNode)

    self.globalPrecondition( rootNode )

    self.obj29=GPSSBlock(self)

    self.obj29.A.setValue('1')
    self.obj29.C.setValue('')
    self.obj29.B.setValue('')
    self.obj29.E.setValue('')
    self.obj29.D.setValue('')
    self.obj29.F.setValue('')
    self.obj29.X.setValue('')
    self.obj29.Type.setValue( (['Advance', 'Assign', 'Depart', 'Enter', 'Gate', 'Generate', 'Leave', 'Link', 'Logic', 'Mark', 'Priority', 'Queue', 'Release', 'SaveValue', 'Seize', 'Tabulate', 'Terminate', 'Test', 'Transfer', 'Unlink'], 16) )
    self.obj29.Type.config = 0
    self.obj29.Comments.setValue('; Accepted parts')
    self.obj29.Label.setValue('ACC')
    self.obj29.graphClass_= graph_GPSSBlock
    if self.genGraphics:
       from graph_Terminate import *
       new_obj = graph_Terminate(339.0,420.0,self.obj29)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("GPSSBlock", new_obj.tag)
    else: new_obj = None
    self.obj29.graphObject_ = new_obj
    rootNode.addNode(self.obj29)
    self.globalAndLocalPostcondition(self.obj29, rootNode)

    self.globalPrecondition( rootNode )

    self.obj30=GPSSBlock(self)

    self.obj30.A.setValue('1')
    self.obj30.C.setValue('')
    self.obj30.B.setValue('')
    self.obj30.E.setValue('')
    self.obj30.D.setValue('')
    self.obj30.F.setValue('')
    self.obj30.X.setValue('')
    self.obj30.Type.setValue( (['Advance', 'Assign', 'Depart', 'Enter', 'Gate', 'Generate', 'Leave', 'Link', 'Logic', 'Mark', 'Priority', 'Queue', 'Release', 'SaveValue', 'Seize', 'Tabulate', 'Terminate', 'Test', 'Transfer', 'Unlink'], 16) )
    self.obj30.Type.config = 0
    self.obj30.Comments.setValue('; Rejected parts')
    self.obj30.Label.setValue('REJ')
    self.obj30.graphClass_= graph_GPSSBlock
    if self.genGraphics:
       from graph_Terminate import *
       new_obj = graph_Terminate(471.0,322.0,self.obj30)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("GPSSBlock", new_obj.tag)
    else: new_obj = None
    self.obj30.graphObject_ = new_obj
    rootNode.addNode(self.obj30)
    self.globalAndLocalPostcondition(self.obj30, rootNode)

    self.globalPrecondition( rootNode )

    self.obj31=GPSSBlock(self)

    self.obj31.A.setValue('INSPECTR')
    self.obj31.C.setValue('')
    self.obj31.B.setValue('1')
    self.obj31.E.setValue('')
    self.obj31.D.setValue('')
    self.obj31.F.setValue('')
    self.obj31.X.setValue('')
    self.obj31.Type.setValue( (['Advance', 'Assign', 'Depart', 'Enter', 'Gate', 'Generate', 'Leave', 'Link', 'Logic', 'Mark', 'Priority', 'Queue', 'Release', 'SaveValue', 'Seize', 'Tabulate', 'Terminate', 'Test', 'Transfer', 'Unlink'], 3) )
    self.obj31.Type.config = 0
    self.obj31.Comments.setValue('; A single inspector becomes busy')
    self.obj31.Label.setValue('L5')
    self.obj31.graphClass_= graph_GPSSBlock
    if self.genGraphics:
       from graph_Enter import *
       new_obj = graph_Enter(123.0,162.0,self.obj31)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("GPSSBlock", new_obj.tag)
    else: new_obj = None
    self.obj31.graphObject_ = new_obj
    rootNode.addNode(self.obj31)
    self.globalAndLocalPostcondition(self.obj31, rootNode)

    self.globalPrecondition( rootNode )

    self.obj32=GPSSBlock(self)

    self.obj32.A.setValue('INSPECTR')
    self.obj32.C.setValue('')
    self.obj32.B.setValue('1')
    self.obj32.E.setValue('')
    self.obj32.D.setValue('')
    self.obj32.F.setValue('')
    self.obj32.X.setValue('')
    self.obj32.Type.setValue( (['Advance', 'Assign', 'Depart', 'Enter', 'Gate', 'Generate', 'Leave', 'Link', 'Logic', 'Mark', 'Priority', 'Queue', 'Release', 'SaveValue', 'Seize', 'Tabulate', 'Terminate', 'Test', 'Transfer', 'Unlink'], 6) )
    self.obj32.Type.config = 0
    self.obj32.Comments.setValue('; Make the inspector idle again')
    self.obj32.Label.setValue('L6')
    self.obj32.graphClass_= graph_GPSSBlock
    if self.genGraphics:
       from graph_Leave import *
       new_obj = graph_Leave(318.0,154.0,self.obj32)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("GPSSBlock", new_obj.tag)
    else: new_obj = None
    self.obj32.graphObject_ = new_obj
    rootNode.addNode(self.obj32)
    self.globalAndLocalPostcondition(self.obj32, rootNode)

    self.globalPrecondition( rootNode )

    self.obj208=GPSSBlock(self)

    self.obj208.A.setValue('INSPQ')
    self.obj208.C.setValue('')
    self.obj208.B.setValue('')
    self.obj208.E.setValue('')
    self.obj208.D.setValue('')
    self.obj208.F.setValue('')
    self.obj208.X.setValue('')
    self.obj208.Type.setValue( (['Advance', 'Assign', 'Depart', 'Enter', 'Gate', 'Generate', 'Leave', 'Link', 'Logic', 'Mark', 'Priority', 'Queue', 'Release', 'SaveValue', 'Seize', 'Tabulate', 'Terminate', 'Test', 'Transfer', 'Unlink'], 11) )
    self.obj208.Type.config = 0
    self.obj208.Comments.setValue('; Queue for an inspector')
    self.obj208.Label.setValue('L7')
    self.obj208.graphClass_= graph_GPSSBlock
    if self.genGraphics:
       from graph_Queue import *
       new_obj = graph_Queue(133.0,80.0,self.obj208)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("GPSSBlock", new_obj.tag)
    else: new_obj = None
    self.obj208.graphObject_ = new_obj
    rootNode.addNode(self.obj208)
    self.globalAndLocalPostcondition(self.obj208, rootNode)

    self.globalPrecondition( rootNode )

    self.obj211=GPSSBlock(self)

    self.obj211.A.setValue('INSPQ')
    self.obj211.C.setValue('')
    self.obj211.B.setValue('')
    self.obj211.E.setValue('')
    self.obj211.D.setValue('')
    self.obj211.F.setValue('')
    self.obj211.X.setValue('')
    self.obj211.Type.setValue( (['Advance', 'Assign', 'Depart', 'Enter', 'Gate', 'Generate', 'Leave', 'Link', 'Logic', 'Mark', 'Priority', 'Queue', 'Release', 'SaveValue', 'Seize', 'Tabulate', 'Terminate', 'Test', 'Transfer', 'Unlink'], 2) )
    self.obj211.Type.config = 0
    self.obj211.Comments.setValue('; Leave the inspector queue')
    self.obj211.Label.setValue('L8')
    self.obj211.graphClass_= graph_GPSSBlock
    if self.genGraphics:
       from graph_Depart import *
       new_obj = graph_Depart(131.0,247.0,self.obj211)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("GPSSBlock", new_obj.tag)
    else: new_obj = None
    self.obj211.graphObject_ = new_obj
    rootNode.addNode(self.obj211)
    self.globalAndLocalPostcondition(self.obj211, rootNode)

    self.globalPrecondition( rootNode )

    self.obj214=GPSSBlock(self)

    self.obj214.A.setValue('')
    self.obj214.C.setValue('')
    self.obj214.B.setValue('')
    self.obj214.E.setValue('')
    self.obj214.D.setValue('')
    self.obj214.F.setValue('')
    self.obj214.X.setValue('')
    self.obj214.Type.setValue( (['Advance', 'Assign', 'Depart', 'Enter', 'Gate', 'Generate', 'Leave', 'Link', 'Logic', 'Mark', 'Priority', 'Queue', 'Release', 'SaveValue', 'Seize', 'Tabulate', 'Terminate', 'Test', 'Transfer', 'Unlink'], 9) )
    self.obj214.Type.config = 0
    self.obj214.Comments.setValue('; Start counting transit time')
    self.obj214.Label.setValue('L9')
    self.obj214.graphClass_= graph_GPSSBlock
    if self.genGraphics:
       from graph_Mark import *
       new_obj = graph_Mark(310.0,22.0,self.obj214)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("GPSSBlock", new_obj.tag)
    else: new_obj = None
    self.obj214.graphObject_ = new_obj
    rootNode.addNode(self.obj214)
    self.globalAndLocalPostcondition(self.obj214, rootNode)

    self.globalPrecondition( rootNode )

    self.obj222=GPSSBlock(self)

    self.obj222.A.setValue('TRANSIT')
    self.obj222.C.setValue('')
    self.obj222.B.setValue('')
    self.obj222.E.setValue('')
    self.obj222.D.setValue('')
    self.obj222.F.setValue('')
    self.obj222.X.setValue('')
    self.obj222.Type.setValue( (['Advance', 'Assign', 'Depart', 'Enter', 'Gate', 'Generate', 'Leave', 'Link', 'Logic', 'Mark', 'Priority', 'Queue', 'Release', 'SaveValue', 'Seize', 'Tabulate', 'Terminate', 'Test', 'Transfer', 'Unlink'], 15) )
    self.obj222.Type.config = 0
    self.obj222.Comments.setValue('; Tabulate parts\' transit time')
    self.obj222.Label.setValue('L10')
    self.obj222.graphClass_= graph_GPSSBlock
    if self.genGraphics:
       from graph_Tabulate import *
       new_obj = graph_Tabulate(319.0,242.0,self.obj222)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("GPSSBlock", new_obj.tag)
    else: new_obj = None
    self.obj222.graphObject_ = new_obj
    rootNode.addNode(self.obj222)
    self.globalAndLocalPostcondition(self.obj222, rootNode)

    self.globalPrecondition( rootNode )

    self.obj49=Storage_Size(self)

    self.obj49.Storage_Size.setValue(3)
    self.obj49.Storage_Name.setValue('INSPECTR')
    self.obj49.graphClass_= graph_Storage_Size
    if self.genGraphics:
       from graph_Storage_Size import *
       new_obj = graph_Storage_Size(7.0,155.0,self.obj49)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("Storage_Size", new_obj.tag)
    else: new_obj = None
    self.obj49.graphObject_ = new_obj
    rootNode.addNode(self.obj49)
    self.globalAndLocalPostcondition(self.obj49, rootNode)

    self.globalPrecondition( rootNode )

    self.obj227=Table(self)

    self.obj227.Lower_Limit.setValue('5')
    self.obj227.Interval_Size.setValue('5')
    self.obj227.Type.setValue('M1')
    self.obj227.Number_Of_Intervals.setValue('10')
    self.obj227.Label.setValue('TRANSIT')
    self.obj227.graphClass_= graph_Table
    if self.genGraphics:
       from graph_Table import *
       new_obj = graph_Table(498.0,227.0,self.obj227)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("Table", new_obj.tag)
    else: new_obj = None
    self.obj227.graphObject_ = new_obj
    rootNode.addNode(self.obj227)
    self.globalAndLocalPostcondition(self.obj227, rootNode)

    self.globalPrecondition( rootNode )

    self.obj33=connected_to(self)

    self.obj33.graphClass_= graph_connected_to
    if self.genGraphics:
       from graph_connected_to import *
       new_obj = graph_connected_to(371.0,402.5,self.obj33)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("connected_to", new_obj.tag)
    else: new_obj = None
    self.obj33.graphObject_ = new_obj
    rootNode.addNode(self.obj33)
    self.globalAndLocalPostcondition(self.obj33, rootNode)

    self.globalPrecondition( rootNode )

    self.obj34=connected_to(self)

    self.obj34.graphClass_= graph_connected_to
    if self.genGraphics:
       from graph_connected_to import *
       new_obj = graph_connected_to(450.0,354.0,self.obj34)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("connected_to", new_obj.tag)
    else: new_obj = None
    self.obj34.graphObject_ = new_obj
    rootNode.addNode(self.obj34)
    self.globalAndLocalPostcondition(self.obj34, rootNode)

    self.globalPrecondition( rootNode )

    self.obj37=connected_to(self)

    self.obj37.graphClass_= graph_connected_to
    if self.genGraphics:
       from graph_connected_to import *
       new_obj = graph_connected_to(368.5,149.0,self.obj37)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("connected_to", new_obj.tag)
    else: new_obj = None
    self.obj37.graphObject_ = new_obj
    rootNode.addNode(self.obj37)
    self.globalAndLocalPostcondition(self.obj37, rootNode)

    self.globalPrecondition( rootNode )

    self.obj217=connected_to(self)

    self.obj217.graphClass_= graph_connected_to
    if self.genGraphics:
       from graph_connected_to import *
       new_obj = graph_connected_to(174.0,67.5,self.obj217)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("connected_to", new_obj.tag)
    else: new_obj = None
    self.obj217.graphObject_ = new_obj
    rootNode.addNode(self.obj217)
    self.globalAndLocalPostcondition(self.obj217, rootNode)

    self.globalPrecondition( rootNode )

    self.obj218=connected_to(self)

    self.obj218.graphClass_= graph_connected_to
    if self.genGraphics:
       from graph_connected_to import *
       new_obj = graph_connected_to(174.0,147.0,self.obj218)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("connected_to", new_obj.tag)
    else: new_obj = None
    self.obj218.graphObject_ = new_obj
    rootNode.addNode(self.obj218)
    self.globalAndLocalPostcondition(self.obj218, rootNode)

    self.globalPrecondition( rootNode )

    self.obj219=connected_to(self)

    self.obj219.graphClass_= graph_connected_to
    if self.genGraphics:
       from graph_connected_to import *
       new_obj = graph_connected_to(173.0,232.5,self.obj219)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("connected_to", new_obj.tag)
    else: new_obj = None
    self.obj219.graphObject_ = new_obj
    rootNode.addNode(self.obj219)
    self.globalAndLocalPostcondition(self.obj219, rootNode)

    self.globalPrecondition( rootNode )

    self.obj220=connected_to(self)

    self.obj220.graphClass_= graph_connected_to
    if self.genGraphics:
       from graph_connected_to import *
       new_obj = graph_connected_to(171.0,313.5,self.obj220)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("connected_to", new_obj.tag)
    else: new_obj = None
    self.obj220.graphObject_ = new_obj
    rootNode.addNode(self.obj220)
    self.globalAndLocalPostcondition(self.obj220, rootNode)

    self.globalPrecondition( rootNode )

    self.obj221=connected_to(self)

    self.obj221.graphClass_= graph_connected_to
    if self.genGraphics:
       from graph_connected_to import *
       new_obj = graph_connected_to(371.0,77.0,self.obj221)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("connected_to", new_obj.tag)
    else: new_obj = None
    self.obj221.graphObject_ = new_obj
    rootNode.addNode(self.obj221)
    self.globalAndLocalPostcondition(self.obj221, rootNode)

    self.globalPrecondition( rootNode )

    self.obj225=connected_to(self)

    self.obj225.graphClass_= graph_connected_to
    if self.genGraphics:
       from graph_connected_to import *
       new_obj = graph_connected_to(366.5,230.5,self.obj225)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("connected_to", new_obj.tag)
    else: new_obj = None
    self.obj225.graphObject_ = new_obj
    rootNode.addNode(self.obj225)
    self.globalAndLocalPostcondition(self.obj225, rootNode)

    self.globalPrecondition( rootNode )

    self.obj226=connected_to(self)

    self.obj226.graphClass_= graph_connected_to
    if self.genGraphics:
       from graph_connected_to import *
       new_obj = graph_connected_to(369.0,316.0,self.obj226)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("connected_to", new_obj.tag)
    else: new_obj = None
    self.obj226.graphObject_ = new_obj
    rootNode.addNode(self.obj226)
    self.globalAndLocalPostcondition(self.obj226, rootNode)
    self.drawConnections((self.obj26,self.obj217,[173.0, 59.0, 174.0, 67.5], 0, 2), (self.obj27,self.obj37,[369.0, 139.0, 368.5, 149.0], 0, 2), (self.obj28,self.obj33,[370.0, 387.0, 371.0, 402.5], 0, 2), (self.obj28,self.obj34,[415.0, 355.0, 450.0, 354.0], 0, 2), (self.obj31,self.obj219,[173.0, 223.0, 173.0, 232.5], 0, 2), (self.obj32,self.obj225,[368.0, 221.0, 366.5, 230.5], 0, 2), (self.obj208,self.obj218,[173.0, 137.0, 174.0, 147.0], 0, 2), (self.obj211,self.obj220,[171.0, 298.0, 171.0, 313.5], 0, 2), (self.obj214,self.obj221,[370.0, 69.0, 371.0, 77.0], 0, 2), (self.obj222,self.obj226,[369.0, 303.0, 369.0, 316.0], 0, 2), (self.obj33,self.obj29,[371.0, 402.5, 370.0, 423.0], 0, 2), (self.obj34,self.obj30,[450.0, 354.0, 474.0, 354.0], 0, 2), (self.obj37,self.obj32,[368.5, 149.0, 368.0, 163.0], 0, 2), (self.obj217,self.obj208,[174.0, 67.5, 174.0, 89.0], 0, 2), (self.obj218,self.obj31,[174.0, 147.0, 173.0, 165.0], 0, 2), (self.obj219,self.obj211,[173.0, 232.5, 172.0, 250.0], 0, 2), (self.obj220,self.obj214,[171.0, 313.5, 276.0, 313.0, 275.0, 18.0, 372.0, 18.0, 370.0, 30.0], 0, 5), (self.obj221,self.obj27,[371.0, 77.0, 370.0, 89.0], 0, 2), (self.obj225,self.obj222,[366.5, 230.5, 369.0, 245.0], 0, 2), (self.obj226,self.obj28,[369.0, 316.0, 369.0, 324.0], 0, 2) )

newfunction = manufacturing_4_GPSS_mdl

loadedMMName = 'GPSSMetaModel'
