from graph_ASG_ERmetaMetaModel import *
from stickylink import *
from widthXfillXdecoration import *
from ASG_GPSSMetaModel import *
from ASG_GPSSMetaModel import *
from GPSSBlock import *
from Function import *
from Storage_Size import *
from Table import *
from SNAVariable import *
from connected_to import *
from ControlStatement import *
from ATOM3BottomType import *
from ATOM3String import *
from ATOM3Constraint import *
from ATOM3Attribute import *
from ATOM3Enum import *
from ATOM3Appearance import *
from ATOM3Float import *
from ATOM3Connection import *
from ATOM3Boolean import *
from ATOM3Link import *
from Point import *
from ATOM3Integer import *
from ATOM3List import *
from ATOM3Port import *

def supermarket_1_GPSS_mdl(self, rootNode):
    rootNode.Name.setValue('Supermarket simulation 1')
    rootNode.Control_Statements.setActionFlags([ 1, 1, 1, 0])
    lcobj1 =[]
    cobj1= ltypenameXAXBXC()
    cobj1.ltypename=ATOM3Enum(['START', 'CLEAR', 'RESET'],0,0)
    cobj1.A=ATOM3String('50')
    cobj1.B=ATOM3String('NP')
    cobj1.C=ATOM3String('')
    lcobj1.append(cobj1)
    cobj1= ltypenameXAXBXC()
    cobj1.ltypename=ATOM3Enum(['START', 'CLEAR', 'RESET'],2,0)
    cobj1.A=ATOM3String('')
    cobj1.B=ATOM3String('')
    cobj1.C=ATOM3String('')
    lcobj1.append(cobj1)
    cobj1= ltypenameXAXBXC()
    cobj1.ltypename=ATOM3Enum(['START', 'CLEAR', 'RESET'],0,0)
    cobj1.A=ATOM3String('1000')
    cobj1.B=ATOM3String('')
    cobj1.C=ATOM3String('')
    lcobj1.append(cobj1)
    rootNode.Control_Statements.setValue(lcobj1)
    rootNode.Author.setValue('G. Gordon. Figure 12-4/10-2')

    self.globalPrecondition( rootNode )

    self.obj614=GPSSBlock(self)

    self.obj614.A.setValue('36')
    self.obj614.C.setValue('')
    self.obj614.B.setValue('FN$POISS')
    self.obj614.E.setValue('')
    self.obj614.D.setValue('')
    self.obj614.F.setValue('')
    self.obj614.X.setValue('')
    self.obj614.Type.setValue( (['Advance', 'Assign', 'Depart', 'Enter', 'Gate', 'Generate', 'Leave', 'Link', 'Logic', 'Mark', 'Priority', 'Queue', 'Release', 'SaveValue', 'Seize', 'Tabulate', 'Terminate', 'Test', 'Transfer', 'Unlink'], 5) )
    self.obj614.Type.config = 0
    self.obj614.Comments.setValue('; Poisson distributed arrival of customers.')
    self.obj614.Label.setValue('L0')
    self.obj614.graphClass_= graph_GPSSBlock
    if self.genGraphics:
       from graph_Generate import *
       new_obj = graph_Generate(169.0,44.0,self.obj614)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("GPSSBlock", new_obj.tag)
    else: new_obj = None
    self.obj614.graphObject_ = new_obj
    rootNode.addNode(self.obj614)
    self.globalAndLocalPostcondition(self.obj614, rootNode)

    self.globalPrecondition( rootNode )

    self.obj615=GPSSBlock(self)

    self.obj615.A.setValue('')
    self.obj615.C.setValue('')
    self.obj615.B.setValue('')
    self.obj615.E.setValue('')
    self.obj615.D.setValue('')
    self.obj615.F.setValue('')
    self.obj615.X.setValue('')
    self.obj615.Type.setValue( (['Advance', 'Assign', 'Depart', 'Enter', 'Gate', 'Generate', 'Leave', 'Link', 'Logic', 'Mark', 'Priority', 'Queue', 'Release', 'SaveValue', 'Seize', 'Tabulate', 'Terminate', 'Test', 'Transfer', 'Unlink'], 16) )
    self.obj615.Type.config = 0
    self.obj615.Comments.setValue('; Lost customers')
    self.obj615.Label.setValue('AWAY')
    self.obj615.graphClass_= graph_GPSSBlock
    if self.genGraphics:
       from graph_Terminate import *
       new_obj = graph_Terminate(30.0,172.0,self.obj615)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("GPSSBlock", new_obj.tag)
    else: new_obj = None
    self.obj615.graphObject_ = new_obj
    rootNode.addNode(self.obj615)
    self.globalAndLocalPostcondition(self.obj615, rootNode)

    self.globalPrecondition( rootNode )

    self.obj617=GPSSBlock(self)

    self.obj617.A.setValue('BSKTS')
    self.obj617.C.setValue('')
    self.obj617.B.setValue('')
    self.obj617.E.setValue('')
    self.obj617.D.setValue('')
    self.obj617.F.setValue('')
    self.obj617.X.setValue('')
    self.obj617.Type.setValue( (['Advance', 'Assign', 'Depart', 'Enter', 'Gate', 'Generate', 'Leave', 'Link', 'Logic', 'Mark', 'Priority', 'Queue', 'Release', 'SaveValue', 'Seize', 'Tabulate', 'Terminate', 'Test', 'Transfer', 'Unlink'], 3) )
    self.obj617.Type.config = 0
    self.obj617.Comments.setValue('')
    self.obj617.Label.setValue('L3')
    self.obj617.graphClass_= graph_GPSSBlock
    if self.genGraphics:
       from graph_Enter import *
       new_obj = graph_Enter(159.0,208.0,self.obj617)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("GPSSBlock", new_obj.tag)
    else: new_obj = None
    self.obj617.graphObject_ = new_obj
    rootNode.addNode(self.obj617)
    self.globalAndLocalPostcondition(self.obj617, rootNode)

    self.globalPrecondition( rootNode )

    self.obj619=GPSSBlock(self)

    self.obj619.A.setValue('IS')
    self.obj619.C.setValue('')
    self.obj619.B.setValue('FN$IS')
    self.obj619.E.setValue('')
    self.obj619.D.setValue('')
    self.obj619.F.setValue('')
    self.obj619.X.setValue('')
    self.obj619.Type.setValue( (['Advance', 'Assign', 'Depart', 'Enter', 'Gate', 'Generate', 'Leave', 'Link', 'Logic', 'Mark', 'Priority', 'Queue', 'Release', 'SaveValue', 'Seize', 'Tabulate', 'Terminate', 'Test', 'Transfer', 'Unlink'], 1) )
    self.obj619.Type.config = 0
    self.obj619.Comments.setValue('; Determine nr. of items. Store in parameter P$IS')
    self.obj619.Label.setValue('L5')
    self.obj619.graphClass_= graph_GPSSBlock
    if self.genGraphics:
       from graph_Assign import *
       new_obj = graph_Assign(127.0,302.0,self.obj619)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("GPSSBlock", new_obj.tag)
    else: new_obj = None
    self.obj619.graphObject_ = new_obj
    rootNode.addNode(self.obj619)
    self.globalAndLocalPostcondition(self.obj619, rootNode)

    self.globalPrecondition( rootNode )

    self.obj625=GPSSBlock(self)

    self.obj625.A.setValue('1')
    self.obj625.C.setValue('')
    self.obj625.B.setValue('')
    self.obj625.E.setValue('')
    self.obj625.D.setValue('')
    self.obj625.F.setValue('')
    self.obj625.X.setValue('')
    self.obj625.Type.setValue( (['Advance', 'Assign', 'Depart', 'Enter', 'Gate', 'Generate', 'Leave', 'Link', 'Logic', 'Mark', 'Priority', 'Queue', 'Release', 'SaveValue', 'Seize', 'Tabulate', 'Terminate', 'Test', 'Transfer', 'Unlink'], 16) )
    self.obj625.Type.config = 0
    self.obj625.Comments.setValue('')
    self.obj625.Label.setValue('L11')
    self.obj625.graphClass_= graph_GPSSBlock
    if self.genGraphics:
       from graph_Terminate import *
       new_obj = graph_Terminate(388.0,780.0,self.obj625)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("GPSSBlock", new_obj.tag)
    else: new_obj = None
    self.obj625.graphObject_ = new_obj
    rootNode.addNode(self.obj625)
    self.globalAndLocalPostcondition(self.obj625, rootNode)

    self.globalPrecondition( rootNode )

    self.obj628=GPSSBlock(self)

    self.obj628.A.setValue('BSKTS')
    self.obj628.C.setValue('')
    self.obj628.B.setValue('')
    self.obj628.E.setValue('')
    self.obj628.D.setValue('')
    self.obj628.F.setValue('')
    self.obj628.X.setValue('')
    self.obj628.Type.setValue( (['Advance', 'Assign', 'Depart', 'Enter', 'Gate', 'Generate', 'Leave', 'Link', 'Logic', 'Mark', 'Priority', 'Queue', 'Release', 'SaveValue', 'Seize', 'Tabulate', 'Terminate', 'Test', 'Transfer', 'Unlink'], 6) )
    self.obj628.Type.config = 0
    self.obj628.Comments.setValue('; Return basket.')
    self.obj628.Label.setValue('L14')
    self.obj628.graphClass_= graph_GPSSBlock
    if self.genGraphics:
       from graph_Leave import *
       new_obj = graph_Leave(369.0,682.0,self.obj628)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("GPSSBlock", new_obj.tag)
    else: new_obj = None
    self.obj628.graphObject_ = new_obj
    rootNode.addNode(self.obj628)
    self.globalAndLocalPostcondition(self.obj628, rootNode)

    self.globalPrecondition( rootNode )

    self.obj634=GPSSBlock(self)

    self.obj634.A.setValue('CTRS')
    self.obj634.C.setValue('')
    self.obj634.B.setValue('')
    self.obj634.E.setValue('')
    self.obj634.D.setValue('')
    self.obj634.F.setValue('')
    self.obj634.X.setValue('')
    self.obj634.Type.setValue( (['Advance', 'Assign', 'Depart', 'Enter', 'Gate', 'Generate', 'Leave', 'Link', 'Logic', 'Mark', 'Priority', 'Queue', 'Release', 'SaveValue', 'Seize', 'Tabulate', 'Terminate', 'Test', 'Transfer', 'Unlink'], 6) )
    self.obj634.Type.config = 0
    self.obj634.Comments.setValue('; Free counter space')
    self.obj634.Label.setValue('L20')
    self.obj634.graphClass_= graph_GPSSBlock
    if self.genGraphics:
       from graph_Leave import *
       new_obj = graph_Leave(156.0,783.0,self.obj634)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("GPSSBlock", new_obj.tag)
    else: new_obj = None
    self.obj634.graphObject_ = new_obj
    rootNode.addNode(self.obj634)
    self.globalAndLocalPostcondition(self.obj634, rootNode)

    self.globalPrecondition( rootNode )

    self.obj762=GPSSBlock(self)

    self.obj762.A.setValue('BOTH')
    self.obj762.C.setValue('AWAY')
    self.obj762.B.setValue('L3')
    self.obj762.E.setValue('')
    self.obj762.D.setValue('')
    self.obj762.F.setValue('')
    self.obj762.X.setValue('')
    self.obj762.Type.setValue( (['Advance', 'Assign', 'Depart', 'Enter', 'Gate', 'Generate', 'Leave', 'Link', 'Logic', 'Mark', 'Priority', 'Queue', 'Release', 'SaveValue', 'Seize', 'Tabulate', 'Terminate', 'Test', 'Transfer', 'Unlink'], 18) )
    self.obj762.Type.config = 0
    self.obj762.Comments.setValue('; Check for available baskets. If none, go away.')
    self.obj762.Label.setValue('L22')
    self.obj762.graphClass_= graph_GPSSBlock
    if self.genGraphics:
       from graph_Transfer import *
       new_obj = graph_Transfer(163.0,120.0,self.obj762)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("GPSSBlock", new_obj.tag)
    else: new_obj = None
    self.obj762.graphObject_ = new_obj
    rootNode.addNode(self.obj762)
    self.globalAndLocalPostcondition(self.obj762, rootNode)

    self.globalPrecondition( rootNode )

    self.obj793=GPSSBlock(self)

    self.obj793.A.setValue('IS')
    self.obj793.C.setValue('')
    self.obj793.B.setValue('FN$SHOPT')
    self.obj793.E.setValue('')
    self.obj793.D.setValue('')
    self.obj793.F.setValue('')
    self.obj793.X.setValue('')
    self.obj793.Type.setValue( (['Advance', 'Assign', 'Depart', 'Enter', 'Gate', 'Generate', 'Leave', 'Link', 'Logic', 'Mark', 'Priority', 'Queue', 'Release', 'SaveValue', 'Seize', 'Tabulate', 'Terminate', 'Test', 'Transfer', 'Unlink'], 0) )
    self.obj793.Type.config = 0
    self.obj793.Comments.setValue('; Shop. Duration determined by number of items in param IS')
    self.obj793.Label.setValue('L23')
    self.obj793.graphClass_= graph_GPSSBlock
    if self.genGraphics:
       from graph_Advance import *
       new_obj = graph_Advance(169.0,383.0,self.obj793)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("GPSSBlock", new_obj.tag)
    else: new_obj = None
    self.obj793.graphObject_ = new_obj
    rootNode.addNode(self.obj793)
    self.globalAndLocalPostcondition(self.obj793, rootNode)

    self.globalPrecondition( rootNode )

    self.obj799=GPSSBlock(self)

    self.obj799.A.setValue('WAIT')
    self.obj799.C.setValue('')
    self.obj799.B.setValue('')
    self.obj799.E.setValue('')
    self.obj799.D.setValue('')
    self.obj799.F.setValue('')
    self.obj799.X.setValue('')
    self.obj799.Type.setValue( (['Advance', 'Assign', 'Depart', 'Enter', 'Gate', 'Generate', 'Leave', 'Link', 'Logic', 'Mark', 'Priority', 'Queue', 'Release', 'SaveValue', 'Seize', 'Tabulate', 'Terminate', 'Test', 'Transfer', 'Unlink'], 11) )
    self.obj799.Type.config = 0
    self.obj799.Comments.setValue('; Wait for counter space.')
    self.obj799.Label.setValue('L24')
    self.obj799.graphClass_= graph_GPSSBlock
    if self.genGraphics:
       from graph_Queue import *
       new_obj = graph_Queue(168.0,455.0,self.obj799)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("GPSSBlock", new_obj.tag)
    else: new_obj = None
    self.obj799.graphObject_ = new_obj
    rootNode.addNode(self.obj799)
    self.globalAndLocalPostcondition(self.obj799, rootNode)

    self.globalPrecondition( rootNode )

    self.obj809=GPSSBlock(self)

    self.obj809.A.setValue('CTRS')
    self.obj809.C.setValue('')
    self.obj809.B.setValue('')
    self.obj809.E.setValue('')
    self.obj809.D.setValue('')
    self.obj809.F.setValue('')
    self.obj809.X.setValue('')
    self.obj809.Type.setValue( (['Advance', 'Assign', 'Depart', 'Enter', 'Gate', 'Generate', 'Leave', 'Link', 'Logic', 'Mark', 'Priority', 'Queue', 'Release', 'SaveValue', 'Seize', 'Tabulate', 'Terminate', 'Test', 'Transfer', 'Unlink'], 3) )
    self.obj809.Type.config = 0
    self.obj809.Comments.setValue('; Get counter space')
    self.obj809.Label.setValue('L25')
    self.obj809.graphClass_= graph_GPSSBlock
    if self.genGraphics:
       from graph_Enter import *
       new_obj = graph_Enter(158.0,535.0,self.obj809)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("GPSSBlock", new_obj.tag)
    else: new_obj = None
    self.obj809.graphObject_ = new_obj
    rootNode.addNode(self.obj809)
    self.globalAndLocalPostcondition(self.obj809, rootNode)

    self.globalPrecondition( rootNode )

    self.obj815=GPSSBlock(self)

    self.obj815.A.setValue('WAIT')
    self.obj815.C.setValue('')
    self.obj815.B.setValue('')
    self.obj815.E.setValue('')
    self.obj815.D.setValue('')
    self.obj815.F.setValue('')
    self.obj815.X.setValue('')
    self.obj815.Type.setValue( (['Advance', 'Assign', 'Depart', 'Enter', 'Gate', 'Generate', 'Leave', 'Link', 'Logic', 'Mark', 'Priority', 'Queue', 'Release', 'SaveValue', 'Seize', 'Tabulate', 'Terminate', 'Test', 'Transfer', 'Unlink'], 2) )
    self.obj815.Type.config = 0
    self.obj815.Comments.setValue('; Leave queue')
    self.obj815.Label.setValue('L26')
    self.obj815.graphClass_= graph_GPSSBlock
    if self.genGraphics:
       from graph_Depart import *
       new_obj = graph_Depart(168.0,624.0,self.obj815)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("GPSSBlock", new_obj.tag)
    else: new_obj = None
    self.obj815.graphObject_ = new_obj
    rootNode.addNode(self.obj815)
    self.globalAndLocalPostcondition(self.obj815, rootNode)

    self.globalPrecondition( rootNode )

    self.obj825=GPSSBlock(self)

    self.obj825.A.setValue('V$CKTT')
    self.obj825.C.setValue('')
    self.obj825.B.setValue('')
    self.obj825.E.setValue('')
    self.obj825.D.setValue('')
    self.obj825.F.setValue('')
    self.obj825.X.setValue('')
    self.obj825.Type.setValue( (['Advance', 'Assign', 'Depart', 'Enter', 'Gate', 'Generate', 'Leave', 'Link', 'Logic', 'Mark', 'Priority', 'Queue', 'Release', 'SaveValue', 'Seize', 'Tabulate', 'Terminate', 'Test', 'Transfer', 'Unlink'], 0) )
    self.obj825.Type.config = 0
    self.obj825.Comments.setValue('; Check out.')
    self.obj825.Label.setValue('L27')
    self.obj825.graphClass_= graph_GPSSBlock
    if self.genGraphics:
       from graph_Advance import *
       new_obj = graph_Advance(166.0,704.0,self.obj825)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("GPSSBlock", new_obj.tag)
    else: new_obj = None
    self.obj825.graphObject_ = new_obj
    rootNode.addNode(self.obj825)
    self.globalAndLocalPostcondition(self.obj825, rootNode)

    self.globalPrecondition( rootNode )

    self.obj841=GPSSBlock(self)

    self.obj841.A.setValue('TRT')
    self.obj841.C.setValue('')
    self.obj841.B.setValue('')
    self.obj841.E.setValue('')
    self.obj841.D.setValue('')
    self.obj841.F.setValue('')
    self.obj841.X.setValue('')
    self.obj841.Type.setValue( (['Advance', 'Assign', 'Depart', 'Enter', 'Gate', 'Generate', 'Leave', 'Link', 'Logic', 'Mark', 'Priority', 'Queue', 'Release', 'SaveValue', 'Seize', 'Tabulate', 'Terminate', 'Test', 'Transfer', 'Unlink'], 15) )
    self.obj841.Type.config = 0
    self.obj841.Comments.setValue('; Tabulate transit time.')
    self.obj841.Label.setValue('L13')
    self.obj841.graphClass_= graph_GPSSBlock
    if self.genGraphics:
       from graph_Tabulate import *
       new_obj = graph_Tabulate(369.0,492.0,self.obj841)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("GPSSBlock", new_obj.tag)
    else: new_obj = None
    self.obj841.graphObject_ = new_obj
    rootNode.addNode(self.obj841)
    self.globalAndLocalPostcondition(self.obj841, rootNode)

    self.globalPrecondition( rootNode )

    self.obj842=GPSSBlock(self)

    self.obj842.A.setValue('ITMS')
    self.obj842.C.setValue('')
    self.obj842.B.setValue('')
    self.obj842.E.setValue('')
    self.obj842.D.setValue('')
    self.obj842.F.setValue('')
    self.obj842.X.setValue('')
    self.obj842.Type.setValue( (['Advance', 'Assign', 'Depart', 'Enter', 'Gate', 'Generate', 'Leave', 'Link', 'Logic', 'Mark', 'Priority', 'Queue', 'Release', 'SaveValue', 'Seize', 'Tabulate', 'Terminate', 'Test', 'Transfer', 'Unlink'], 15) )
    self.obj842.Type.config = 0
    self.obj842.Comments.setValue('; Tabulate number of items.')
    self.obj842.Label.setValue('L15')
    self.obj842.graphClass_= graph_GPSSBlock
    if self.genGraphics:
       from graph_Tabulate import *
       new_obj = graph_Tabulate(369.0,587.0,self.obj842)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("GPSSBlock", new_obj.tag)
    else: new_obj = None
    self.obj842.graphObject_ = new_obj
    rootNode.addNode(self.obj842)
    self.globalAndLocalPostcondition(self.obj842, rootNode)

    self.globalPrecondition( rootNode )

    self.obj636=Function(self)

    self.obj636.Input.setValue('RN1')
    self.obj636.Points.setActionFlags([ 1, 1, 1, 0])
    lcobj1 =[]
    cobj1= xXy()
    cobj1.x=ATOM3Float(0.0)
    cobj1.y=ATOM3Float(0.0)
    lcobj1.append(cobj1)
    cobj1= xXy()
    cobj1.x=ATOM3Float(0.1)
    cobj1.y=ATOM3Float(0.104)
    lcobj1.append(cobj1)
    cobj1= xXy()
    cobj1.x=ATOM3Float(0.2)
    cobj1.y=ATOM3Float(0.222)
    lcobj1.append(cobj1)
    cobj1= xXy()
    cobj1.x=ATOM3Float(0.3)
    cobj1.y=ATOM3Float(0.355)
    lcobj1.append(cobj1)
    cobj1= xXy()
    cobj1.x=ATOM3Float(0.4)
    cobj1.y=ATOM3Float(0.509)
    lcobj1.append(cobj1)
    cobj1= xXy()
    cobj1.x=ATOM3Float(0.5)
    cobj1.y=ATOM3Float(0.69)
    lcobj1.append(cobj1)
    cobj1= xXy()
    cobj1.x=ATOM3Float(0.6)
    cobj1.y=ATOM3Float(0.915)
    lcobj1.append(cobj1)
    cobj1= xXy()
    cobj1.x=ATOM3Float(0.7)
    cobj1.y=ATOM3Float(1.2)
    lcobj1.append(cobj1)
    cobj1= xXy()
    cobj1.x=ATOM3Float(0.8)
    cobj1.y=ATOM3Float(1.6)
    lcobj1.append(cobj1)
    cobj1= xXy()
    cobj1.x=ATOM3Float(0.84)
    cobj1.y=ATOM3Float(1.83)
    lcobj1.append(cobj1)
    cobj1= xXy()
    cobj1.x=ATOM3Float(0.88)
    cobj1.y=ATOM3Float(7.12)
    lcobj1.append(cobj1)
    cobj1= xXy()
    cobj1.x=ATOM3Float(0.9)
    cobj1.y=ATOM3Float(2.3)
    lcobj1.append(cobj1)
    cobj1= xXy()
    cobj1.x=ATOM3Float(0.92)
    cobj1.y=ATOM3Float(2.52)
    lcobj1.append(cobj1)
    cobj1= xXy()
    cobj1.x=ATOM3Float(0.94)
    cobj1.y=ATOM3Float(2.81)
    lcobj1.append(cobj1)
    cobj1= xXy()
    cobj1.x=ATOM3Float(0.95)
    cobj1.y=ATOM3Float(2.99)
    lcobj1.append(cobj1)
    cobj1= xXy()
    cobj1.x=ATOM3Float(0.96)
    cobj1.y=ATOM3Float(3.2)
    lcobj1.append(cobj1)
    cobj1= xXy()
    cobj1.x=ATOM3Float(0.97)
    cobj1.y=ATOM3Float(3.5)
    lcobj1.append(cobj1)
    cobj1= xXy()
    cobj1.x=ATOM3Float(0.98)
    cobj1.y=ATOM3Float(3.9)
    lcobj1.append(cobj1)
    cobj1= xXy()
    cobj1.x=ATOM3Float(0.99)
    cobj1.y=ATOM3Float(4.6)
    lcobj1.append(cobj1)
    cobj1= xXy()
    cobj1.x=ATOM3Float(0.995)
    cobj1.y=ATOM3Float(5.3)
    lcobj1.append(cobj1)
    cobj1= xXy()
    cobj1.x=ATOM3Float(0.998)
    cobj1.y=ATOM3Float(6.2)
    lcobj1.append(cobj1)
    cobj1= xXy()
    cobj1.x=ATOM3Float(0.999)
    cobj1.y=ATOM3Float(7.0)
    lcobj1.append(cobj1)
    cobj1= xXy()
    cobj1.x=ATOM3Float(0.9997)
    cobj1.y=ATOM3Float(8.0)
    lcobj1.append(cobj1)
    self.obj636.Points.setValue(lcobj1)
    self.obj636.Mode.setValue( (['Continuous', 'Discrete'], 0) )
    self.obj636.Mode.config = 0
    self.obj636.Number_Of_Points.setValue(24)
    self.obj636.Function_Number.setValue('POISS')
    self.obj636.graphClass_= graph_Function
    if self.genGraphics:
       from graph_Function import *
       new_obj = graph_Function(383.0,104.0,self.obj636)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("Function", new_obj.tag)
    else: new_obj = None
    self.obj636.graphObject_ = new_obj
    rootNode.addNode(self.obj636)
    self.globalAndLocalPostcondition(self.obj636, rootNode)

    self.globalPrecondition( rootNode )

    self.obj784=Function(self)

    self.obj784.Input.setValue('RN1')
    self.obj784.Points.setActionFlags([ 1, 1, 1, 0])
    lcobj1 =[]
    cobj1= xXy()
    cobj1.x=ATOM3Float(0.2)
    cobj1.y=ATOM3Float(5.0)
    lcobj1.append(cobj1)
    cobj1= xXy()
    cobj1.x=ATOM3Float(0.5)
    cobj1.y=ATOM3Float(10.0)
    lcobj1.append(cobj1)
    cobj1= xXy()
    cobj1.x=ATOM3Float(0.9)
    cobj1.y=ATOM3Float(15.0)
    lcobj1.append(cobj1)
    cobj1= xXy()
    cobj1.x=ATOM3Float(1.0)
    cobj1.y=ATOM3Float(20.0)
    lcobj1.append(cobj1)
    self.obj784.Points.setValue(lcobj1)
    self.obj784.Mode.setValue( (['Continuous', 'Discrete'], 1) )
    self.obj784.Mode.config = 0
    self.obj784.Number_Of_Points.setValue(4)
    self.obj784.Function_Number.setValue('IS')
    self.obj784.graphClass_= graph_Function
    if self.genGraphics:
       from graph_Function import *
       new_obj = graph_Function(384.0,200.0,self.obj784)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("Function", new_obj.tag)
    else: new_obj = None
    self.obj784.graphObject_ = new_obj
    rootNode.addNode(self.obj784)
    self.globalAndLocalPostcondition(self.obj784, rootNode)

    self.globalPrecondition( rootNode )

    self.obj859=Function(self)

    self.obj859.Input.setValue('P$IS')
    self.obj859.Points.setActionFlags([ 1, 1, 1, 0])
    lcobj1 =[]
    cobj1= xXy()
    cobj1.x=ATOM3Float(0.0)
    cobj1.y=ATOM3Float(0.0)
    lcobj1.append(cobj1)
    cobj1= xXy()
    cobj1.x=ATOM3Float(5.0)
    cobj1.y=ATOM3Float(400.0)
    lcobj1.append(cobj1)
    cobj1= xXy()
    cobj1.x=ATOM3Float(10.0)
    cobj1.y=ATOM3Float(900.0)
    lcobj1.append(cobj1)
    cobj1= xXy()
    cobj1.x=ATOM3Float(15.0)
    cobj1.y=ATOM3Float(1500.0)
    lcobj1.append(cobj1)
    cobj1= xXy()
    cobj1.x=ATOM3Float(20.0)
    cobj1.y=ATOM3Float(2250.0)
    lcobj1.append(cobj1)
    self.obj859.Points.setValue(lcobj1)
    self.obj859.Mode.setValue( (['Continuous', 'Discrete'], 0) )
    self.obj859.Mode.config = 0
    self.obj859.Number_Of_Points.setValue(5)
    self.obj859.Function_Number.setValue('SHOPT')
    self.obj859.graphClass_= graph_Function
    if self.genGraphics:
       from graph_Function import *
       new_obj = graph_Function(386.0,298.0,self.obj859)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("Function", new_obj.tag)
    else: new_obj = None
    self.obj859.graphObject_ = new_obj
    rootNode.addNode(self.obj859)
    self.globalAndLocalPostcondition(self.obj859, rootNode)

    self.globalPrecondition( rootNode )

    self.obj637=Storage_Size(self)

    self.obj637.Storage_Size.setValue(50)
    self.obj637.Storage_Name.setValue('BSKTS')
    self.obj637.graphClass_= graph_Storage_Size
    if self.genGraphics:
       from graph_Storage_Size import *
       new_obj = graph_Storage_Size(604.0,111.0,self.obj637)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("Storage_Size", new_obj.tag)
    else: new_obj = None
    self.obj637.graphObject_ = new_obj
    rootNode.addNode(self.obj637)
    self.globalAndLocalPostcondition(self.obj637, rootNode)

    self.globalPrecondition( rootNode )

    self.obj864=Storage_Size(self)

    self.obj864.Storage_Size.setValue(5)
    self.obj864.Storage_Name.setValue('CTRS')
    self.obj864.graphClass_= graph_Storage_Size
    if self.genGraphics:
       from graph_Storage_Size import *
       new_obj = graph_Storage_Size(601.0,195.0,self.obj864)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("Storage_Size", new_obj.tag)
    else: new_obj = None
    self.obj864.graphObject_ = new_obj
    rootNode.addNode(self.obj864)
    self.globalAndLocalPostcondition(self.obj864, rootNode)

    self.globalPrecondition( rootNode )

    self.obj867=Table(self)

    self.obj867.Lower_Limit.setValue('500')
    self.obj867.Interval_Size.setValue('500')
    self.obj867.Type.setValue('M1')
    self.obj867.Number_Of_Intervals.setValue('10')
    self.obj867.Label.setValue('TRT')
    self.obj867.graphClass_= graph_Table
    if self.genGraphics:
       from graph_Table import *
       new_obj = graph_Table(534.0,296.0,self.obj867)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("Table", new_obj.tag)
    else: new_obj = None
    self.obj867.graphObject_ = new_obj
    rootNode.addNode(self.obj867)
    self.globalAndLocalPostcondition(self.obj867, rootNode)

    self.globalPrecondition( rootNode )

    self.obj868=Table(self)

    self.obj868.Lower_Limit.setValue('5')
    self.obj868.Interval_Size.setValue('5')
    self.obj868.Type.setValue('P$IS')
    self.obj868.Number_Of_Intervals.setValue('4')
    self.obj868.Label.setValue('ITMS')
    self.obj868.graphClass_= graph_Table
    if self.genGraphics:
       from graph_Table import *
       new_obj = graph_Table(533.0,387.0,self.obj868)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("Table", new_obj.tag)
    else: new_obj = None
    self.obj868.graphObject_ = new_obj
    rootNode.addNode(self.obj868)
    self.globalAndLocalPostcondition(self.obj868, rootNode)

    self.globalPrecondition( rootNode )

    self.obj869=SNAVariable(self)

    self.obj869.Expression.setValue('P$IS*10+25')
    self.obj869.Type.setValue( (['Integer', 'Float', 'Boolean'], 1) )
    self.obj869.Type.config = 0
    self.obj869.Name.setValue('CKTT')
    self.obj869.graphClass_= graph_SNAVariable
    if self.genGraphics:
       from graph_SNAVariable import *
       new_obj = graph_SNAVariable(552.0,487.0,self.obj869)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("SNAVariable", new_obj.tag)
    else: new_obj = None
    self.obj869.graphObject_ = new_obj
    rootNode.addNode(self.obj869)
    self.globalAndLocalPostcondition(self.obj869, rootNode)

    self.globalPrecondition( rootNode )

    self.obj765=connected_to(self)

    self.obj765.graphClass_= graph_connected_to
    if self.genGraphics:
       from graph_connected_to import *
       new_obj = graph_connected_to(208.0,109.5,self.obj765)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("connected_to", new_obj.tag)
    else: new_obj = None
    self.obj765.graphObject_ = new_obj
    rootNode.addNode(self.obj765)
    self.globalAndLocalPostcondition(self.obj765, rootNode)

    self.globalPrecondition( rootNode )

    self.obj766=connected_to(self)

    self.obj766.graphClass_= graph_connected_to
    if self.genGraphics:
       from graph_connected_to import *
       new_obj = graph_connected_to(210.0,196.5,self.obj766)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("connected_to", new_obj.tag)
    else: new_obj = None
    self.obj766.graphObject_ = new_obj
    rootNode.addNode(self.obj766)
    self.globalAndLocalPostcondition(self.obj766, rootNode)

    self.globalPrecondition( rootNode )

    self.obj767=connected_to(self)

    self.obj767.graphClass_= graph_connected_to
    if self.genGraphics:
       from graph_connected_to import *
       new_obj = graph_connected_to(59.0,155.0,self.obj767)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("connected_to", new_obj.tag)
    else: new_obj = None
    self.obj767.graphObject_ = new_obj
    rootNode.addNode(self.obj767)
    self.globalAndLocalPostcondition(self.obj767, rootNode)

    self.globalPrecondition( rootNode )

    self.obj771=connected_to(self)

    self.obj771.graphClass_= graph_connected_to
    if self.genGraphics:
       from graph_connected_to import *
       new_obj = graph_connected_to(208.5,285.5,self.obj771)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("connected_to", new_obj.tag)
    else: new_obj = None
    self.obj771.graphObject_ = new_obj
    rootNode.addNode(self.obj771)
    self.globalAndLocalPostcondition(self.obj771, rootNode)

    self.globalPrecondition( rootNode )

    self.obj798=connected_to(self)

    self.obj798.graphClass_= graph_connected_to
    if self.genGraphics:
       from graph_connected_to import *
       new_obj = graph_connected_to(209.5,371.0,self.obj798)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("connected_to", new_obj.tag)
    else: new_obj = None
    self.obj798.graphObject_ = new_obj
    rootNode.addNode(self.obj798)
    self.globalAndLocalPostcondition(self.obj798, rootNode)

    self.globalPrecondition( rootNode )

    self.obj808=connected_to(self)

    self.obj808.graphClass_= graph_connected_to
    if self.genGraphics:
       from graph_connected_to import *
       new_obj = graph_connected_to(209.0,447.0,self.obj808)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("connected_to", new_obj.tag)
    else: new_obj = None
    self.obj808.graphObject_ = new_obj
    rootNode.addNode(self.obj808)
    self.globalAndLocalPostcondition(self.obj808, rootNode)

    self.globalPrecondition( rootNode )

    self.obj812=connected_to(self)

    self.obj812.graphClass_= graph_connected_to
    if self.genGraphics:
       from graph_connected_to import *
       new_obj = graph_connected_to(209.5,526.5,self.obj812)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("connected_to", new_obj.tag)
    else: new_obj = None
    self.obj812.graphObject_ = new_obj
    rootNode.addNode(self.obj812)
    self.globalAndLocalPostcondition(self.obj812, rootNode)

    self.globalPrecondition( rootNode )

    self.obj824=connected_to(self)

    self.obj824.graphClass_= graph_connected_to
    if self.genGraphics:
       from graph_connected_to import *
       new_obj = graph_connected_to(209.0,610.0,self.obj824)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("connected_to", new_obj.tag)
    else: new_obj = None
    self.obj824.graphObject_ = new_obj
    rootNode.addNode(self.obj824)
    self.globalAndLocalPostcondition(self.obj824, rootNode)

    self.globalPrecondition( rootNode )

    self.obj830=connected_to(self)

    self.obj830.graphClass_= graph_connected_to
    if self.genGraphics:
       from graph_connected_to import *
       new_obj = graph_connected_to(208.5,686.5,self.obj830)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("connected_to", new_obj.tag)
    else: new_obj = None
    self.obj830.graphObject_ = new_obj
    rootNode.addNode(self.obj830)
    self.globalAndLocalPostcondition(self.obj830, rootNode)

    self.globalPrecondition( rootNode )

    self.obj836=connected_to(self)

    self.obj836.graphClass_= graph_connected_to
    if self.genGraphics:
       from graph_connected_to import *
       new_obj = graph_connected_to(207.5,773.0,self.obj836)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("connected_to", new_obj.tag)
    else: new_obj = None
    self.obj836.graphObject_ = new_obj
    rootNode.addNode(self.obj836)
    self.globalAndLocalPostcondition(self.obj836, rootNode)

    self.globalPrecondition( rootNode )

    self.obj855=connected_to(self)

    self.obj855.graphClass_= graph_connected_to
    if self.genGraphics:
       from graph_connected_to import *
       new_obj = graph_connected_to(418.0,568.0,self.obj855)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("connected_to", new_obj.tag)
    else: new_obj = None
    self.obj855.graphObject_ = new_obj
    rootNode.addNode(self.obj855)
    self.globalAndLocalPostcondition(self.obj855, rootNode)

    self.globalPrecondition( rootNode )

    self.obj856=connected_to(self)

    self.obj856.graphClass_= graph_connected_to
    if self.genGraphics:
       from graph_connected_to import *
       new_obj = graph_connected_to(418.0,665.0,self.obj856)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("connected_to", new_obj.tag)
    else: new_obj = None
    self.obj856.graphObject_ = new_obj
    rootNode.addNode(self.obj856)
    self.globalAndLocalPostcondition(self.obj856, rootNode)

    self.globalPrecondition( rootNode )

    self.obj857=connected_to(self)

    self.obj857.graphClass_= graph_connected_to
    if self.genGraphics:
       from graph_connected_to import *
       new_obj = graph_connected_to(419.0,763.5,self.obj857)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("connected_to", new_obj.tag)
    else: new_obj = None
    self.obj857.graphObject_ = new_obj
    rootNode.addNode(self.obj857)
    self.globalAndLocalPostcondition(self.obj857, rootNode)

    self.globalPrecondition( rootNode )

    self.obj858=connected_to(self)

    self.obj858.graphClass_= graph_connected_to
    if self.genGraphics:
       from graph_connected_to import *
       new_obj = graph_connected_to(207.5,876.0,self.obj858)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("connected_to", new_obj.tag)
    else: new_obj = None
    self.obj858.graphObject_ = new_obj
    rootNode.addNode(self.obj858)
    self.globalAndLocalPostcondition(self.obj858, rootNode)
    self.drawConnections((self.obj614,self.obj765,[209.0, 98.0, 208.0, 109.5], 0, 2), (self.obj617,self.obj771,[209.0, 269.0, 208.5, 285.5], 0, 2), (self.obj619,self.obj798,[210.0, 358.0, 209.5, 371.0], 0, 2), (self.obj628,self.obj857,[419.0, 749.0, 419.0, 763.5], 0, 2), (self.obj634,self.obj858,[206.0, 850.0, 207.5, 876.0], 0, 2), (self.obj762,self.obj766,[210.0, 186.0, 210.0, 196.5], 0, 2), (self.obj762,self.obj767,[167.0, 155.0, 59.0, 155.0], 0, 2), (self.obj793,self.obj808,[209.0, 436.0, 209.0, 447.0], 0, 2), (self.obj799,self.obj812,[208.0, 512.0, 209.5, 526.5], 0, 2), (self.obj809,self.obj824,[208.0, 596.0, 209.0, 610.0], 0, 2), (self.obj815,self.obj830,[208.0, 675.0, 208.5, 686.5], 0, 2), (self.obj825,self.obj836,[206.0, 757.0, 207.5, 773.0], 0, 2), (self.obj841,self.obj855,[419.0, 553.0, 418.0, 568.0], 0, 2), (self.obj842,self.obj856,[419.0, 648.0, 418.0, 665.0], 0, 2), (self.obj765,self.obj762,[208.0, 109.5, 209.0, 123.0], 0, 2), (self.obj766,self.obj617,[210.0, 196.5, 209.0, 211.0], 0, 2), (self.obj767,self.obj615,[59.0, 155.0, 61.0, 175.0], 0, 2), (self.obj771,self.obj619,[208.5, 285.5, 209.0, 305.0], 0, 2), (self.obj798,self.obj793,[209.5, 371.0, 210.0, 386.0], 0, 2), (self.obj808,self.obj799,[209.0, 447.0, 209.0, 464.0], 0, 2), (self.obj812,self.obj809,[209.5, 526.5, 208.0, 538.0], 0, 2), (self.obj824,self.obj815,[209.0, 610.0, 209.0, 627.0], 0, 2), (self.obj830,self.obj825,[208.5, 686.5, 207.0, 707.0], 0, 2), (self.obj836,self.obj634,[207.5, 773.0, 206.0, 792.0], 0, 2), (self.obj855,self.obj842,[418.0, 568.0, 419.0, 590.0], 0, 2), (self.obj856,self.obj628,[418.0, 665.0, 419.0, 691.0], 0, 2), (self.obj857,self.obj625,[419.0, 763.5, 419.0, 783.0], 0, 2), (self.obj858,self.obj841,[207.5, 876.0, 319.0, 875.0, 319.0, 472.0, 419.0, 473.0, 419.0, 495.0], 0, 5) )

newfunction = supermarket_1_GPSS_mdl

loadedTypes = [('Point', 'Point', (), 1),('ControlStatement', 'ControlStatement', (), 1)]
loadedMMName = 'GPSSMetaModel'
