from graph_ASG_ERmetaMetaModel import *
from stickylink import *
from widthXfillXdecoration import *
from ASG_GPSSMetaModel import *
from ASG_GPSSMetaModel import *
from GPSSBlock import *
from Function import *
from Storage_Size import *
from Table import *
from SNAVariable import *
from connected_to import *
from ControlStatement import *
from ATOM3BottomType import *
from ATOM3String import *
from ATOM3Constraint import *
from ATOM3Attribute import *
from ATOM3Enum import *
from ATOM3Appearance import *
from ATOM3Float import *
from ATOM3Connection import *
from ATOM3Boolean import *
from ATOM3Link import *
from Point import *
from ATOM3Integer import *
from ATOM3List import *
from ATOM3Port import *

def telephone_2_GPSS_mdl(self, rootNode):
    rootNode.Name.setValue('Simulation of a telephone system (basic).')
    rootNode.Control_Statements.setActionFlags([ 1, 1, 1, 0])
    lcobj1 =[]
    cobj1= ltypenameXAXBXC()
    cobj1.ltypename=ATOM3Enum(['START', 'CLEAR', 'RESET'],0,0)
    cobj1.A=ATOM3String('10')
    cobj1.B=ATOM3String('NP')
    cobj1.C=ATOM3String('')
    lcobj1.append(cobj1)
    cobj1= ltypenameXAXBXC()
    cobj1.ltypename=ATOM3Enum(['START', 'CLEAR', 'RESET'],2,0)
    cobj1.A=ATOM3String('')
    cobj1.B=ATOM3String('')
    cobj1.C=ATOM3String('')
    lcobj1.append(cobj1)
    cobj1= ltypenameXAXBXC()
    cobj1.ltypename=ATOM3Enum(['START', 'CLEAR', 'RESET'],0,0)
    cobj1.A=ATOM3String('600')
    cobj1.B=ATOM3String('')
    cobj1.C=ATOM3String('')
    lcobj1.append(cobj1)
    rootNode.Control_Statements.setValue(lcobj1)
    rootNode.Author.setValue('G. Gordon. Figure 12-7/10-5')

    self.globalPrecondition( rootNode )

    self.obj39=GPSSBlock(self)

    self.obj39.A.setValue('12')
    self.obj39.C.setValue('')
    self.obj39.B.setValue('FN$POISS')
    self.obj39.E.setValue('')
    self.obj39.D.setValue('')
    self.obj39.F.setValue('')
    self.obj39.X.setValue('')
    self.obj39.Type.setValue( (['Advance', 'Assign', 'Depart', 'Enter', 'Gate', 'Generate', 'Leave', 'Link', 'Logic', 'Mark', 'Priority', 'Queue', 'Release', 'SaveValue', 'Seize', 'Tabulate', 'Terminate', 'Test', 'Transfer', 'Unlink'], 5) )
    self.obj39.Type.config = 0
    self.obj39.Comments.setValue('; Interarrival time of calls')
    self.obj39.Label.setValue('L0')
    self.obj39.graphClass_= graph_GPSSBlock
    if self.genGraphics:
       from graph_Generate import *
       new_obj = graph_Generate(169.0,80.0,self.obj39)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("GPSSBlock", new_obj.tag)
    else: new_obj = None
    self.obj39.graphObject_ = new_obj
    rootNode.addNode(self.obj39)
    self.globalAndLocalPostcondition(self.obj39, rootNode)

    self.globalPrecondition( rootNode )

    self.obj40=GPSSBlock(self)

    self.obj40.A.setValue('')
    self.obj40.C.setValue('')
    self.obj40.B.setValue('')
    self.obj40.E.setValue('')
    self.obj40.D.setValue('')
    self.obj40.F.setValue('')
    self.obj40.X.setValue('')
    self.obj40.Type.setValue( (['Advance', 'Assign', 'Depart', 'Enter', 'Gate', 'Generate', 'Leave', 'Link', 'Logic', 'Mark', 'Priority', 'Queue', 'Release', 'SaveValue', 'Seize', 'Tabulate', 'Terminate', 'Test', 'Transfer', 'Unlink'], 16) )
    self.obj40.Type.config = 0
    self.obj40.Comments.setValue('; Abandon call.')
    self.obj40.Label.setValue('ABND')
    self.obj40.graphClass_= graph_GPSSBlock
    if self.genGraphics:
       from graph_Terminate import *
       new_obj = graph_Terminate(14.0,224.0,self.obj40)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("GPSSBlock", new_obj.tag)
    else: new_obj = None
    self.obj40.graphObject_ = new_obj
    rootNode.addNode(self.obj40)
    self.globalAndLocalPostcondition(self.obj40, rootNode)

    self.globalPrecondition( rootNode )

    self.obj41=GPSSBlock(self)

    self.obj41.A.setValue('V$FL')
    self.obj41.C.setValue('ABND')
    self.obj41.B.setValue('2')
    self.obj41.E.setValue('')
    self.obj41.D.setValue('')
    self.obj41.F.setValue('')
    self.obj41.X.setValue('G')
    self.obj41.Type.setValue( (['Advance', 'Assign', 'Depart', 'Enter', 'Gate', 'Generate', 'Leave', 'Link', 'Logic', 'Mark', 'Priority', 'Queue', 'Release', 'SaveValue', 'Seize', 'Tabulate', 'Terminate', 'Test', 'Transfer', 'Unlink'], 17) )
    self.obj41.Type.config = 0
    self.obj41.Comments.setValue('; Test if system is full (all lines in use).')
    self.obj41.Label.setValue('L2')
    self.obj41.graphClass_= graph_GPSSBlock
    if self.genGraphics:
       from graph_Test import *
       new_obj = graph_Test(164.0,167.0,self.obj41)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("GPSSBlock", new_obj.tag)
    else: new_obj = None
    self.obj41.graphObject_ = new_obj
    rootNode.addNode(self.obj41)
    self.globalAndLocalPostcondition(self.obj41, rootNode)

    self.globalPrecondition( rootNode )

    self.obj42=GPSSBlock(self)

    self.obj42.A.setValue('P$OR')
    self.obj42.C.setValue('')
    self.obj42.B.setValue('ASN1')
    self.obj42.E.setValue('')
    self.obj42.D.setValue('')
    self.obj42.F.setValue('')
    self.obj42.X.setValue('LR')
    self.obj42.Type.setValue( (['Advance', 'Assign', 'Depart', 'Enter', 'Gate', 'Generate', 'Leave', 'Link', 'Logic', 'Mark', 'Priority', 'Queue', 'Release', 'SaveValue', 'Seize', 'Tabulate', 'Terminate', 'Test', 'Transfer', 'Unlink'], 4) )
    self.obj42.Type.config = 0
    self.obj42.Comments.setValue('; Test for origin busy')
    self.obj42.Label.setValue('L4')
    self.obj42.graphClass_= graph_GPSSBlock
    if self.genGraphics:
       from graph_Gate import *
       new_obj = graph_Gate(162.0,356.0,self.obj42)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("GPSSBlock", new_obj.tag)
    else: new_obj = None
    self.obj42.graphObject_ = new_obj
    rootNode.addNode(self.obj42)
    self.globalAndLocalPostcondition(self.obj42, rootNode)

    self.globalPrecondition( rootNode )

    self.obj43=GPSSBlock(self)

    self.obj43.A.setValue('DT')
    self.obj43.C.setValue('')
    self.obj43.B.setValue('V$LN')
    self.obj43.E.setValue('')
    self.obj43.D.setValue('')
    self.obj43.F.setValue('')
    self.obj43.X.setValue('')
    self.obj43.Type.setValue( (['Advance', 'Assign', 'Depart', 'Enter', 'Gate', 'Generate', 'Leave', 'Link', 'Logic', 'Mark', 'Priority', 'Queue', 'Release', 'SaveValue', 'Seize', 'Tabulate', 'Terminate', 'Test', 'Transfer', 'Unlink'], 1) )
    self.obj43.Type.config = 0
    self.obj43.Comments.setValue('; Pick a destination line. Store in parameter DT.')
    self.obj43.Label.setValue('ASN2')
    self.obj43.graphClass_= graph_GPSSBlock
    if self.genGraphics:
       from graph_Assign import *
       new_obj = graph_Assign(129.0,449.0,self.obj43)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("GPSSBlock", new_obj.tag)
    else: new_obj = None
    self.obj43.graphObject_ = new_obj
    rootNode.addNode(self.obj43)
    self.globalAndLocalPostcondition(self.obj43, rootNode)

    self.globalPrecondition( rootNode )

    self.obj44=GPSSBlock(self)

    self.obj44.A.setValue('P$OR')
    self.obj44.C.setValue('ASN2')
    self.obj44.B.setValue('P$DT')
    self.obj44.E.setValue('')
    self.obj44.D.setValue('')
    self.obj44.F.setValue('')
    self.obj44.X.setValue('NE')
    self.obj44.Type.setValue( (['Advance', 'Assign', 'Depart', 'Enter', 'Gate', 'Generate', 'Leave', 'Link', 'Logic', 'Mark', 'Priority', 'Queue', 'Release', 'SaveValue', 'Seize', 'Tabulate', 'Terminate', 'Test', 'Transfer', 'Unlink'], 17) )
    self.obj44.Type.config = 0
    self.obj44.Comments.setValue('; Retry if origin OR = destination DT')
    self.obj44.Label.setValue('L6')
    self.obj44.graphClass_= graph_GPSSBlock
    if self.genGraphics:
       from graph_Test import *
       new_obj = graph_Test(165.0,540.0,self.obj44)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("GPSSBlock", new_obj.tag)
    else: new_obj = None
    self.obj44.graphObject_ = new_obj
    rootNode.addNode(self.obj44)
    self.globalAndLocalPostcondition(self.obj44, rootNode)

    self.globalPrecondition( rootNode )

    self.obj45=GPSSBlock(self)

    self.obj45.A.setValue('P$OR')
    self.obj45.C.setValue('')
    self.obj45.B.setValue('')
    self.obj45.E.setValue('')
    self.obj45.D.setValue('')
    self.obj45.F.setValue('')
    self.obj45.X.setValue('S')
    self.obj45.Type.setValue( (['Advance', 'Assign', 'Depart', 'Enter', 'Gate', 'Generate', 'Leave', 'Link', 'Logic', 'Mark', 'Priority', 'Queue', 'Release', 'SaveValue', 'Seize', 'Tabulate', 'Terminate', 'Test', 'Transfer', 'Unlink'], 8) )
    self.obj45.Type.config = 0
    self.obj45.Comments.setValue('')
    self.obj45.Label.setValue('L7')
    self.obj45.graphClass_= graph_GPSSBlock
    if self.genGraphics:
       from graph_Logic import *
       new_obj = graph_Logic(162.0,639.0,self.obj45)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("GPSSBlock", new_obj.tag)
    else: new_obj = None
    self.obj45.graphObject_ = new_obj
    rootNode.addNode(self.obj45)
    self.globalAndLocalPostcondition(self.obj45, rootNode)

    self.globalPrecondition( rootNode )

    self.obj46=GPSSBlock(self)

    self.obj46.A.setValue('BOTH')
    self.obj46.C.setValue('BLKD')
    self.obj46.B.setValue('L9')
    self.obj46.E.setValue('')
    self.obj46.D.setValue('')
    self.obj46.F.setValue('')
    self.obj46.X.setValue('')
    self.obj46.Type.setValue( (['Advance', 'Assign', 'Depart', 'Enter', 'Gate', 'Generate', 'Leave', 'Link', 'Logic', 'Mark', 'Priority', 'Queue', 'Release', 'SaveValue', 'Seize', 'Tabulate', 'Terminate', 'Test', 'Transfer', 'Unlink'], 18) )
    self.obj46.Type.config = 0
    self.obj46.Comments.setValue('; Try to obtain a link')
    self.obj46.Label.setValue('L8')
    self.obj46.graphClass_= graph_GPSSBlock
    if self.genGraphics:
       from graph_Transfer import *
       new_obj = graph_Transfer(375.0,155.0,self.obj46)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("GPSSBlock", new_obj.tag)
    else: new_obj = None
    self.obj46.graphObject_ = new_obj
    rootNode.addNode(self.obj46)
    self.globalAndLocalPostcondition(self.obj46, rootNode)

    self.globalPrecondition( rootNode )

    self.obj47=GPSSBlock(self)

    self.obj47.A.setValue('LS')
    self.obj47.C.setValue('')
    self.obj47.B.setValue('')
    self.obj47.E.setValue('')
    self.obj47.D.setValue('')
    self.obj47.F.setValue('')
    self.obj47.X.setValue('')
    self.obj47.Type.setValue( (['Advance', 'Assign', 'Depart', 'Enter', 'Gate', 'Generate', 'Leave', 'Link', 'Logic', 'Mark', 'Priority', 'Queue', 'Release', 'SaveValue', 'Seize', 'Tabulate', 'Terminate', 'Test', 'Transfer', 'Unlink'], 3) )
    self.obj47.Type.config = 0
    self.obj47.Comments.setValue('; Get link.')
    self.obj47.Label.setValue('L9')
    self.obj47.graphClass_= graph_GPSSBlock
    if self.genGraphics:
       from graph_Enter import *
       new_obj = graph_Enter(372.0,292.0,self.obj47)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("GPSSBlock", new_obj.tag)
    else: new_obj = None
    self.obj47.graphObject_ = new_obj
    rootNode.addNode(self.obj47)
    self.globalAndLocalPostcondition(self.obj47, rootNode)

    self.globalPrecondition( rootNode )

    self.obj48=GPSSBlock(self)

    self.obj48.A.setValue('WAIT')
    self.obj48.C.setValue('')
    self.obj48.B.setValue('P$OR')
    self.obj48.E.setValue('')
    self.obj48.D.setValue('')
    self.obj48.F.setValue('')
    self.obj48.X.setValue('')
    self.obj48.Type.setValue( (['Advance', 'Assign', 'Depart', 'Enter', 'Gate', 'Generate', 'Leave', 'Link', 'Logic', 'Mark', 'Priority', 'Queue', 'Release', 'SaveValue', 'Seize', 'Tabulate', 'Terminate', 'Test', 'Transfer', 'Unlink'], 7) )
    self.obj48.Type.config = 0
    self.obj48.Comments.setValue('; Link in order of call origin.')
    self.obj48.Label.setValue('BLKD')
    self.obj48.graphClass_= graph_GPSSBlock
    if self.genGraphics:
       from graph_Link import *
       new_obj = graph_Link(526.0,134.0,self.obj48)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("GPSSBlock", new_obj.tag)
    else: new_obj = None
    self.obj48.graphObject_ = new_obj
    rootNode.addNode(self.obj48)
    self.globalAndLocalPostcondition(self.obj48, rootNode)

    self.globalPrecondition( rootNode )

    self.obj49=GPSSBlock(self)

    self.obj49.A.setValue('P$DT')
    self.obj49.C.setValue('')
    self.obj49.B.setValue('BUSY')
    self.obj49.E.setValue('')
    self.obj49.D.setValue('')
    self.obj49.F.setValue('')
    self.obj49.X.setValue('LR')
    self.obj49.Type.setValue( (['Advance', 'Assign', 'Depart', 'Enter', 'Gate', 'Generate', 'Leave', 'Link', 'Logic', 'Mark', 'Priority', 'Queue', 'Release', 'SaveValue', 'Seize', 'Tabulate', 'Terminate', 'Test', 'Transfer', 'Unlink'], 4) )
    self.obj49.Type.config = 0
    self.obj49.Comments.setValue('; Test for destination busy')
    self.obj49.Label.setValue('L12')
    self.obj49.graphClass_= graph_GPSSBlock
    if self.genGraphics:
       from graph_Gate import *
       new_obj = graph_Gate(373.0,366.0,self.obj49)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("GPSSBlock", new_obj.tag)
    else: new_obj = None
    self.obj49.graphObject_ = new_obj
    rootNode.addNode(self.obj49)
    self.globalAndLocalPostcondition(self.obj49, rootNode)

    self.globalPrecondition( rootNode )

    self.obj50=GPSSBlock(self)

    self.obj50.A.setValue('P$OR')
    self.obj50.C.setValue('')
    self.obj50.B.setValue('')
    self.obj50.E.setValue('')
    self.obj50.D.setValue('')
    self.obj50.F.setValue('')
    self.obj50.X.setValue('R')
    self.obj50.Type.setValue( (['Advance', 'Assign', 'Depart', 'Enter', 'Gate', 'Generate', 'Leave', 'Link', 'Logic', 'Mark', 'Priority', 'Queue', 'Release', 'SaveValue', 'Seize', 'Tabulate', 'Terminate', 'Test', 'Transfer', 'Unlink'], 8) )
    self.obj50.Type.config = 0
    self.obj50.Comments.setValue('; Origin hangs up.')
    self.obj50.Label.setValue('BUSY')
    self.obj50.graphClass_= graph_GPSSBlock
    if self.genGraphics:
       from graph_Logic import *
       new_obj = graph_Logic(531.0,364.0,self.obj50)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("GPSSBlock", new_obj.tag)
    else: new_obj = None
    self.obj50.graphObject_ = new_obj
    rootNode.addNode(self.obj50)
    self.globalAndLocalPostcondition(self.obj50, rootNode)

    self.globalPrecondition( rootNode )

    self.obj51=GPSSBlock(self)

    self.obj51.A.setValue('LS')
    self.obj51.C.setValue('')
    self.obj51.B.setValue('')
    self.obj51.E.setValue('')
    self.obj51.D.setValue('')
    self.obj51.F.setValue('')
    self.obj51.X.setValue('')
    self.obj51.Type.setValue( (['Advance', 'Assign', 'Depart', 'Enter', 'Gate', 'Generate', 'Leave', 'Link', 'Logic', 'Mark', 'Priority', 'Queue', 'Release', 'SaveValue', 'Seize', 'Tabulate', 'Terminate', 'Test', 'Transfer', 'Unlink'], 6) )
    self.obj51.Type.config = 0
    self.obj51.Comments.setValue(';  Free link.')
    self.obj51.Label.setValue('L14')
    self.obj51.graphClass_= graph_GPSSBlock
    if self.genGraphics:
       from graph_Leave import *
       new_obj = graph_Leave(531.0,443.0,self.obj51)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("GPSSBlock", new_obj.tag)
    else: new_obj = None
    self.obj51.graphObject_ = new_obj
    rootNode.addNode(self.obj51)
    self.globalAndLocalPostcondition(self.obj51, rootNode)

    self.globalPrecondition( rootNode )

    self.obj52=GPSSBlock(self)

    self.obj52.A.setValue('P$DT')
    self.obj52.C.setValue('')
    self.obj52.B.setValue('')
    self.obj52.E.setValue('')
    self.obj52.D.setValue('')
    self.obj52.F.setValue('')
    self.obj52.X.setValue('S')
    self.obj52.Type.setValue( (['Advance', 'Assign', 'Depart', 'Enter', 'Gate', 'Generate', 'Leave', 'Link', 'Logic', 'Mark', 'Priority', 'Queue', 'Release', 'SaveValue', 'Seize', 'Tabulate', 'Terminate', 'Test', 'Transfer', 'Unlink'], 8) )
    self.obj52.Type.config = 0
    self.obj52.Comments.setValue('; Make destination busy')
    self.obj52.Label.setValue('L16')
    self.obj52.graphClass_= graph_GPSSBlock
    if self.genGraphics:
       from graph_Logic import *
       new_obj = graph_Logic(379.0,440.0,self.obj52)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("GPSSBlock", new_obj.tag)
    else: new_obj = None
    self.obj52.graphObject_ = new_obj
    rootNode.addNode(self.obj52)
    self.globalAndLocalPostcondition(self.obj52, rootNode)

    self.globalPrecondition( rootNode )

    self.obj53=GPSSBlock(self)

    self.obj53.A.setValue('120')
    self.obj53.C.setValue('')
    self.obj53.B.setValue('FN$POISS')
    self.obj53.E.setValue('')
    self.obj53.D.setValue('')
    self.obj53.F.setValue('')
    self.obj53.X.setValue('')
    self.obj53.Type.setValue( (['Advance', 'Assign', 'Depart', 'Enter', 'Gate', 'Generate', 'Leave', 'Link', 'Logic', 'Mark', 'Priority', 'Queue', 'Release', 'SaveValue', 'Seize', 'Tabulate', 'Terminate', 'Test', 'Transfer', 'Unlink'], 0) )
    self.obj53.Type.config = 0
    self.obj53.Comments.setValue('; Talk')
    self.obj53.Label.setValue('L17')
    self.obj53.graphClass_= graph_GPSSBlock
    if self.genGraphics:
       from graph_Advance import *
       new_obj = graph_Advance(379.0,518.0,self.obj53)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("GPSSBlock", new_obj.tag)
    else: new_obj = None
    self.obj53.graphObject_ = new_obj
    rootNode.addNode(self.obj53)
    self.globalAndLocalPostcondition(self.obj53, rootNode)

    self.globalPrecondition( rootNode )

    self.obj54=GPSSBlock(self)

    self.obj54.A.setValue('P$DT')
    self.obj54.C.setValue('')
    self.obj54.B.setValue('')
    self.obj54.E.setValue('')
    self.obj54.D.setValue('')
    self.obj54.F.setValue('')
    self.obj54.X.setValue('R')
    self.obj54.Type.setValue( (['Advance', 'Assign', 'Depart', 'Enter', 'Gate', 'Generate', 'Leave', 'Link', 'Logic', 'Mark', 'Priority', 'Queue', 'Release', 'SaveValue', 'Seize', 'Tabulate', 'Terminate', 'Test', 'Transfer', 'Unlink'], 8) )
    self.obj54.Type.config = 0
    self.obj54.Comments.setValue('; Destination hangs up')
    self.obj54.Label.setValue('L18')
    self.obj54.graphClass_= graph_GPSSBlock
    if self.genGraphics:
       from graph_Logic import *
       new_obj = graph_Logic(378.0,601.0,self.obj54)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("GPSSBlock", new_obj.tag)
    else: new_obj = None
    self.obj54.graphObject_ = new_obj
    rootNode.addNode(self.obj54)
    self.globalAndLocalPostcondition(self.obj54, rootNode)

    self.globalPrecondition( rootNode )

    self.obj55=GPSSBlock(self)

    self.obj55.A.setValue('P$OR')
    self.obj55.C.setValue('')
    self.obj55.B.setValue('')
    self.obj55.E.setValue('')
    self.obj55.D.setValue('')
    self.obj55.F.setValue('')
    self.obj55.X.setValue('R')
    self.obj55.Type.setValue( (['Advance', 'Assign', 'Depart', 'Enter', 'Gate', 'Generate', 'Leave', 'Link', 'Logic', 'Mark', 'Priority', 'Queue', 'Release', 'SaveValue', 'Seize', 'Tabulate', 'Terminate', 'Test', 'Transfer', 'Unlink'], 8) )
    self.obj55.Type.config = 0
    self.obj55.Comments.setValue('; Origin hangs up')
    self.obj55.Label.setValue('L19')
    self.obj55.graphClass_= graph_GPSSBlock
    if self.genGraphics:
       from graph_Logic import *
       new_obj = graph_Logic(378.0,680.0,self.obj55)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("GPSSBlock", new_obj.tag)
    else: new_obj = None
    self.obj55.graphObject_ = new_obj
    rootNode.addNode(self.obj55)
    self.globalAndLocalPostcondition(self.obj55, rootNode)

    self.globalPrecondition( rootNode )

    self.obj56=GPSSBlock(self)

    self.obj56.A.setValue('LS')
    self.obj56.C.setValue('')
    self.obj56.B.setValue('')
    self.obj56.E.setValue('')
    self.obj56.D.setValue('')
    self.obj56.F.setValue('')
    self.obj56.X.setValue('')
    self.obj56.Type.setValue( (['Advance', 'Assign', 'Depart', 'Enter', 'Gate', 'Generate', 'Leave', 'Link', 'Logic', 'Mark', 'Priority', 'Queue', 'Release', 'SaveValue', 'Seize', 'Tabulate', 'Terminate', 'Test', 'Transfer', 'Unlink'], 6) )
    self.obj56.Type.config = 0
    self.obj56.Comments.setValue('; Free link.')
    self.obj56.Label.setValue('L20')
    self.obj56.graphClass_= graph_GPSSBlock
    if self.genGraphics:
       from graph_Leave import *
       new_obj = graph_Leave(371.0,757.0,self.obj56)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("GPSSBlock", new_obj.tag)
    else: new_obj = None
    self.obj56.graphObject_ = new_obj
    rootNode.addNode(self.obj56)
    self.globalAndLocalPostcondition(self.obj56, rootNode)

    self.globalPrecondition( rootNode )

    self.obj57=GPSSBlock(self)

    self.obj57.A.setValue('')
    self.obj57.C.setValue('')
    self.obj57.B.setValue('')
    self.obj57.E.setValue('')
    self.obj57.D.setValue('')
    self.obj57.F.setValue('')
    self.obj57.X.setValue('')
    self.obj57.Type.setValue( (['Advance', 'Assign', 'Depart', 'Enter', 'Gate', 'Generate', 'Leave', 'Link', 'Logic', 'Mark', 'Priority', 'Queue', 'Release', 'SaveValue', 'Seize', 'Tabulate', 'Terminate', 'Test', 'Transfer', 'Unlink'], 16) )
    self.obj57.Type.config = 0
    self.obj57.Comments.setValue('; Normal end of a succesful call.')
    self.obj57.Label.setValue('L21')
    self.obj57.graphClass_= graph_GPSSBlock
    if self.genGraphics:
       from graph_Terminate import *
       new_obj = graph_Terminate(388.0,1103.0,self.obj57)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("GPSSBlock", new_obj.tag)
    else: new_obj = None
    self.obj57.graphObject_ = new_obj
    rootNode.addNode(self.obj57)
    self.globalAndLocalPostcondition(self.obj57, rootNode)

    self.globalPrecondition( rootNode )

    self.obj58=GPSSBlock(self)

    self.obj58.A.setValue('60')
    self.obj58.C.setValue('')
    self.obj58.B.setValue('')
    self.obj58.E.setValue('')
    self.obj58.D.setValue('')
    self.obj58.F.setValue('')
    self.obj58.X.setValue('')
    self.obj58.Type.setValue( (['Advance', 'Assign', 'Depart', 'Enter', 'Gate', 'Generate', 'Leave', 'Link', 'Logic', 'Mark', 'Priority', 'Queue', 'Release', 'SaveValue', 'Seize', 'Tabulate', 'Terminate', 'Test', 'Transfer', 'Unlink'], 5) )
    self.obj58.Type.config = 0
    self.obj58.Comments.setValue('; One clock tick every minute')
    self.obj58.Label.setValue('L22')
    self.obj58.graphClass_= graph_GPSSBlock
    if self.genGraphics:
       from graph_Generate import *
       new_obj = graph_Generate(739.0,121.0,self.obj58)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("GPSSBlock", new_obj.tag)
    else: new_obj = None
    self.obj58.graphObject_ = new_obj
    rootNode.addNode(self.obj58)
    self.globalAndLocalPostcondition(self.obj58, rootNode)

    self.globalPrecondition( rootNode )

    self.obj59=GPSSBlock(self)

    self.obj59.A.setValue('1')
    self.obj59.C.setValue('')
    self.obj59.B.setValue('')
    self.obj59.E.setValue('')
    self.obj59.D.setValue('')
    self.obj59.F.setValue('')
    self.obj59.X.setValue('')
    self.obj59.Type.setValue( (['Advance', 'Assign', 'Depart', 'Enter', 'Gate', 'Generate', 'Leave', 'Link', 'Logic', 'Mark', 'Priority', 'Queue', 'Release', 'SaveValue', 'Seize', 'Tabulate', 'Terminate', 'Test', 'Transfer', 'Unlink'], 16) )
    self.obj59.Type.config = 0
    self.obj59.Comments.setValue('')
    self.obj59.Label.setValue('L23')
    self.obj59.graphClass_= graph_GPSSBlock
    if self.genGraphics:
       from graph_Terminate import *
       new_obj = graph_Terminate(747.0,207.0,self.obj59)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("GPSSBlock", new_obj.tag)
    else: new_obj = None
    self.obj59.graphObject_ = new_obj
    rootNode.addNode(self.obj59)
    self.globalAndLocalPostcondition(self.obj59, rootNode)

    self.globalPrecondition( rootNode )

    self.obj60=GPSSBlock(self)

    self.obj60.A.setValue('OR')
    self.obj60.C.setValue('')
    self.obj60.B.setValue('V$LN')
    self.obj60.E.setValue('')
    self.obj60.D.setValue('')
    self.obj60.F.setValue('')
    self.obj60.X.setValue('')
    self.obj60.Type.setValue( (['Advance', 'Assign', 'Depart', 'Enter', 'Gate', 'Generate', 'Leave', 'Link', 'Logic', 'Mark', 'Priority', 'Queue', 'Release', 'SaveValue', 'Seize', 'Tabulate', 'Terminate', 'Test', 'Transfer', 'Unlink'], 1) )
    self.obj60.Type.config = 0
    self.obj60.Comments.setValue('; Determine origin line. Store in param OR.')
    self.obj60.Label.setValue('ASN1')
    self.obj60.graphClass_= graph_GPSSBlock
    if self.genGraphics:
       from graph_Assign import *
       new_obj = graph_Assign(129.0,271.0,self.obj60)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("GPSSBlock", new_obj.tag)
    else: new_obj = None
    self.obj60.graphObject_ = new_obj
    rootNode.addNode(self.obj60)
    self.globalAndLocalPostcondition(self.obj60, rootNode)

    self.globalPrecondition( rootNode )

    self.obj61=GPSSBlock(self)

    self.obj61.A.setValue('')
    self.obj61.C.setValue('')
    self.obj61.B.setValue('L31')
    self.obj61.E.setValue('')
    self.obj61.D.setValue('')
    self.obj61.F.setValue('')
    self.obj61.X.setValue('')
    self.obj61.Type.setValue( (['Advance', 'Assign', 'Depart', 'Enter', 'Gate', 'Generate', 'Leave', 'Link', 'Logic', 'Mark', 'Priority', 'Queue', 'Release', 'SaveValue', 'Seize', 'Tabulate', 'Terminate', 'Test', 'Transfer', 'Unlink'], 18) )
    self.obj61.Type.config = 0
    self.obj61.Comments.setValue('; Go to test for waiting calls.')
    self.obj61.Label.setValue('L30')
    self.obj61.graphClass_= graph_GPSSBlock
    if self.genGraphics:
       from graph_Transfer import *
       new_obj = graph_Transfer(535.0,540.0,self.obj61)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("GPSSBlock", new_obj.tag)
    else: new_obj = None
    self.obj61.graphObject_ = new_obj
    rootNode.addNode(self.obj61)
    self.globalAndLocalPostcondition(self.obj61, rootNode)

    self.globalPrecondition( rootNode )

    self.obj62=GPSSBlock(self)

    self.obj62.A.setValue('CH$WAIT')
    self.obj62.C.setValue('L32')
    self.obj62.B.setValue('0')
    self.obj62.E.setValue('')
    self.obj62.D.setValue('')
    self.obj62.F.setValue('')
    self.obj62.X.setValue('G')
    self.obj62.Type.setValue( (['Advance', 'Assign', 'Depart', 'Enter', 'Gate', 'Generate', 'Leave', 'Link', 'Logic', 'Mark', 'Priority', 'Queue', 'Release', 'SaveValue', 'Seize', 'Tabulate', 'Terminate', 'Test', 'Transfer', 'Unlink'], 17) )
    self.obj62.Type.config = 0
    self.obj62.Comments.setValue('; Test if calls are queued.')
    self.obj62.Label.setValue('L31')
    self.obj62.graphClass_= graph_GPSSBlock
    if self.genGraphics:
       from graph_Test import *
       new_obj = graph_Test(375.0,850.0,self.obj62)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("GPSSBlock", new_obj.tag)
    else: new_obj = None
    self.obj62.graphObject_ = new_obj
    rootNode.addNode(self.obj62)
    self.globalAndLocalPostcondition(self.obj62, rootNode)

    self.globalPrecondition( rootNode )

    self.obj63=GPSSBlock(self)

    self.obj63.A.setValue('1')
    self.obj63.C.setValue('')
    self.obj63.B.setValue('L33')
    self.obj63.E.setValue('')
    self.obj63.D.setValue('')
    self.obj63.F.setValue('')
    self.obj63.X.setValue('LR')
    self.obj63.Type.setValue( (['Advance', 'Assign', 'Depart', 'Enter', 'Gate', 'Generate', 'Leave', 'Link', 'Logic', 'Mark', 'Priority', 'Queue', 'Release', 'SaveValue', 'Seize', 'Tabulate', 'Terminate', 'Test', 'Transfer', 'Unlink'], 4) )
    self.obj63.Type.config = 0
    self.obj63.Comments.setValue('; Check if line 1 (president) is free.')
    self.obj63.Label.setValue('L32')
    self.obj63.graphClass_= graph_GPSSBlock
    if self.genGraphics:
       from graph_Gate import *
       new_obj = graph_Gate(372.0,934.0,self.obj63)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("GPSSBlock", new_obj.tag)
    else: new_obj = None
    self.obj63.graphObject_ = new_obj
    rootNode.addNode(self.obj63)
    self.globalAndLocalPostcondition(self.obj63, rootNode)

    self.globalPrecondition( rootNode )

    self.obj64=GPSSBlock(self)

    self.obj64.A.setValue('WAIT')
    self.obj64.C.setValue('1')
    self.obj64.B.setValue('GETL')
    self.obj64.E.setValue('1')
    self.obj64.D.setValue('P$DT')
    self.obj64.F.setValue('GETF')
    self.obj64.X.setValue('')
    self.obj64.Type.setValue( (['Advance', 'Assign', 'Depart', 'Enter', 'Gate', 'Generate', 'Leave', 'Link', 'Logic', 'Mark', 'Priority', 'Queue', 'Release', 'SaveValue', 'Seize', 'Tabulate', 'Terminate', 'Test', 'Transfer', 'Unlink'], 19) )
    self.obj64.Type.config = 0
    self.obj64.Comments.setValue('; Connect call from origin 1.')
    self.obj64.Label.setValue('L33')
    self.obj64.graphClass_= graph_GPSSBlock
    if self.genGraphics:
       from graph_Unlink import *
       new_obj = graph_Unlink(343.0,986.0,self.obj64)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("GPSSBlock", new_obj.tag)
    else: new_obj = None
    self.obj64.graphObject_ = new_obj
    rootNode.addNode(self.obj64)
    self.globalAndLocalPostcondition(self.obj64, rootNode)

    self.globalPrecondition( rootNode )

    self.obj97=GPSSBlock(self)

    self.obj97.A.setValue('WAIT')
    self.obj97.C.setValue('1')
    self.obj97.B.setValue('GETL')
    self.obj97.E.setValue('')
    self.obj97.D.setValue('')
    self.obj97.F.setValue('')
    self.obj97.X.setValue('')
    self.obj97.Type.setValue( (['Advance', 'Assign', 'Depart', 'Enter', 'Gate', 'Generate', 'Leave', 'Link', 'Logic', 'Mark', 'Priority', 'Queue', 'Release', 'SaveValue', 'Seize', 'Tabulate', 'Terminate', 'Test', 'Transfer', 'Unlink'], 19) )
    self.obj97.Type.config = 0
    self.obj97.Comments.setValue('; Connect first waiting call.')
    self.obj97.Label.setValue('L34')
    self.obj97.graphClass_= graph_GPSSBlock
    if self.genGraphics:
       from graph_Unlink import *
       new_obj = graph_Unlink(121.0,984.0,self.obj97)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("GPSSBlock", new_obj.tag)
    else: new_obj = None
    self.obj97.graphObject_ = new_obj
    rootNode.addNode(self.obj97)
    self.globalAndLocalPostcondition(self.obj97, rootNode)

    self.globalPrecondition( rootNode )

    self.obj106=GPSSBlock(self)

    self.obj106.A.setValue('')
    self.obj106.C.setValue('')
    self.obj106.B.setValue('L21')
    self.obj106.E.setValue('')
    self.obj106.D.setValue('')
    self.obj106.F.setValue('')
    self.obj106.X.setValue('')
    self.obj106.Type.setValue( (['Advance', 'Assign', 'Depart', 'Enter', 'Gate', 'Generate', 'Leave', 'Link', 'Logic', 'Mark', 'Priority', 'Queue', 'Release', 'SaveValue', 'Seize', 'Tabulate', 'Terminate', 'Test', 'Transfer', 'Unlink'], 18) )
    self.obj106.Type.config = 0
    self.obj106.Comments.setValue('')
    self.obj106.Label.setValue('L35')
    self.obj106.graphClass_= graph_GPSSBlock
    if self.genGraphics:
       from graph_Transfer import *
       new_obj = graph_Transfer(150.0,1100.0,self.obj106)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("GPSSBlock", new_obj.tag)
    else: new_obj = None
    self.obj106.graphObject_ = new_obj
    rootNode.addNode(self.obj106)
    self.globalAndLocalPostcondition(self.obj106, rootNode)

    self.globalPrecondition( rootNode )

    self.obj65=Function(self)

    self.obj65.Input.setValue('RN1')
    self.obj65.Points.setActionFlags([ 1, 1, 1, 0])
    lcobj1 =[]
    cobj1= xXy()
    cobj1.x=ATOM3Float(0.0)
    cobj1.y=ATOM3Float(0.0)
    lcobj1.append(cobj1)
    cobj1= xXy()
    cobj1.x=ATOM3Float(0.1)
    cobj1.y=ATOM3Float(0.104)
    lcobj1.append(cobj1)
    cobj1= xXy()
    cobj1.x=ATOM3Float(0.2)
    cobj1.y=ATOM3Float(0.222)
    lcobj1.append(cobj1)
    cobj1= xXy()
    cobj1.x=ATOM3Float(0.3)
    cobj1.y=ATOM3Float(0.355)
    lcobj1.append(cobj1)
    cobj1= xXy()
    cobj1.x=ATOM3Float(0.4)
    cobj1.y=ATOM3Float(0.509)
    lcobj1.append(cobj1)
    cobj1= xXy()
    cobj1.x=ATOM3Float(0.5)
    cobj1.y=ATOM3Float(0.69)
    lcobj1.append(cobj1)
    cobj1= xXy()
    cobj1.x=ATOM3Float(0.6)
    cobj1.y=ATOM3Float(0.915)
    lcobj1.append(cobj1)
    cobj1= xXy()
    cobj1.x=ATOM3Float(0.7)
    cobj1.y=ATOM3Float(1.2)
    lcobj1.append(cobj1)
    cobj1= xXy()
    cobj1.x=ATOM3Float(0.8)
    cobj1.y=ATOM3Float(1.6)
    lcobj1.append(cobj1)
    cobj1= xXy()
    cobj1.x=ATOM3Float(0.84)
    cobj1.y=ATOM3Float(1.83)
    lcobj1.append(cobj1)
    cobj1= xXy()
    cobj1.x=ATOM3Float(0.88)
    cobj1.y=ATOM3Float(7.12)
    lcobj1.append(cobj1)
    cobj1= xXy()
    cobj1.x=ATOM3Float(0.9)
    cobj1.y=ATOM3Float(2.3)
    lcobj1.append(cobj1)
    cobj1= xXy()
    cobj1.x=ATOM3Float(0.92)
    cobj1.y=ATOM3Float(2.52)
    lcobj1.append(cobj1)
    cobj1= xXy()
    cobj1.x=ATOM3Float(0.94)
    cobj1.y=ATOM3Float(2.81)
    lcobj1.append(cobj1)
    cobj1= xXy()
    cobj1.x=ATOM3Float(0.95)
    cobj1.y=ATOM3Float(2.99)
    lcobj1.append(cobj1)
    cobj1= xXy()
    cobj1.x=ATOM3Float(0.96)
    cobj1.y=ATOM3Float(3.2)
    lcobj1.append(cobj1)
    cobj1= xXy()
    cobj1.x=ATOM3Float(0.97)
    cobj1.y=ATOM3Float(3.5)
    lcobj1.append(cobj1)
    cobj1= xXy()
    cobj1.x=ATOM3Float(0.98)
    cobj1.y=ATOM3Float(3.9)
    lcobj1.append(cobj1)
    cobj1= xXy()
    cobj1.x=ATOM3Float(0.99)
    cobj1.y=ATOM3Float(4.6)
    lcobj1.append(cobj1)
    cobj1= xXy()
    cobj1.x=ATOM3Float(0.995)
    cobj1.y=ATOM3Float(5.3)
    lcobj1.append(cobj1)
    cobj1= xXy()
    cobj1.x=ATOM3Float(0.998)
    cobj1.y=ATOM3Float(6.2)
    lcobj1.append(cobj1)
    cobj1= xXy()
    cobj1.x=ATOM3Float(0.999)
    cobj1.y=ATOM3Float(7.0)
    lcobj1.append(cobj1)
    cobj1= xXy()
    cobj1.x=ATOM3Float(0.9997)
    cobj1.y=ATOM3Float(8.0)
    lcobj1.append(cobj1)
    self.obj65.Points.setValue(lcobj1)
    self.obj65.Mode.setValue( (['Continuous', 'Discrete'], 0) )
    self.obj65.Mode.config = 0
    self.obj65.Number_Of_Points.setValue(24)
    self.obj65.Function_Number.setValue('POISS')
    self.obj65.graphClass_= graph_Function
    if self.genGraphics:
       from graph_Function import *
       new_obj = graph_Function(312.0,18.0,self.obj65)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("Function", new_obj.tag)
    else: new_obj = None
    self.obj65.graphObject_ = new_obj
    rootNode.addNode(self.obj65)
    self.globalAndLocalPostcondition(self.obj65, rootNode)

    self.globalPrecondition( rootNode )

    self.obj66=Storage_Size(self)

    self.obj66.Storage_Size.setValue(10)
    self.obj66.Storage_Name.setValue('LS')
    self.obj66.graphClass_= graph_Storage_Size
    if self.genGraphics:
       from graph_Storage_Size import *
       new_obj = graph_Storage_Size(643.0,15.0,self.obj66)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("Storage_Size", new_obj.tag)
    else: new_obj = None
    self.obj66.graphObject_ = new_obj
    rootNode.addNode(self.obj66)
    self.globalAndLocalPostcondition(self.obj66, rootNode)

    self.globalPrecondition( rootNode )

    self.obj67=SNAVariable(self)

    self.obj67.Expression.setValue('X$LS-2*S$LS')
    self.obj67.Type.setValue( (['Integer', 'Float', 'Boolean'], 1) )
    self.obj67.Type.config = 0
    self.obj67.Name.setValue('FL')
    self.obj67.graphClass_= graph_SNAVariable
    if self.genGraphics:
       from graph_SNAVariable import *
       new_obj = graph_SNAVariable(451.0,16.0,self.obj67)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("SNAVariable", new_obj.tag)
    else: new_obj = None
    self.obj67.graphObject_ = new_obj
    rootNode.addNode(self.obj67)
    self.globalAndLocalPostcondition(self.obj67, rootNode)

    self.globalPrecondition( rootNode )

    self.obj68=SNAVariable(self)

    self.obj68.Expression.setValue('X$LS*RN1/1000+1')
    self.obj68.Type.setValue( (['Integer', 'Float', 'Boolean'], 1) )
    self.obj68.Type.config = 0
    self.obj68.Name.setValue('LN')
    self.obj68.graphClass_= graph_SNAVariable
    if self.genGraphics:
       from graph_SNAVariable import *
       new_obj = graph_SNAVariable(452.0,79.0,self.obj68)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("SNAVariable", new_obj.tag)
    else: new_obj = None
    self.obj68.graphObject_ = new_obj
    rootNode.addNode(self.obj68)
    self.globalAndLocalPostcondition(self.obj68, rootNode)

    self.globalPrecondition( rootNode )

    self.obj69=connected_to(self)

    self.obj69.graphClass_= graph_connected_to
    if self.genGraphics:
       from graph_connected_to import *
       new_obj = graph_connected_to(210.0,424.0,self.obj69)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("connected_to", new_obj.tag)
    else: new_obj = None
    self.obj69.graphObject_ = new_obj
    rootNode.addNode(self.obj69)
    self.globalAndLocalPostcondition(self.obj69, rootNode)

    self.globalPrecondition( rootNode )

    self.obj70=connected_to(self)

    self.obj70.graphClass_= graph_connected_to
    if self.genGraphics:
       from graph_connected_to import *
       new_obj = graph_connected_to(212.0,521.0,self.obj70)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("connected_to", new_obj.tag)
    else: new_obj = None
    self.obj70.graphObject_ = new_obj
    rootNode.addNode(self.obj70)
    self.globalAndLocalPostcondition(self.obj70, rootNode)

    self.globalPrecondition( rootNode )

    self.obj71=connected_to(self)

    self.obj71.graphClass_= graph_connected_to
    if self.genGraphics:
       from graph_connected_to import *
       new_obj = graph_connected_to(108.0,428.0,self.obj71)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("connected_to", new_obj.tag)
    else: new_obj = None
    self.obj71.graphObject_ = new_obj
    rootNode.addNode(self.obj71)
    self.globalAndLocalPostcondition(self.obj71, rootNode)

    self.globalPrecondition( rootNode )

    self.obj72=connected_to(self)

    self.obj72.graphClass_= graph_connected_to
    if self.genGraphics:
       from graph_connected_to import *
       new_obj = graph_connected_to(212.0,620.0,self.obj72)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("connected_to", new_obj.tag)
    else: new_obj = None
    self.obj72.graphObject_ = new_obj
    rootNode.addNode(self.obj72)
    self.globalAndLocalPostcondition(self.obj72, rootNode)

    self.globalPrecondition( rootNode )

    self.obj73=connected_to(self)

    self.obj73.graphClass_= graph_connected_to
    if self.genGraphics:
       from graph_connected_to import *
       new_obj = graph_connected_to(293.0,711.0,self.obj73)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("connected_to", new_obj.tag)
    else: new_obj = None
    self.obj73.graphObject_ = new_obj
    rootNode.addNode(self.obj73)
    self.globalAndLocalPostcondition(self.obj73, rootNode)

    self.globalPrecondition( rootNode )

    self.obj74=connected_to(self)

    self.obj74.graphClass_= graph_connected_to
    if self.genGraphics:
       from graph_connected_to import *
       new_obj = graph_connected_to(423.0,247.0,self.obj74)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("connected_to", new_obj.tag)
    else: new_obj = None
    self.obj74.graphObject_ = new_obj
    rootNode.addNode(self.obj74)
    self.globalAndLocalPostcondition(self.obj74, rootNode)

    self.globalPrecondition( rootNode )

    self.obj75=connected_to(self)

    self.obj75.graphClass_= graph_connected_to
    if self.genGraphics:
       from graph_connected_to import *
       new_obj = graph_connected_to(423.0,363.0,self.obj75)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("connected_to", new_obj.tag)
    else: new_obj = None
    self.obj75.graphObject_ = new_obj
    rootNode.addNode(self.obj75)
    self.globalAndLocalPostcondition(self.obj75, rootNode)

    self.globalPrecondition( rootNode )

    self.obj76=connected_to(self)

    self.obj76.graphClass_= graph_connected_to
    if self.genGraphics:
       from graph_connected_to import *
       new_obj = graph_connected_to(516.0,394.0,self.obj76)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("connected_to", new_obj.tag)
    else: new_obj = None
    self.obj76.graphObject_ = new_obj
    rootNode.addNode(self.obj76)
    self.globalAndLocalPostcondition(self.obj76, rootNode)

    self.globalPrecondition( rootNode )

    self.obj77=connected_to(self)

    self.obj77.graphClass_= graph_connected_to
    if self.genGraphics:
       from graph_connected_to import *
       new_obj = graph_connected_to(581.0,436.0,self.obj77)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("connected_to", new_obj.tag)
    else: new_obj = None
    self.obj77.graphObject_ = new_obj
    rootNode.addNode(self.obj77)
    self.globalAndLocalPostcondition(self.obj77, rootNode)

    self.globalPrecondition( rootNode )

    self.obj78=connected_to(self)

    self.obj78.graphClass_= graph_connected_to
    if self.genGraphics:
       from graph_connected_to import *
       new_obj = graph_connected_to(422.0,432.0,self.obj78)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("connected_to", new_obj.tag)
    else: new_obj = None
    self.obj78.graphObject_ = new_obj
    rootNode.addNode(self.obj78)
    self.globalAndLocalPostcondition(self.obj78, rootNode)

    self.globalPrecondition( rootNode )

    self.obj79=connected_to(self)

    self.obj79.graphClass_= graph_connected_to
    if self.genGraphics:
       from graph_connected_to import *
       new_obj = graph_connected_to(423.0,511.0,self.obj79)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("connected_to", new_obj.tag)
    else: new_obj = None
    self.obj79.graphObject_ = new_obj
    rootNode.addNode(self.obj79)
    self.globalAndLocalPostcondition(self.obj79, rootNode)

    self.globalPrecondition( rootNode )

    self.obj80=connected_to(self)

    self.obj80.graphClass_= graph_connected_to
    if self.genGraphics:
       from graph_connected_to import *
       new_obj = graph_connected_to(422.0,670.0,self.obj80)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("connected_to", new_obj.tag)
    else: new_obj = None
    self.obj80.graphObject_ = new_obj
    rootNode.addNode(self.obj80)
    self.globalAndLocalPostcondition(self.obj80, rootNode)

    self.globalPrecondition( rootNode )

    self.obj81=connected_to(self)

    self.obj81.graphClass_= graph_connected_to
    if self.genGraphics:
       from graph_connected_to import *
       new_obj = graph_connected_to(422.0,753.0,self.obj81)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("connected_to", new_obj.tag)
    else: new_obj = None
    self.obj81.graphObject_ = new_obj
    rootNode.addNode(self.obj81)
    self.globalAndLocalPostcondition(self.obj81, rootNode)

    self.globalPrecondition( rootNode )

    self.obj82=connected_to(self)

    self.obj82.graphClass_= graph_connected_to
    if self.genGraphics:
       from graph_connected_to import *
       new_obj = graph_connected_to(422.0,585.0,self.obj82)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("connected_to", new_obj.tag)
    else: new_obj = None
    self.obj82.graphObject_ = new_obj
    rootNode.addNode(self.obj82)
    self.globalAndLocalPostcondition(self.obj82, rootNode)

    self.globalPrecondition( rootNode )

    self.obj84=connected_to(self)

    self.obj84.graphClass_= graph_connected_to
    if self.genGraphics:
       from graph_connected_to import *
       new_obj = graph_connected_to(779.0,192.0,self.obj84)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("connected_to", new_obj.tag)
    else: new_obj = None
    self.obj84.graphObject_ = new_obj
    rootNode.addNode(self.obj84)
    self.globalAndLocalPostcondition(self.obj84, rootNode)

    self.globalPrecondition( rootNode )

    self.obj85=connected_to(self)

    self.obj85.graphClass_= graph_connected_to
    if self.genGraphics:
       from graph_connected_to import *
       new_obj = graph_connected_to(208.0,145.5,self.obj85)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("connected_to", new_obj.tag)
    else: new_obj = None
    self.obj85.graphObject_ = new_obj
    rootNode.addNode(self.obj85)
    self.globalAndLocalPostcondition(self.obj85, rootNode)

    self.globalPrecondition( rootNode )

    self.obj86=connected_to(self)

    self.obj86.graphClass_= graph_connected_to
    if self.genGraphics:
       from graph_connected_to import *
       new_obj = graph_connected_to(44.5,203.0,self.obj86)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("connected_to", new_obj.tag)
    else: new_obj = None
    self.obj86.graphObject_ = new_obj
    rootNode.addNode(self.obj86)
    self.globalAndLocalPostcondition(self.obj86, rootNode)

    self.globalPrecondition( rootNode )

    self.obj87=connected_to(self)

    self.obj87.graphClass_= graph_connected_to
    if self.genGraphics:
       from graph_connected_to import *
       new_obj = graph_connected_to(211.5,251.0,self.obj87)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("connected_to", new_obj.tag)
    else: new_obj = None
    self.obj87.graphObject_ = new_obj
    rootNode.addNode(self.obj87)
    self.globalAndLocalPostcondition(self.obj87, rootNode)

    self.globalPrecondition( rootNode )

    self.obj88=connected_to(self)

    self.obj88.graphClass_= graph_connected_to
    if self.genGraphics:
       from graph_connected_to import *
       new_obj = graph_connected_to(211.5,341.0,self.obj88)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("connected_to", new_obj.tag)
    else: new_obj = None
    self.obj88.graphObject_ = new_obj
    rootNode.addNode(self.obj88)
    self.globalAndLocalPostcondition(self.obj88, rootNode)

    self.globalPrecondition( rootNode )

    self.obj89=connected_to(self)

    self.obj89.graphClass_= graph_connected_to
    if self.genGraphics:
       from graph_connected_to import *
       new_obj = graph_connected_to(115.5,385.5,self.obj89)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("connected_to", new_obj.tag)
    else: new_obj = None
    self.obj89.graphObject_ = new_obj
    rootNode.addNode(self.obj89)
    self.globalAndLocalPostcondition(self.obj89, rootNode)

    self.globalPrecondition( rootNode )

    self.obj90=connected_to(self)

    self.obj90.graphClass_= graph_connected_to
    if self.genGraphics:
       from graph_connected_to import *
       new_obj = graph_connected_to(581.0,526.5,self.obj90)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("connected_to", new_obj.tag)
    else: new_obj = None
    self.obj90.graphObject_ = new_obj
    rootNode.addNode(self.obj90)
    self.globalAndLocalPostcondition(self.obj90, rootNode)

    self.globalPrecondition( rootNode )

    self.obj91=connected_to(self)

    self.obj91.graphClass_= graph_connected_to
    if self.genGraphics:
       from graph_connected_to import *
       new_obj = graph_connected_to(421.0,840.0,self.obj91)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("connected_to", new_obj.tag)
    else: new_obj = None
    self.obj91.graphObject_ = new_obj
    rootNode.addNode(self.obj91)
    self.globalAndLocalPostcondition(self.obj91, rootNode)

    self.globalPrecondition( rootNode )

    self.obj92=connected_to(self)

    self.obj92.graphClass_= graph_connected_to
    if self.genGraphics:
       from graph_connected_to import *
       new_obj = graph_connected_to(421.5,925.5,self.obj92)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("connected_to", new_obj.tag)
    else: new_obj = None
    self.obj92.graphObject_ = new_obj
    rootNode.addNode(self.obj92)
    self.globalAndLocalPostcondition(self.obj92, rootNode)

    self.globalPrecondition( rootNode )

    self.obj94=connected_to(self)

    self.obj94.graphClass_= graph_connected_to
    if self.genGraphics:
       from graph_connected_to import *
       new_obj = graph_connected_to(582.0,836.0,self.obj94)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("connected_to", new_obj.tag)
    else: new_obj = None
    self.obj94.graphObject_ = new_obj
    rootNode.addNode(self.obj94)
    self.globalAndLocalPostcondition(self.obj94, rootNode)

    self.globalPrecondition( rootNode )

    self.obj95=connected_to(self)

    self.obj95.graphClass_= graph_connected_to
    if self.genGraphics:
       from graph_connected_to import *
       new_obj = graph_connected_to(506.0,190.0,self.obj95)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("connected_to", new_obj.tag)
    else: new_obj = None
    self.obj95.graphObject_ = new_obj
    rootNode.addNode(self.obj95)
    self.globalAndLocalPostcondition(self.obj95, rootNode)

    self.globalPrecondition( rootNode )

    self.obj96=connected_to(self)

    self.obj96.graphClass_= graph_connected_to
    if self.genGraphics:
       from graph_connected_to import *
       new_obj = graph_connected_to(420.5,1000.5,self.obj96)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("connected_to", new_obj.tag)
    else: new_obj = None
    self.obj96.graphObject_ = new_obj
    rootNode.addNode(self.obj96)
    self.globalAndLocalPostcondition(self.obj96, rootNode)

    self.globalPrecondition( rootNode )

    self.obj100=connected_to(self)

    self.obj100.graphClass_= graph_connected_to
    if self.genGraphics:
       from graph_connected_to import *
       new_obj = graph_connected_to(293.5,1042.0,self.obj100)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("connected_to", new_obj.tag)
    else: new_obj = None
    self.obj100.graphObject_ = new_obj
    rootNode.addNode(self.obj100)
    self.globalAndLocalPostcondition(self.obj100, rootNode)

    self.globalPrecondition( rootNode )

    self.obj101=connected_to(self)

    self.obj101.graphClass_= graph_connected_to
    if self.genGraphics:
       from graph_connected_to import *
       new_obj = graph_connected_to(420.5,1092.0,self.obj101)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("connected_to", new_obj.tag)
    else: new_obj = None
    self.obj101.graphObject_ = new_obj
    rootNode.addNode(self.obj101)
    self.globalAndLocalPostcondition(self.obj101, rootNode)

    self.globalPrecondition( rootNode )

    self.obj102=connected_to(self)

    self.obj102.graphClass_= graph_connected_to
    if self.genGraphics:
       from graph_connected_to import *
       new_obj = graph_connected_to(533.0,884.5,self.obj102)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("connected_to", new_obj.tag)
    else: new_obj = None
    self.obj102.graphObject_ = new_obj
    rootNode.addNode(self.obj102)
    self.globalAndLocalPostcondition(self.obj102, rootNode)

    self.globalPrecondition( rootNode )

    self.obj103=connected_to(self)

    self.obj103.graphClass_= graph_connected_to
    if self.genGraphics:
       from graph_connected_to import *
       new_obj = graph_connected_to(704.0,268.0,self.obj103)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("connected_to", new_obj.tag)
    else: new_obj = None
    self.obj103.graphObject_ = new_obj
    rootNode.addNode(self.obj103)
    self.globalAndLocalPostcondition(self.obj103, rootNode)

    self.globalPrecondition( rootNode )

    self.obj104=connected_to(self)

    self.obj104.graphClass_= graph_connected_to
    if self.genGraphics:
       from graph_connected_to import *
       new_obj = graph_connected_to(198.0,964.0,self.obj104)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("connected_to", new_obj.tag)
    else: new_obj = None
    self.obj104.graphObject_ = new_obj
    rootNode.addNode(self.obj104)
    self.globalAndLocalPostcondition(self.obj104, rootNode)

    self.globalPrecondition( rootNode )

    self.obj105=connected_to(self)

    self.obj105.graphClass_= graph_connected_to
    if self.genGraphics:
       from graph_connected_to import *
       new_obj = graph_connected_to(314.0,683.0,self.obj105)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("connected_to", new_obj.tag)
    else: new_obj = None
    self.obj105.graphObject_ = new_obj
    rootNode.addNode(self.obj105)
    self.globalAndLocalPostcondition(self.obj105, rootNode)

    self.globalPrecondition( rootNode )

    self.obj109=connected_to(self)

    self.obj109.graphClass_= graph_connected_to
    if self.genGraphics:
       from graph_connected_to import *
       new_obj = graph_connected_to(197.0,1083.5,self.obj109)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("connected_to", new_obj.tag)
    else: new_obj = None
    self.obj109.graphObject_ = new_obj
    rootNode.addNode(self.obj109)
    self.globalAndLocalPostcondition(self.obj109, rootNode)

    self.globalPrecondition( rootNode )

    self.obj110=connected_to(self)

    self.obj110.graphClass_= graph_connected_to
    if self.genGraphics:
       from graph_connected_to import *
       new_obj = graph_connected_to(316.5,1134.5,self.obj110)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("connected_to", new_obj.tag)
    else: new_obj = None
    self.obj110.graphObject_ = new_obj
    rootNode.addNode(self.obj110)
    self.globalAndLocalPostcondition(self.obj110, rootNode)
    self.drawConnections((self.obj39,self.obj85,[209.0, 134.0, 208.0, 145.5], 0, 2), (self.obj41,self.obj86,[168.0, 202.0, 44.5, 203.0], 0, 2), (self.obj41,self.obj87,[211.0, 233.0, 211.5, 251.0], 0, 2), (self.obj42,self.obj69,[211.0, 408.0, 210.0, 424.0], 0, 2), (self.obj42,self.obj89,[165.0, 385.0, 115.5, 385.5], 0, 2), (self.obj43,self.obj70,[212.0, 505.0, 212.0, 521.0], 0, 2), (self.obj44,self.obj71,[169.0, 575.0, 107.0, 575.0, 108.0, 428.0], 0, 3), (self.obj44,self.obj72,[212.0, 606.0, 212.0, 620.0], 0, 2), (self.obj45,self.obj73,[211.0, 693.0, 212.0, 712.0, 293.0, 711.0], 0, 3), (self.obj46,self.obj74,[422.0, 221.0, 423.0, 247.0], 0, 2), (self.obj46,self.obj95,[467.0, 189.0, 506.0, 190.0], 0, 2), (self.obj47,self.obj75,[422.0, 353.0, 423.0, 363.0], 0, 2), (self.obj49,self.obj76,[497.0, 393.0, 516.0, 394.0], 0, 2), (self.obj49,self.obj78,[422.0, 418.0, 422.0, 432.0], 0, 2), (self.obj50,self.obj77,[580.0, 418.0, 581.0, 436.0], 0, 2), (self.obj51,self.obj90,[581.0, 510.0, 581.0, 526.5], 0, 2), (self.obj52,self.obj79,[422.0, 494.0, 423.0, 511.0], 0, 2), (self.obj53,self.obj82,[419.0, 571.0, 422.0, 585.0], 0, 2), (self.obj54,self.obj80,[421.0, 655.0, 422.0, 670.0], 0, 2), (self.obj55,self.obj81,[421.0, 734.0, 422.0, 753.0], 0, 2), (self.obj56,self.obj91,[421.0, 824.0, 421.0, 840.0], 0, 2), (self.obj58,self.obj84,[779.0, 175.0, 779.0, 192.0], 0, 2), (self.obj60,self.obj88,[212.0, 327.0, 211.5, 341.0], 0, 2), (self.obj61,self.obj94,[582.0, 606.0, 582.0, 836.0], 0, 2), (self.obj62,self.obj92,[422.0, 916.0, 421.5, 925.5], 0, 2), (self.obj62,self.obj102,[467.0, 884.0, 533.0, 884.5], 0, 2), (self.obj63,self.obj96,[421.0, 986.0, 420.5, 1000.5], 0, 2), (self.obj63,self.obj104,[375.0, 963.0, 198.0, 964.0], 0, 2), (self.obj64,self.obj100,[352.0, 1041.0, 293.5, 1042.0], 0, 2), (self.obj64,self.obj101,[419.0, 1069.0, 420.5, 1092.0], 0, 2), (self.obj64,self.obj103,[468.0, 1043.0, 704.0, 1044.0, 704.0, 268.0], 0, 3), (self.obj97,self.obj105,[176.0, 1015.0, 175.0, 792.0, 315.0, 791.0, 314.0, 683.0], 0, 4), (self.obj97,self.obj109,[197.0, 1067.0, 197.0, 1083.5], 0, 2), (self.obj106,self.obj110,[242.0, 1134.0, 316.5, 1134.5], 0, 2), (self.obj69,self.obj43,[210.0, 424.0, 211.0, 452.0], 0, 2), (self.obj70,self.obj44,[212.0, 521.0, 211.0, 543.0], 0, 2), (self.obj71,self.obj43,[108.0, 428.0, 211.0, 428.0, 211.0, 452.0], 0, 3), (self.obj72,self.obj45,[212.0, 620.0, 211.0, 642.0], 0, 2), (self.obj73,self.obj46,[293.0, 711.0, 292.0, 136.0, 420.0, 135.0, 421.0, 158.0], 0, 4), (self.obj74,self.obj47,[423.0, 247.0, 422.0, 295.0], 0, 2), (self.obj75,self.obj49,[423.0, 363.0, 423.0, 370.0], 0, 2), (self.obj76,self.obj50,[516.0, 394.0, 540.0, 393.0], 0, 2), (self.obj77,self.obj51,[581.0, 436.0, 581.0, 452.0], 0, 2), (self.obj78,self.obj52,[422.0, 432.0, 422.0, 443.0], 0, 2), (self.obj79,self.obj53,[423.0, 511.0, 420.0, 521.0], 0, 2), (self.obj80,self.obj55,[422.0, 670.0, 421.0, 683.0], 0, 2), (self.obj81,self.obj56,[422.0, 753.0, 421.0, 766.0], 0, 2), (self.obj82,self.obj54,[422.0, 585.0, 421.0, 604.0], 0, 2), (self.obj84,self.obj59,[779.0, 192.0, 778.0, 210.0], 0, 2), (self.obj85,self.obj41,[208.0, 145.5, 210.0, 170.0], 0, 2), (self.obj86,self.obj40,[44.5, 203.0, 45.0, 227.0], 0, 2), (self.obj87,self.obj60,[211.5, 251.0, 211.0, 274.0], 0, 2), (self.obj88,self.obj42,[211.5, 341.0, 212.0, 360.0], 0, 2), (self.obj89,self.obj60,[115.5, 385.5, 115.0, 248.0, 212.0, 249.0, 211.0, 274.0], 0, 4), (self.obj90,self.obj61,[581.0, 526.5, 581.0, 543.0], 0, 2), (self.obj91,self.obj62,[421.0, 840.0, 421.0, 853.0], 0, 2), (self.obj92,self.obj63,[421.5, 925.5, 422.0, 938.0], 0, 2), (self.obj94,self.obj62,[582.0, 836.0, 423.0, 836.0, 421.0, 853.0], 0, 3), (self.obj95,self.obj48,[506.0, 190.0, 529.0, 190.0], 0, 2), (self.obj96,self.obj64,[420.5, 1000.5, 420.0, 1017.0], 0, 2), (self.obj100,self.obj97,[293.5, 1042.0, 246.0, 1041.0], 0, 2), (self.obj101,self.obj57,[420.5, 1092.0, 419.0, 1106.0], 0, 2), (self.obj102,self.obj57,[533.0, 884.5, 532.0, 1085.0, 420.0, 1085.0, 419.0, 1106.0], 0, 4), (self.obj103,self.obj47,[704.0, 268.0, 423.0, 267.0, 422.0, 295.0], 0, 3), (self.obj104,self.obj97,[198.0, 964.0, 198.0, 1015.0], 0, 2), (self.obj105,self.obj47,[314.0, 683.0, 314.0, 268.0, 423.0, 269.0, 422.0, 295.0], 0, 4), (self.obj109,self.obj106,[197.0, 1083.5, 196.0, 1103.0], 0, 2), (self.obj110,self.obj57,[316.5, 1134.5, 391.0, 1135.0], 0, 2) )

newfunction = telephone_2_GPSS_mdl

loadedTypes = [('Point', 'Point', (), 1),('ControlStatement', 'ControlStatement', (), 1)]
loadedMMName = 'GPSSMetaModel'
