# _ startNewBranch.py ____________________________________________________________________________
# File generated automatically by ATOM3. Graph Grammar Rule
# ___________________________________________________________________________________________
from GGrule import *
from Function import *
from ASG_GPSSMetaModel import *
from SNAVariable import *
from Table import *
from connected_to import *
from Storage_Size import *
from GPSSBlock import *
class startNewBranch (GGrule):

   def __init__(self, parent):
      GGrule.__init__(self, 5)
      self.LHS = ASG_GPSSMetaModel(parent)

      self.obj105=GPSSBlock(parent)

      self.obj105.A.setValue('')
      self.obj105.C.setValue('')
      self.obj105.B.setValue('')
      self.obj105.E.setValue('')
      self.obj105.D.setValue('')
      self.obj105.F.setValue('')
      self.obj105.X.setValue('')
      self.obj105.Type.setNone()
      self.obj105.Type.config = 0
      self.obj105.Comments.setValue('')
      self.obj105.Label.setValue('')
      self.obj105.GGLabel.setValue(1)
      self.obj105.graphClass_= graph_GPSSBlock
      if parent.genGraphics:
         from graph_GPSSBlock import *
         new_obj = graph_GPSSBlock(93.0,124.0,self.obj105)
      else: new_obj = None
      self.obj105.graphObject_ = new_obj
      self.LHS.addNode(self.obj105)

      self.obj106=GPSSBlock(parent)

      self.obj106.A.setValue('')
      self.obj106.C.setValue('')
      self.obj106.B.setValue('')
      self.obj106.E.setValue('')
      self.obj106.D.setValue('')
      self.obj106.F.setValue('')
      self.obj106.X.setValue('')
      self.obj106.Type.setNone()
      self.obj106.Type.config = 0
      self.obj106.Comments.setValue('')
      self.obj106.Label.setValue('')
      self.obj106.GGLabel.setValue(3)
      self.obj106.graphClass_= graph_GPSSBlock
      if parent.genGraphics:
         from graph_GPSSBlock import *
         new_obj = graph_GPSSBlock(92.0,305.0,self.obj106)
      else: new_obj = None
      self.obj106.graphObject_ = new_obj
      self.LHS.addNode(self.obj106)

      self.obj107=connected_to(parent)

      self.obj107.GGLabel.setValue(2)
      self.obj107.graphClass_= graph_connected_to
      if parent.genGraphics:
         from graph_connected_to import *
         new_obj = graph_connected_to(93.0,215.0,self.obj107)
      else: new_obj = None
      self.obj107.graphObject_ = new_obj
      self.LHS.addNode(self.obj107)
      self.obj105.out_connections_.append(self.obj107)
      self.obj107.in_connections_.append(self.obj105)
      self.obj107.out_connections_.append(self.obj106)
      self.obj106.in_connections_.append(self.obj107)
      self.RHS = ASG_GPSSMetaModel(parent)

      self.obj109=GPSSBlock(parent)

      self.obj109.A.setValue('')
      self.obj109.C.setValue('')
      self.obj109.B.setValue('')
      self.obj109.E.setValue('')
      self.obj109.D.setValue('')
      self.obj109.F.setValue('')
      self.obj109.X.setValue('')
      self.obj109.Type.setValue( (['Advance', 'Assign', 'Depart', 'Enter', 'Gate', 'Generate', 'Leave', 'Link', 'Logic', 'Mark', 'Priority', 'Queue', 'Release', 'SaveValue', 'Seize', 'Tabulate', 'Terminate', 'Test', 'Transfer', 'Unlink'], 0) )
      self.obj109.Type.config = 0
      self.obj109.Comments.setValue('')
      self.obj109.Label.setValue('L0')
      self.obj109.GGLabel.setValue(1)
      self.obj109.graphClass_= graph_GPSSBlock
      if parent.genGraphics:
         from graph_GPSSBlock import *
         new_obj = graph_GPSSBlock(102.0,109.0,self.obj109)
      else: new_obj = None
      self.obj109.graphObject_ = new_obj
      self.obj1090= AttrCalc()
      self.obj1090.Copy=ATOM3Boolean()
      self.obj1090.Copy.setValue(('Copy from LHS', 1))
      self.obj1090.Copy.config = 0
      self.obj1090.Specify=ATOM3Constraint()
      self.obj1090.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj109.GGset2Any['A']= self.obj1090
      self.obj1091= AttrCalc()
      self.obj1091.Copy=ATOM3Boolean()
      self.obj1091.Copy.setValue(('Copy from LHS', 1))
      self.obj1091.Copy.config = 0
      self.obj1091.Specify=ATOM3Constraint()
      self.obj1091.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj109.GGset2Any['C']= self.obj1091
      self.obj1092= AttrCalc()
      self.obj1092.Copy=ATOM3Boolean()
      self.obj1092.Copy.setValue(('Copy from LHS', 1))
      self.obj1092.Copy.config = 0
      self.obj1092.Specify=ATOM3Constraint()
      self.obj1092.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj109.GGset2Any['B']= self.obj1092
      self.obj1093= AttrCalc()
      self.obj1093.Copy=ATOM3Boolean()
      self.obj1093.Copy.setValue(('Copy from LHS', 1))
      self.obj1093.Copy.config = 0
      self.obj1093.Specify=ATOM3Constraint()
      self.obj1093.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj109.GGset2Any['E']= self.obj1093
      self.obj1094= AttrCalc()
      self.obj1094.Copy=ATOM3Boolean()
      self.obj1094.Copy.setValue(('Copy from LHS', 1))
      self.obj1094.Copy.config = 0
      self.obj1094.Specify=ATOM3Constraint()
      self.obj1094.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj109.GGset2Any['D']= self.obj1094
      self.obj1095= AttrCalc()
      self.obj1095.Copy=ATOM3Boolean()
      self.obj1095.Copy.setValue(('Copy from LHS', 1))
      self.obj1095.Copy.config = 0
      self.obj1095.Specify=ATOM3Constraint()
      self.obj1095.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj109.GGset2Any['F']= self.obj1095
      self.obj1096= AttrCalc()
      self.obj1096.Copy=ATOM3Boolean()
      self.obj1096.Copy.setValue(('Copy from LHS', 1))
      self.obj1096.Copy.config = 0
      self.obj1096.Specify=ATOM3Constraint()
      self.obj1096.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj109.GGset2Any['X']= self.obj1096
      self.obj1097= AttrCalc()
      self.obj1097.Copy=ATOM3Boolean()
      self.obj1097.Copy.setValue(('Copy from LHS', 1))
      self.obj1097.Copy.config = 0
      self.obj1097.Specify=ATOM3Constraint()
      self.obj1097.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj109.GGset2Any['Type']= self.obj1097
      self.obj1098= AttrCalc()
      self.obj1098.Copy=ATOM3Boolean()
      self.obj1098.Copy.setValue(('Copy from LHS', 1))
      self.obj1098.Copy.config = 0
      self.obj1098.Specify=ATOM3Constraint()
      self.obj1098.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj109.GGset2Any['Comments']= self.obj1098
      self.obj1099= AttrCalc()
      self.obj1099.Copy=ATOM3Boolean()
      self.obj1099.Copy.setValue(('Copy from LHS', 1))
      self.obj1099.Copy.config = 0
      self.obj1099.Specify=ATOM3Constraint()
      self.obj1099.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj109.GGset2Any['Label']= self.obj1099
      self.RHS.addNode(self.obj109)

      self.obj110=GPSSBlock(parent)

      self.obj110.A.setValue('')
      self.obj110.C.setValue('')
      self.obj110.B.setValue('')
      self.obj110.E.setValue('')
      self.obj110.D.setValue('')
      self.obj110.F.setValue('')
      self.obj110.X.setValue('')
      self.obj110.Type.setValue( (['Advance', 'Assign', 'Depart', 'Enter', 'Gate', 'Generate', 'Leave', 'Link', 'Logic', 'Mark', 'Priority', 'Queue', 'Release', 'SaveValue', 'Seize', 'Tabulate', 'Terminate', 'Test', 'Transfer', 'Unlink'], 0) )
      self.obj110.Type.config = 0
      self.obj110.Comments.setValue('')
      self.obj110.Label.setValue('L1')
      self.obj110.GGLabel.setValue(3)
      self.obj110.graphClass_= graph_GPSSBlock
      if parent.genGraphics:
         from graph_GPSSBlock import *
         new_obj = graph_GPSSBlock(100.0,332.0,self.obj110)
      else: new_obj = None
      self.obj110.graphObject_ = new_obj
      self.obj1100= AttrCalc()
      self.obj1100.Copy=ATOM3Boolean()
      self.obj1100.Copy.setValue(('Copy from LHS', 1))
      self.obj1100.Copy.config = 0
      self.obj1100.Specify=ATOM3Constraint()
      self.obj1100.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj110.GGset2Any['A']= self.obj1100
      self.obj1101= AttrCalc()
      self.obj1101.Copy=ATOM3Boolean()
      self.obj1101.Copy.setValue(('Copy from LHS', 1))
      self.obj1101.Copy.config = 0
      self.obj1101.Specify=ATOM3Constraint()
      self.obj1101.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj110.GGset2Any['C']= self.obj1101
      self.obj1102= AttrCalc()
      self.obj1102.Copy=ATOM3Boolean()
      self.obj1102.Copy.setValue(('Copy from LHS', 1))
      self.obj1102.Copy.config = 0
      self.obj1102.Specify=ATOM3Constraint()
      self.obj1102.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj110.GGset2Any['B']= self.obj1102
      self.obj1103= AttrCalc()
      self.obj1103.Copy=ATOM3Boolean()
      self.obj1103.Copy.setValue(('Copy from LHS', 1))
      self.obj1103.Copy.config = 0
      self.obj1103.Specify=ATOM3Constraint()
      self.obj1103.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj110.GGset2Any['E']= self.obj1103
      self.obj1104= AttrCalc()
      self.obj1104.Copy=ATOM3Boolean()
      self.obj1104.Copy.setValue(('Copy from LHS', 1))
      self.obj1104.Copy.config = 0
      self.obj1104.Specify=ATOM3Constraint()
      self.obj1104.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj110.GGset2Any['D']= self.obj1104
      self.obj1105= AttrCalc()
      self.obj1105.Copy=ATOM3Boolean()
      self.obj1105.Copy.setValue(('Copy from LHS', 1))
      self.obj1105.Copy.config = 0
      self.obj1105.Specify=ATOM3Constraint()
      self.obj1105.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj110.GGset2Any['F']= self.obj1105
      self.obj1106= AttrCalc()
      self.obj1106.Copy=ATOM3Boolean()
      self.obj1106.Copy.setValue(('Copy from LHS', 1))
      self.obj1106.Copy.config = 0
      self.obj1106.Specify=ATOM3Constraint()
      self.obj1106.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj110.GGset2Any['X']= self.obj1106
      self.obj1107= AttrCalc()
      self.obj1107.Copy=ATOM3Boolean()
      self.obj1107.Copy.setValue(('Copy from LHS', 1))
      self.obj1107.Copy.config = 0
      self.obj1107.Specify=ATOM3Constraint()
      self.obj1107.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj110.GGset2Any['Type']= self.obj1107
      self.obj1108= AttrCalc()
      self.obj1108.Copy=ATOM3Boolean()
      self.obj1108.Copy.setValue(('Copy from LHS', 1))
      self.obj1108.Copy.config = 0
      self.obj1108.Specify=ATOM3Constraint()
      self.obj1108.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj110.GGset2Any['Comments']= self.obj1108
      self.obj1109= AttrCalc()
      self.obj1109.Copy=ATOM3Boolean()
      self.obj1109.Copy.setValue(('Copy from LHS', 1))
      self.obj1109.Copy.config = 0
      self.obj1109.Specify=ATOM3Constraint()
      self.obj1109.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj110.GGset2Any['Label']= self.obj1109
      self.RHS.addNode(self.obj110)

      self.obj111=connected_to(parent)

      self.obj111.GGLabel.setValue(2)
      self.obj111.graphClass_= graph_connected_to
      if parent.genGraphics:
         from graph_connected_to import *
         new_obj = graph_connected_to(101.0,221.0,self.obj111)
      else: new_obj = None
      self.obj111.graphObject_ = new_obj
      self.RHS.addNode(self.obj111)
      self.obj109.out_connections_.append(self.obj111)
      self.obj111.in_connections_.append(self.obj109)
      self.obj111.out_connections_.append(self.obj110)
      self.obj110.in_connections_.append(self.obj111)
   def condition(self, graphID, isograph, atom3i):
      node=self.getMatched(graphID, self.LHS.nodeWithLabel(1))
      child=self.getMatched(graphID, self.LHS.nodeWithLabel(3))
      return node.visited == 1 and node.current == 0 and child.visited == 0 and child.current == 0
      
      
      

   def action(self, graphID, isograph, atom3i):
      child=self.getMatched(graphID, self.LHS.nodeWithLabel(3))
      child.current = 1
      
      

